<?php
/**
 * ModulVerwaltungPlugin.class.php
 *
 * lange Beschreibung...
 * Diese Datei enthlt die Hauptklasse des Plugins
 *
 * PHP version 5
 *
 * @author  	Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @author		Jan-Hendrik willms <tleilax@mindfuck.de>
 * @package 	IBIT_ModulVerwaltungPlugin
 * @copyright 	2008,2009 IBIT
 * @license 	http://www.gnu.org/licenses/gpl.html GPL Licence 3
 * @version 	0.9.9.11
 */

// IMPORTS
require_once 'bootstrap.inc.php';

/**
 * Enter description here...
 *
 */
class ModulVerwaltungPlugin extends AbstractStudIPSystemPlugin
{
	/**
	 * Objekt der Templateklasse
	 *
	 * @var unknown_type
	 */
	public $template_factory;

	/**
	 * Reiter in Studip fr M-Admins
	 *
	 * @var array()
	 */
	private $mtabs = array(
		'show'=>'Veranstaltungen verwalten',
		'copyModules'=>'Module kopieren',
		'adminModules'=>'Module verwalten',
		'modulHandbuch'=>'Modulhandbuch',
		'LVPShow'=>'berschneidung',
	);

	/**
	 * Reiter in Studip fr V-Admins
	 *
	 * @var array()
	 */
	private $vtabs = array(
		'show'=>'Veranstaltungen verwalten',
		'LVPShow'=>'berschneidung',
	);

	/**
	 * Reiter in Studip fr ROOT
	 *
	 * @var array()
	 */
	private $roottabs = array(
		'show'=>'Veranstaltungen verwalten',
		'copyModules'=>'Module kopieren',
		'adminModules'=>'Module verwalten',
		'modulHandbuch'=>'Modulhandbuch',
		'LVPShow'=>'berschneidung',
		'listAdmins'=>'M-/V-Adminstratoren'
	);

	private $handbuchtabs = array(
		'modulHandbuchShow'=>'Modulhandbuch anzeigen',
		'modulHandbuchAdmin'=>'Modulhandbuch verwalten'
	);

	private $veranstaltungentabs = array(
		'copyCourses'=>'Veranstaltungen kopieren',
		'listCourses'=>'Veranstaltungsbericht erzeugen'
	);

	private $action_lookup = array(
		'CalendarDown' => 'LVPShow',
		'CalendarRedirectRaumzeit' => 'LVPShow',
		'CalendarSendMessage' => 'LVPShow',
		'CalendarGoTo' => 'LVPShow',
		'CalendarPreviousConflict' => 'LVPShow',
		'CalendarNextConflict' => 'LVPShow',
		'CalendarDown' => 'LVPShow',
		'CalendarUp' => 'LVPShow',
		'CalendarPrevious' => 'LVPShow',
		'CalendarNext' => 'LVPShow',
		'CalendarShowSingleCourse' => 'LVPShow',
		'CalendarShowModule' => 'LVPShow',
		'CalendarShowFoS' => 'LVPShow',
		'OverviewReset' => 'LVPShow',
		'OverviewNew' => 'LVPShow',
		'OverviewRefresh' => 'LVPShow',
		'OverviewToggleVisibility' => 'LVPShow',
		'OverviewToggleIgnore' => 'LVPShow',
		'OverviewNotifyClose' => 'LVPShow',
		'OverviewNotifyOpen' => 'LVPShow',
		'OverviewGetPbConflicts' => 'LVPShow',
		'OverviewGetConflicts' => 'LVPShow',
		'OverviewSendMessage' => 'LVPShow',
		'OverviewGetMessages' => 'LVPShow',
		'OverviewGetNote' => 'LVPShow',
		'OverviewDeleteNote' => 'LVPShow',
		'OverviewUpdateNote' => 'LVPShow',
		'OverviewEditNote' => 'LVPShow',
		'OverviewGetElement' => 'LVPShow',
		'OverviewChangeFoS' => 'LVPShow',
		'ShowCalendar' => 'LVPShow',
		'ShowOverview' => 'LVPShow',
	);

	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $user;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	public $permissions;
	/**
	 * Enter description here...
	 *
	 * @var unknown_type
	 */
	private $roles;
	/**
	 * Enter description here...
	 *
	 * @var string
	 */
	public $path;


	private $view;
	private $display_title;

	/**
	 * Konstruktor
	 *
	 * @return ModulVerwaltungPlugin
	 */
	public function __construct()
	{
		parent::AbstractStudIPSystemPlugin();
		$this->user = $this->getUser();
		$this->permissions = $this->user->getPermission();
		$this->roles = $this->getRoles();
		$this->buildMenu();
		$this->path = $GLOBALS['ABSOLUTE_URI_STUDIP'].str_replace($GLOBALS['ABSOLUTE_PATH_STUDIP'], '', dirname(__FILE__));
		$this->setPluginiconname('img/page_edit.png');
		$this->template_factory = new Flexi_TemplateFactory(dirname(__FILE__).'/templates');
	}

	/**
	 * ldt beim aufrufen zustzliche infos in den html-header...
	 *
	 */
	public function initialize()
	{
		$this->view = LVPPluginView::GetView('Overview', $this);
		$this->display_title = _("berschneidung - bersicht");

		$GLOBALS['_include_additional_header'] .= '<link href="'.$this->path.'/optimizer.php?studienmodulmanagement.css,modulverwaltung.css,LVPPlugin.css" type="text/css" rel="stylesheet" />'."\n";
		$GLOBALS['_include_additional_header'] .= '<script src="'.$this->path.'/optimizer.php?cookiejar.js,accordion.js,modulverwaltung.js,lvpplugin.js" type="text/javascript"></script>'."\n";
	}

	/**
	 * Gibt den Namen des Plugins zurck
	 *
	 * @return Pluginame
	 */
	public function getPluginname()
	{
		return _('ModulVerwaltungPlugin');
	}

	/**
	 * Zeigt das Plugin als Unterpunkt in der Navigation an, je nach V- oder M-Admin
	 * ist der Titel auch anders.
	 *
	 */
	public function buildMenu()
	{
		if($this->roles['m_admin'] || $this->permissions->hasRootPermission())
		{
			$tab = new PluginNavigation();
			$tab->setDisplayname(_('Modul-Verwaltung'));
			$this->setNavigation($tab);
		}
		elseif ($this->permissions->hasAdminPermission() && !$this->roles['m_admin'])
		{
			$tab = new PluginNavigation();
			$tab->setDisplayname(_('LV-Verwaltung'));
			$this->setNavigation($tab);
		}
	}

	/**
	 * Zeigt die passenden Reiter an, und berprft die Rechte und das Login,
	 * da dieser Teil als erstes einer Seite geladen wird.
	 *
	 */
	private function displayHeader()
	{
		//Login berprfen
		//kann raus (rolle nobody entfernen)... $this->checkLogin();

		//passende Tabs laden
		if ($this->permissions->hasAdminPermission() && !$this->roles['m_admin'])
		{
			$tabs = $this->vtabs;
		}
		elseif ($this->roles['m_admin'] && !$this->permissions->hasRootPermission())
		{
			$tabs = $this->mtabs;
		}
		elseif($this->permissions->hasRootPermission())
		{
			$tabs = $this->roottabs;
		}

		//aktiven Reiter ermitteln
		$command = !empty($_REQUEST['cmd']) ? $_REQUEST['cmd'] : array_shift(explode('?', $GLOBALS['unconsumed'].'?'));

		$this->parameters = array();

		if (isset($_REQUEST['back']))
		{
			list($l, $f, $a) = explode('|', $_REQUEST['back']);
			$this->parameters['lehreinheit'] = $l;
			$this->parameters['fach'] = $f;
			$this->parameters['abschluss'] = $a;
		}

		if (!empty($_REQUEST['lehreinheit'])) $this->parameters['lehreinheit'] = $_REQUEST['lehreinheit'];
		if (!empty($_REQUEST['fach'])) $this->parameters['fach'] = $_REQUEST['fach'];
		if (!empty($_REQUEST['abschluss'])) $this->parameters['abschluss'] = $_REQUEST['abschluss'];
		if (!empty($_REQUEST['semester'])) $this->parameters['semester'] = $_REQUEST['semester'];
		elseif (!empty($_REQUEST['back']))
		{
			list($l, $f, $a, $s) = explode('|', $_REQUEST['back']);
			$this->parameters['semester'] = $s;
		}

		// Reiter erzeugen
		$structure = array();
		foreach ($tabs as $cmd=>$title)
		{
			$structure[$cmd] = array(
				'topKat'=>'',
				'name'=>_($title),
				'link'=>PluginEngine::getLink($this, $this->parameters, $cmd),
				'active'=>($cmd==$command) or (in_array($command, array_keys($this->action_lookup)) and $this->action_lookup[$command]==$cmd)
			);
		}

		// Subreiter fr Modulhandbuch erzeugen
		foreach ($this->handbuchtabs as $cmd=>$title)
		{
			$structure[$cmd] = array(
				'topKat'=>'modulHandbuch',
				'name'=>_($title),
				'link'=>PluginEngine::getLink($this, $this->parameters, $cmd),
				'active'=>($cmd==$command)
			);
		}
		// Subreiter fr Veranstaltungen erzeugen
		foreach ($this->veranstaltungentabs as $cmd=>$title)
		{
			$structure[$cmd] = array(
				'topKat'=>'show',
				'name'=>_($title),
				'link'=>PluginEngine::getLink($this, $this->parameters, $cmd),
				'active'=>($cmd==$command)
			);
		}
		// Subreiter fr Modulverwaltung erzeugen
		$tab = !empty($_REQUEST['ma_tab']) ? $_REQUEST['ma_tab'] : null;

		foreach (ModuleAdministration::$tabs as $cmd=>$title)
		{
			$structure[$cmd] = array(
				'topKat'=>'adminModules',
				'name'=>_($title),
				'link'=>PluginEngine::getLink($this, array_merge(array('ma_tab'=>$cmd), $this->parameters), 'adminModules'),
				'active'=>($cmd==$tab)
			);
		}

		//Reiter anzeigen
		if (!empty($tab))
		{
			$command .= '('.$tab.')';
		}

		$reiter = new reiter;
		$reiter->create($structure, $command);
		echo '<br/>';
	}

	/**
	 * berprft, ob der Benutzer eingelogt ist. Falls das nicht der Fall ist,
	 * wird eine Fehlermeldung ausgegeben und die Abarbeitung beendet.
	 *
	 */
	/* veraltet... private function checkLogin()
	{
		// Login prfen
		if (!isset($_SESSION['auth']) or !is_object($_SESSION['auth']) or !isset($_SESSION['auth']->auth) or !isset($_SESSION['auth']->auth['uid']) or ($_SESSION['auth']->auth['uid']=='nobody'))
		{
			StudIPTemplateEngine::showErrorMessage('Sie m�ssen eingeloggt sein, um dieses Plugin aufrufen zu d�rfen');
			die;
		}
	}*/

	/**
	 * berprft, ob der Benutzer V-Admin, oder M-Admin ist
	 *
	 * @return array
	 */
	private function getRoles()
	{
		$roleperm = array();
		$roles = $this->user->getAssignedRoles();
		// Benutzer ist Admin
		//TODO: das hier anpassen und so.
		if($this->permissions->hasAdminPermission() && !$this->permissions->hasRootPermission())
		{
			foreach ($roles as $role)
			{
				if ($role->rolename == 'V-Admin')
				{
					$roleperm['v_admin'] = true;
				}
				elseif($role->rolename == 'M-Admin')
				{
					$roleperm['m_admin'] = true;
				}
			}
		}
		//Root darf alles!
		elseif($this->permissions->hasRootPermission())
		{
			$roleperm['m_admin'] = true;
			$roleperm['v_admin'] = true;
		}
		return $roleperm;
	}

	/**
	 * Zeigt den Auswahlbereich mit 3 Spalten an.
	 *
	 */
	public function showCourseSelectArea()
	{
		$semObject = new SemesterData;
		$template = $this->template_factory->open('course_select');
		$lehreinheiten = ModulVerwaltungDB::getLehreinheiten($this->user->userid, $this->permissions->hasRootPermission());

		//Lehreinheit ausgewhlt
		if(!empty($_REQUEST['lehreinheit']) && in_array($_REQUEST['lehreinheit'], array_keys($lehreinheiten)))
		{
			$current_lehreinheit = trim($_REQUEST['lehreinheit']);
			$template->set_attribute('current_lehreinheit', $current_lehreinheit);
			$faecher = ModulVerwaltungDB::getFaecher($current_lehreinheit);
			$template->set_attribute('faecher', $faecher);
			$_SESSION['modulverwaltungsplugin']['current_lehreinheit'] = $current_lehreinheit;
		}
		//Fach ausgewhlt
		if(!empty($_REQUEST['fach']) && isset($faecher) && in_array($_REQUEST['fach'], array_keys($faecher)))
		{
			$current_fach = trim($_REQUEST['fach']);
			$template->set_attribute('current_fach', $current_fach);
			if($_SESSION['modulverwaltungsplugin']['current_lehreinheit'] == $current_lehreinheit)
			{
				$abschluesse  =ModulVerwaltungDB::getAbschluesseAndModule($current_fach);
				$template->set_attribute('abschluesse', $abschluesse);
			}
			$template->set_attribute('show_button', true);
		}
		//Fach ausgewhlt
		if(!empty($_REQUEST['abschluss']) && isset($abschluesse))
		{
			$current_abschluss = trim($_REQUEST['abschluss']);
			$template->set_attribute('current_abschluss', $current_abschluss);
		}

		//Semesterauswahl
		if(!empty($_REQUEST['semester']) && $_REQUEST['action'] != 'copy')
		{
			$current_semester = $_REQUEST['semester'];
		}
		else
		{
			$sem = $semObject->getCurrentSemesterData();
			$current_semester = $sem['semester_id'];
		}

		//Ausgabe
		$template->set_attribute('semester', $semObject->getAllSemesterData());
		$template->set_attribute('current_semester', $current_semester);
		$template->set_attribute('lehreinheiten', $lehreinheiten);
		echo $template->render();

	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $show_semesters
	 * @param unknown_type $action
	 * @param unknown_type $include_prof
	 * @param unknown_type $include_foreign_modules
	 * @return unknown
	 */
	public function showModulesSelectArea($show_semesters = true, $action = '', $include_prof = false, $include_foreign_modules = false)
	{
		$__complete = false;

		$lehreinheiten = ModulVerwaltungDB::getLehreinheiten($this->user->userid, $this->permissions->hasRootPermission(), $include_prof);

		$is_foreign = false;
		$foreign_lehreinheiten = array();
		if ($include_foreign_modules )
		{
			$foreign_lehreinheiten = ModuleDB::GetLehreinheitenForForeignModules($this->user->userid);
			$is_foreign = (!empty($_REQUEST['lehreinheit']) and isset($foreign_lehreinheiten[ $_REQUEST['lehreinheit'] ]) and !isset($lehreinheiten[ $_REQUEST['lehreinheit'] ]));
		}

		$semObject = new SemesterData;
		$template = $this->template_factory->open('module_select');

		$lehreinheiten = ModulVerwaltungDB::getLehreinheiten($this->user->userid, $this->permissions->hasRootPermission(), $include_prof);

		//Lehreinheit ausgewhlt
		if(!empty($_REQUEST['lehreinheit']) and $_REQUEST['lehreinheit']{0}!='x' and in_array($_REQUEST['lehreinheit'], array_keys(array_merge($lehreinheiten, $foreign_lehreinheiten))))
		{
			$current_lehreinheit = trim($_REQUEST['lehreinheit']);
			$template->set_attribute('current_lehreinheit', $current_lehreinheit);
			$_SESSION['modulverwaltungsplugin']['current_lehreinheit'] = $current_lehreinheit;

			$faecher = $is_foreign
				? ModuleDB::GetFaecherForForeignLehreinheit($this->user->userid, $current_lehreinheit)
				: ModulVerwaltungDB::getFaecher($current_lehreinheit);

			$template->set_attribute('faecher', $faecher);
		}
		//Fach ausgewhlt
		if (!empty($_REQUEST['fach']) and isset($faecher) and in_array($_REQUEST['fach'], array_keys($faecher)))
		{
			$current_fach = trim($_REQUEST['fach']);
			$template->set_attribute('current_fach', $current_fach);

			$abschluesse = $is_foreign
				? ModuleDB::GetAbschluesseForForeignFach($this->user->userid, $current_fach)
				: ModulVerwaltungDB::getAbschluesse($current_fach);

			if($_SESSION['modulverwaltungsplugin']['current_lehreinheit'] == $current_lehreinheit)
			{
				$template->set_attribute('abschluesse', $abschluesse);
			}
			$template->set_attribute('show_button', true);
		}
		//Fach ausgewhlt
		if (!empty($_REQUEST['abschluss']) and isset($abschluesse) and in_array($_REQUEST['abschluss'], array_keys($abschluesse)))
		{
			$current_abschluss = trim($_REQUEST['abschluss']);
			$template->set_attribute('current_abschluss', $current_abschluss);

			$__complete = true;
		}

		//Semesterauswahl
		if(!empty($_REQUEST['semester']))
		{
			$current_semester = $_REQUEST['semester'];
		}
		else
		{
			$sem = $semObject->getCurrentSemesterData();
			$current_semester = $sem['semester_id'];
		}

		//Ausgabe
		if (!empty($action))
		{
			$template->set_attribute('action', $action);
		}
		$template->set_attribute('show_semesters', $show_semesters);
		$template->set_attribute('semester', $semObject->getAllSemesterData());
		$template->set_attribute('current_semester', $current_semester);
		$template->set_attribute('lehreinheiten', $lehreinheiten);

		if ($include_foreign_modules)
		{
			$template->set_attribute('foreign_lehreinheiten', $foreign_lehreinheiten);
		}

		echo $template->render();
		return $__complete;
	}

	/**
	 * Zeigt die 3 Spaltenauswahl fr Handbcher an und gibt zurck, ob alle 3 Bereiche
	 * ausgewhlt sind.
	 *
	 * @return boolean
	 */
	public function showHandbuchSelectArea()
	{

		$template = $this->template_factory->open('handbuch_select');
		$__complete = false;
		$lehreinheiten = ModulVerwaltungDB::getLehreinheiten($this->user->userid, $this->permissions->hasRootPermission(), false);

		//Lehreinheit ausgewhlt
		if(!empty($_REQUEST['lehreinheit']) and $_REQUEST['lehreinheit']{0}!='x' && in_array($_REQUEST['lehreinheit'], array_keys($lehreinheiten)))
		{
			$current_lehreinheit = trim($_REQUEST['lehreinheit']);
			$template->set_attribute('current_lehreinheit', $current_lehreinheit);
			$_SESSION['modulverwaltungsplugin']['current_lehreinheit'] = $current_lehreinheit;

			$faecher = ModulVerwaltungDB::getFaecher($current_lehreinheit);
			$template->set_attribute('faecher', $faecher);
		}
		//Fach ausgewhlt
		if (!empty($_REQUEST['fach']) and isset($faecher) and in_array($_REQUEST['fach'], array_keys($faecher)))
		{
			$current_fach = trim($_REQUEST['fach']);
			$template->set_attribute('current_fach', $current_fach);

			$abschluesse = ModulVerwaltungDB::getAbschluesse($current_fach);

			if($_SESSION['modulverwaltungsplugin']['current_lehreinheit'] == $current_lehreinheit)
			{
				$template->set_attribute('abschluesse', $abschluesse);
			}
			$template->set_attribute('show_button', true);
		}
		//Fach ausgewhlt
		if (!empty($_REQUEST['abschluss']) && (in_array($_REQUEST['abschluss'], array_keys($abschluesse)) || $_REQUEST['abschluss'] == 'all'))
		{
			$current_abschluss = trim($_REQUEST['abschluss']);
			$template->set_attribute('current_abschluss', $current_abschluss);

			$__complete = true;
		}

		//Ausgabe
		$template->set_attribute('lehreinheiten', $lehreinheiten);
		echo $template->render();

		return $__complete;
	}

	/**
	 * Zeigt die ausgewhlten Veranstaltungen an
	 *
	 */
	private function showCourses()
	{
		$semObject = new SemesterData;
		$sem = $semObject->getCurrentSemesterData();
		$current_semester = $sem['semester_id'];

		$template = $this->template_factory->open('course_list');
		$template->set_attribute('semesters', $semObject->getAllSemesterData());
		$template->set_attribute('current_semester', $current_semester);
		$template->set_attribute('current_lehreinheit', trim($_REQUEST['lehreinheit']));
		$template->set_attribute('current_fach',  trim($_REQUEST['fach']));
		$template->set_attribute('current_abschluss', trim($_REQUEST['abschluss']));
		$template->set_attribute('link', PluginEngine::getLink($this, $this->parameters, 'copyCourses'));
		$template->set_attribute('courses', ModulVerwaltungDB::getVeranstaltungen($_REQUEST['semester'], $_REQUEST['lehreinheit'], $_REQUEST['fach'], $_REQUEST['abschluss']));
		echo $template->render();
	}

	/**
	 * Zeigt die ausgewhlten Veranstaltungen an
	 *
	 */
	private function showModules()
	{
		$semObject = new SemesterData;
		$sem = $semObject->getCurrentSemesterData();
		$current_semester = $sem['semester_id'];

		$template = $this->template_factory->open('module_list');
		$template->set_attribute('semester', $semObject->getAllSemesterData());
		$template->set_attribute('current_semester', $current_semester);
		$template->set_attribute('link', PluginEngine::getURL($this, $this->parameters, 'copyModules'));
		$template->set_attribute('modules', ModulVerwaltungDB::getKonModule($_REQUEST['abschluss'], $_REQUEST['semester']));
		echo $template->render();
	}

	/**
	 * Kopiert die ausgewhlten Veranstaltungen
	 * Code vom MultiCopyPlugin Osnabrck!!!
	 *
	 */
	private function copyCourses()
	{
		?>
		<div class="topic"><b>Veranstaltungen kopieren</b></div>
		<?
		// 1. um zu vermeiden, dass Veranstaltungen doppelt kopiert werden
		#echo "Schritt 1...";
		$courses_to_copy = array_unique($_REQUEST['seminar_ids']);
		sort($courses_to_copy);
		#echo " fertig.<br/>";

		// 2. rechte berprfen
		//es duerfen nur Veranstaltungen kopiert werden, in denen der Benutzer admin der Heimateinrichtung ist, root darf alle
		#echo "Schritt 2...";
		if (!$this->permissions->hasRootPermission())
		{
			$tmp_array = ModulVerwaltungDB::checkSeminars($courses_to_copy, $this->user->userid);
			$courses_to_copy = $tmp_array[0]; // zu kopierende Veranstaltungen
			$deny_sem_array = $tmp_array[1]; // nicht zu kopierende Veranstaltungen
		}
		#echo " fertig.<br/>";

		// 3. Daten des neuen Semesters inkl. Startzeit
		#echo "Schritt 3...";
		$semdata = new SemesterData;
		$copy_semester = $semdata->getSemesterData($_REQUEST['semester']);
		#echo " fertig.<br/>";

		//4. Instanz des Uni-Readers, Konstruktor mit Array bestehend aus Seminar_ids
		#echo "Schritt 4...";
	    $u_reader = new UniReader($copy_semester['beginn'], $courses_to_copy);
		#echo "vorher: <pre>";
		#print_r($u_reader);
		#echo "</pre>";
		// alle Seminare werden in den StorageVector gepackt
	    $u_reader->setAllSeminars();
	    #echo "vorher: <pre>";
		#print_r($u_reader);
		#echo "</pre>";
		// Beim kopieren wurden die metadate_ids mit bernommen was zu Uberschneidungen und Problemen fhrte.
	    foreach ($u_reader->storage_vector->storage_array as $key=>$data)
		{
			$md = unserialize($data->seminar['metadata_dates']);
			// nur zeiten und rume kopieren, wenn dies eingestellt wurde
			if($_REQUEST['roomtime'] == 'yes')
			{
				for($i=0; $i < count($md['turnus_data']); $i++)
				{
					$md['turnus_data'][$i]['metadate_id'] = md5(uniqid(rand()));
				}
			}
			// ansonsten rume und zeiten resetten.
			else
			{
				$md['turnus_data'] = array();
			}
			$u_reader->storage_vector->storage_array[$key]->seminar['metadata_dates'] = serialize($md);
		}

		#echo " fertig.<br/>";

		//5. writer
		#echo "Schritt 5... Kopieren... ";
        $u_writer = new UniWriter($copy_semester['beginn'], $u_reader->storage_vector);
 	    #echo "nachher: <pre>";
		#print_r($u_writer);
		#echo "</pre>";
        $u_writer->initWrite();
		#echo " fertig.<br/>";


		//6. Ausgabe
		#echo "Schritt 6... ";
	    $sem_count = count($courses_to_copy);
	    if ($sem_count > 0)
		{
		?>
           <table cellpadding="2" cellspacing="0" width="100%">
            <tr>
				<td width="40">
					<img src=" <?=$GLOBALS['ASSETS_URL']?>images/ok.gif" border="0" />
				</td>
				<td>
					<font color="green"><?=$sem_count ?> Veranstaltung(en) wurde(n) erfolgreich in das <?=$copy_semester["name"]?> kopiert!</font>
				</td>
			</tr>
			</table>
			<table cellpadding="2" cellspacing="0" width="100%">
			<?
            foreach ($u_reader->storage_vector->storage_array as $key=>$val)
            {
                $name = ModulVerwaltungDB::getSeminarName($val->getSeminarId());
                $nummer = ModulVerwaltungDB::getVANummer($val->getSeminarId());
                $log_debug_info .= $nummer."--->".$name.", ";
				?>
			<tr class="<?=($key%2==0)?'steel1':'steelgraulight' ?>">
				<td width="10%">
					<a href="adminarea_start.php?select_sem_id=<?=$val->getSeminarId()?>"><?=$nummer?></a>
				</td>
				<td>
					<a href="adminarea_start.php?select_sem_id=<?=$val->getSeminarId()?>"><?=$name?></a>
				</td>
			</tr>
			<?
            }
        }
        if(count($deny_sem_array)>0)
		{
            ?>
            </table>
            <br/>
            <table cellpadding="2" cellspacing="0" width="100%">
			<tr>
				<td width="40">
					<img src="<?=$GLOBALS['ASSETS_URL']?>images/x.gif" border="0" />
				</td>
				<td>
					<font color="red"><?=count($deny_sem_array)?> Veranstaltung(en) konnte(n) nicht kopiert werden (keine Berechtigung)</font>
				</td>
			</tr>
            </table>
            <table cellpadding="2" cellspacing="0" width="100%">
			<?
			foreach ($deny_sem_array as $key => $val)
			{
                $name = ModulVerwaltungDB::getSeminarName($val);
                $nummer = ModulVerwaltungDB::getVANummer($val);
                $fb_name = ModulVerwaltungDB::getInstitut($val);
			?>
			<tr class="<?=($key%2==0)?'steel1':'steelgraulight' ?>">
				<td width="10%">
					<?=$nummer?>
				</td>
				<td>
					<?=$name?> (<b>Heimateinrichtung: <?=$fb_name?></b>)
				</td>
			</tr>
			<?
            }
        }
		?>
        	<tr>
				<td colspan="2" class="steel2">
					<a href="<?=PluginEngine::getLink($this,$this->parameters,"show")?>"><?=makeButton('zurueck', 'img', 'zurck zur bersicht')?></a>
				</td>
			</tr>
		</table>
		<?

		//7. Logging
		#echo "schritt 7<br/>";
		log_event("SEM_COPY_MULTI",NULL,NULL, $sem_count.' Veranstaltungen erfolgreich in das '.$copy_semester["name"].' kopiert!',$log_debug_info);
		#echo "FERTIG!!!!";
	}

	/**
	 * Kopier konkrete Module von einem ins andere Semester
	 *
	 */
	private function copyModules()
	{
		if(empty($_REQUEST['modul_ids']))
		{
			StudIPTemplateEngine::showErrorMessage("Fehler. Sie haben keine Module zum Kopieren ausgewhlt!");
			$this->showModulesSelectArea();
		}
		else
		{
			// 1. um zu vermeiden, dass Module doppelt kopiert werden
			$modules_to_copy = array_unique($_REQUEST['modul_ids']);
			sort($modules_to_copy);

			// 2. Semester
			$semester = $_REQUEST['semester'];
			$semdata = new SemesterData;
			$copy_semester = $semdata->getSemesterData($_REQUEST['semester']);

			// 3. kopieren...
			$copies = ModulVerwaltungDB::copyModules($modules_to_copy, $semester, $this->user->userid);

			// 4. Logging
			log_event("MOD_COPY_MULTI",NULL,NULL, $copies[0].' Module erfolgreich in das '.$copy_semester["name"].' kopiert!', NULL);

			// 5. Ausgabe
			$msg = "Es wurden <b>".$copies[0]."</b> Module erfolgreich in das ".$copy_semester["name"]." kopiert.";
			if($copies[1] > 0)
			{
				$msg .= "<br><b>".$copies[1]."</b> Module waren bereits vorhanden.";
			}
			StudIPTemplateEngine::showSuccessMessage($msg);
			$this->showModulesSelectArea();
		}
	}

	/**
	 * Redirect fr Pluginstartseite
	 *
	 */
	public function actionshow()
	{
		$this->actioncopyCourses();
	}

	/**
	 * Module kopieren Seite
	 *
	 */
	public function actioncopyModules()
	{
		//Reiter anzeigen
		$this->displayHeader();

		//Abschluss oder Modul ausgewhlt, also Kurse anzeigen
		if($_REQUEST['action'] == 'select')
		{
			//Auswahlbereich anzeigen
			$this->showModulesSelectArea();
			//Veranstaltungen nur anzeigen, wenn abschluss ausgewhlt ist
			if(isset($_REQUEST['abschluss']))
			{
				$this->showModuleCopyWarning();
				$this->showModules();
			}
		}

		//Abschluss oder Modul ausgewhlt, also Kurse anzeigen
		elseif($_REQUEST['action'] == 'copy')
		{
			$this->copyModules();
		}

		//Startansicht
		else
		{
			//Auswahlbereich anzeigen
			$this->showModulesSelectArea();
		}
	}

	/**
	 * Veranstaltungen kopieren Seite
	 *
	 */
	public function actioncopyCourses()
	{
		$_REQUEST['cmd'] = 'show';
		//Reiter anzeigen
		$this->displayHeader();

		//Abschluss oder Modul ausgewhlt, also Kurse anzeigen
		if($_REQUEST['action'] == 'select')
		{
			//Auswahlbereich anzeigen
			$this->showCourseSelectArea();
			//Veranstaltungen nur anzeigen, wenn abschluss ausgewhlt ist
			if(isset($_REQUEST['abschluss']))
			{
				$this->showCourses();
			}
		}

		//Abschluss oder Modul ausgewhlt, also Kurse anzeigen
		elseif($_REQUEST['action'] == 'copy')
		{
			if(empty($_REQUEST['seminar_ids']))
			{
				$this->showCourseSelectArea();
				StudIPTemplateEngine::showErrorMessage('Fehler! Sie haben keine Veranstaltungen zum Kopieren ausgew�hlt.');
				$this->showCourses();
			}
			else
			{
				$this->copyCourses();
			}
		}

		//Startansicht
		else
		{
			//Auswahlbereich anzeigen
			$this->showCourseSelectArea();
		}
	}

	/**
	 * Veranstaltungsbericht Seite
	 *
	 */
	public function actionlistCourses()
	{
		$this->displayHeader();
		#StudIPTemplateEngine::showInfoMessage("In Bearbeitung... Fertigstellung voraussichtlich Juli 2009");

		$semObject = new SemesterData;
		$sem = $semObject->getCurrentSemesterData();
		$current_semester = $sem['semester_id'];

		$template = $this->template_factory->open('vbericht_list');

		//semester ausgewhlt
		if($_REQUEST['action'] == 'selectsemester')
		{
			$current_semester = $_REQUEST['semester'];

			$vb = new Veranstaltungsbericht($this->user->userid, $this->permissions->hasRootPermission());
			$template->set_attribute('vb', $vb);
			$template->set_attribute('lehreinheiten', $vb->getLehreinheiten(true));

			//filter einstellungen in die session
			$filter = array(
				'hiddencourses' => $_REQUEST['hiddencourses'],
				'vdetails' => $_REQUEST['vdetails'],
				'additionalcourses' => $_REQUEST['additionalcourses'],
				'externalcourses' => $_REQUEST['externalcourses'],
				'foreigncourses' => $_REQUEST['foreigncourses'],
				'shorttimes' => $_REQUEST['shorttimes'],
				'sortbysemester' => $_REQUEST['sortbysemester']
			);
			$_SESSION['mvp']['vbericht']['filter'] = $filter;
			$template->set_attribute('filter', $filter);
		}

		//Ausgabe
		$template->set_attribute('semester', $semObject->getAllSemesterData());
		$template->set_attribute('current_semester', $current_semester);
		$template->set_attribute('plugin_url', $this->getPluginURL());
		$template->set_attribute('link1', PluginEngine::getLink($this, $this->parameters, 'listCourses'));
		$template->set_attribute('link2', PluginEngine::getLink($this, array(), 'generateExport'));
		$template->set_attribute('infobox', $this->getInfobox('3'));
		echo $template->render();

	}

	/**
	 * Redirect fr Jans Funktionen
	 *
	 */
	public function actionadminModules()
	{
		//Reiter anzeigen
		$this->displayHeader();

		ModuleAdministration::Engage($this);
	}

	/**
	 * Zeigt eine Liste aller Modulhandbcher an
	 *
	 */
	public function actionmodulHandbuch()
	{
		$this->displayHeader();

		$template = $this->template_factory->open('handbuch_list');
		$template->set_attribute('plugin_url', $this->getPluginURL());
		$template->set_attribute('plugin_link', PluginEngine::getLink($this, array(), 'generateExport'));
		$template->set_attribute('handbuecher', ModulHandbuch::getHandbuecher(ModulVerwaltungDB::getLehreinheiten($this->user->userid, $this->permissions->hasRootPermission())));
		$template->set_attribute('infobox', $this->getInfobox('1'));
		echo $template->render();
	}

	/**
	 * Zeigt eine Liste aller Modulhandbcher an
	 *
	 */
	public function actionmodulHandbuchShow()
	{
		$this->actionmodulHandbuch();
	}

	/**
	 * Bietet Funktionen zum verwalten von Modulhandbchern an
	 *
	 */
	public function actionmodulHandbuchAdmin()
	{
		$this->displayHeader();
		$complete = $this->showHandbuchSelectArea();

		if($_REQUEST['action'] == 'change')
		{
			ModulHandbuch::setHandbuch($_REQUEST, $this->user->userid);
			StudIPTemplateEngine::showSuccessMessage("Die nderungen wurden erfolgreich gespeichert.");
		}

		if(isset($_REQUEST['abschluss']) && $complete)
		{
			$template = $this->template_factory->open('handbuch_admin');

			$template->set_attribute('konmod', ModulHandbuch::getHandbuchAndModules($_REQUEST['fach'], $_REQUEST['abschluss']));
			$template->set_attribute('lehreinheit', trim($_REQUEST['lehreinheit']));
			$template->set_attribute('fach', trim($_REQUEST['fach']));
			$template->set_attribute('abschluss', trim($_REQUEST['abschluss']));
			$template->set_attribute('link', PluginEngine::getLink($this, array(), 'modulHandbuchAdmin'));
			$template->set_attribute('path', $this->path);
			$template->set_attribute('infobox', $this->getInfobox('2'));
			echo $template->render();
		}
	}

	/**
	 * RTF-Export-Funktion...
	 *
	 */
	public function actiongenerateExport()
	{
		//Ausgabe
		ob_end_clean();
		ob_start();

		header("Window-target: _blank");
		header('Content-Type: application/'.$_REQUEST['type']);
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');

		// Modulhandbuch
		if($_REQUEST['file'] == 'uebersicht')
		{
			$handbuch = ModulHandbuch::getHandbuch(trim($_REQUEST['id']));
			foreach ($handbuch['module'] as $key=>$modul)
			{
				$handbuch['module'][$key]['complete'] = ModuleDB::LoadConcrete($modul['modul_kon_id']);
				$handbuch['module'][$key]['seminars'] = ModuleDB::GetSeminarDataForKonModule($modul['modul_kon_id']);
			}

			header("Content-Disposition: attachment; filename=moduluebersicht_".$_REQUEST['id'].".rtf");
			$template = $this->template_factory->open('rtf_uebersicht');
			$template->set_attribute('handbuch', $handbuch);
			echo $template->render();
		}
		//Modulkatalog
		elseif($_REQUEST['file'] == 'katalog')
		{
			$handbuch = ModulHandbuch::getHandbuch(trim($_REQUEST['id']));
			foreach ($handbuch['module'] as $key=>$modul)
			{
				$handbuch['module'][$key]['complete'] = ModuleDB::LoadConcrete($modul['modul_kon_id']);
				$handbuch['module'][$key]['seminars'] = ModuleDB::GetSeminarDataForKonModule($modul['modul_kon_id']);
			}

			header("Content-Disposition: attachment; filename=modulkatalog_".$_REQUEST['id'].".rtf");
			$template = $this->template_factory->open('rtf_katalog');
			$template->set_attribute('handbuch', $handbuch);
			echo $template->render();
		}

		// Veranstaltungsbericht
		elseif($_REQUEST['file'] == 'verzeichnis')
		{
			$vb = new Veranstaltungsbericht($this->user->userid, $this->permissions->hasRootPermission(), $_REQUEST['semester']);
			$complete = $vb->getCompleteTree($_REQUEST['topid'], $_SESSION['mvp']['vbericht']['filter'], true);

			#echo "Complete: <pre>";
			#print_r($complete);
			#echo "</pre>";
			#die;

			header("Content-Disposition: attachment; filename=veranstaltungsbericht.rtf");
			//Header
			$header = $this->template_factory->open('rtf/veranstaltungsbericht.header.php');
			$document = $header->render();
			//content
			$content = $this->template_factory->open('rtf/veranstaltungsbericht.content.php');
			$semdata = new SemesterData();
			$content->set_attribute('semester', $semdata->getSemesterData($_REQUEST['semester']));
			$content->set_attribute('complete', $complete);
			$content->set_attribute('filter', $_SESSION['mvp']['vbericht']['filter']);
			$document .= $content->render();
			//Footer
			$footer = $this->template_factory->open('rtf/veranstaltungsbericht.footer.php');
			$document .= $footer->render();
			echo $document;
		}
		ob_end_flush();
		die;
	}

	/**
	 * Zeigt eine Liste aller V-/M-Administratoren an
	 *
	 */
	public function actionlistadmins()
	{
		$this->displayHeader();
		$template = $this->template_factory->open('list_admins');
		$template->set_attribute('vadmins', ModulVerwaltungDB::getAllVAdmins());
		$template->set_attribute('madmins', ModulVerwaltungDB::getAllMAdmins());
		echo $template->render();
	}

	/**
	 * Infoboxen...
	 */
	public function getInfoBox($id = '0')
	{
		// Modulhandbuch
		if($id == '1')
		{
	 		$infobox = array(
				array("kategorie" => _("Information:"),
					"eintrag" => array(
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Wenn hier Studiengnge fehlen sollten,
							dann berprfen Sie bitte im Moduldeskriptor die
							Zuordnung der Module zu dem betreffenden Studiengang.'
						),
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Modulbersicht lt. fachspez. Bericht zu Kapitel 2.6.'
						),
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Modulkatalog lt. fachspez. Bericht zu den Anlagen II.'
						)
					)
				)
	 		);
		}
		if($id == '2')
		{
	 		$infobox = array(
				array("kategorie" => _("Information:"),
					"eintrag" => array(
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Wenn hier Module fehlen sollten, dann berprfen Sie bitte im
							Moduldeskriptor die Zuordnung der Module zu diesem Studiengang. Magebend
							dafr ist das <b>spteste</b> Semester, in dem das Modul in der <b>Rubrikenhierarchie</b>
							aufgefhrt ist.'
						),
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Die aufgefhrten Module mssen genau den aktuellsten (Entwrfen der)
							fachspezifischen Anlagen zur Prfungsordnung entsprechen (plus Praxismodul/e und
							Arbeitsabschlussmodul).'
						)
					)
				),
				array("kategorie" => _("Hinweise:"),
					"eintrag" => array(
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Wenn ein Modul durchgestrichen ist, dann
							gibt es zu diesem noch keine konkreten Informationen.'
						),
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/table_refresh.png',
							"text" => 'Mit diesem Symbol knnen Sie alle nicht ausgewhlten Module
							des Handbuchs ein und ausblenden.'
						)
					)
				)
	 		);
		}
		if($id == '3')
		{
	 		$infobox = array(
				array("kategorie" => _("Information:"),
					"eintrag" => array(
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Whlen Sie das Semester aus und klicken Sie auf <b>auswhlen</b>.
							Sie erhalten dann eine bersicht der Veranstaltungen je Fach.'
						),
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Sie knnen den Inhalt des Veranstaltungsberichts anpassen. Whlen
							Sie dazu die Optionen aus, die in dem Bericht mit angezeigt werden sollen und
							klicken Sie erneut auf <b>auswhlen</b>.'
						),
						array(
							"icon" => '../../'.$this->getPluginpath().'/img/information.png',
							"text" => 'Studienbereiche ohne vorhandene Module werden in dieser
							bersicht nicht angezeigt.'
						)
					)
				)
	 		);
		}
		return $infobox;
	}

	public function showModuleCopyWarning()
	{
		$parameters = array_intersect_key($_REQUEST, array('lehreinheit'=>null, 'fach'=>null, 'abschluss'=>null, 'semester'=>null));

		$template = $this->template_factory->open('module_copy_warning');
		$template->set_attribute('module_link', PluginEngine::GetLink($this, $parameters, 'adminModules'));
		echo $template->render();
	}

#### LVP Plugin
	private function showNavigation () {

		if ($this->hasNavigation()) {
			$nav = $this->getNavigation();
			$structure['plugin_' . $this->getPluginid()] = array(
				'topKat' => '',
				'name' => $nav->getDisplayname(),
				'link' => $nav->getLink(),
				'active' => false
			);

			$structure['_plugin_' . $this->getPluginid() . '_overview'] = array(
				'topKat' => 'plugin_' . $this->getPluginId(),
				'name' => _("bersicht"),
				'link' => PluginEngine::getLink($this, array(),
				'ShowOverview'),
				'active' => false
			);

		//	$structure['_plugin_' . $this->getPluginid() . '_calendar'] = array('topKat' => 'plugin_' . $this->getPluginId(), 'name' => _("Wochenansicht"), 'link' => PluginEngine::getLink($this, array(), 'ShowCalendar'), 'active' => false);

			/*
			$pluginsubmenu["_plugin_" . $this->getPluginId()] = array('topKat' => 'plugin_' . $this->getPluginId(), 'name' => $nav->getDisplayname(), 'link' => PluginEngine::getLink($this, $nav->getLinkParams()), 'active' => false);
			$submenu = $nav->getSubMenu();
			foreach ($submenu as $submenuitem) {
				$pluginsubmenu['plugin_' . $this->getPluginId() . '_' . $submenuitem->getDisplayname()] = array ('topKat' => 'plugin_' . $this->getPluginId(), 'name' => $submenuitem->getDisplayname(), 'link' => $submenuitem->getLink(), 'active' => false);
				foreach ($submenuitem->getLinkParams() as $key => $val) {
					if (isset($_GET[$key]) && $_GET[$key] == $val) {
						$reiter_view = 'plugin_' . $this->getPluginId() . '_' . $submenuitem->getDisplayname();
						break;
					}
			}
			*/

			// ermitteln des aktiven Reiters
			if (strpos('_' . $GLOBALS['unconsumed'], 'Calendar')) {
				$reiter_view = '_plugin_' . $this->getPluginid() . '_calendar';
			} else {
				$reiter_view = '_plugin_' . $this->getPluginid() . '_overview';
			}

		//	$structure = array_merge((array) $structure, (array) $pluginsubmenu);
			$reiter = new reiter();
			$reiter->create($structure, $reiter_view);
		}
	}

	public function actionLVPShow () {
		$this->displayHeader();
//		$this->showNavigation();
		echo $this->view->show();
	}

	public function actionShowOverview () {
		$this->actionLVPShow();
	}

	public function actionShowCalendar () {
		$this->actionLVPShow();
	}

	public function actionOverviewChangeFoS () {
		$this->actionLVPShow();
	}

	public function actionOverviewRedirectRaumzeit () {
		$this->actionLVPShow();
	}

	public function actionOverviewGetElement () {
		$module_id = substr($_REQUEST['module_id'], 0, 32);
		$seminar_id = substr($_REQUEST['seminar_id'], 0, 32);
		$element_id = substr($_REQUEST['element'], 0, 10);
		if ($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] == $element_id) {
			unset($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id]);
		} else {
			$_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] = $element_id;
		}
		switch ($element_id) {
			case 'note' :
				$element = $this->view->getNote($module_id, $seminar_id);
				break;
			case 'messages' :
				$element = $this->view->getMessages($module_id, $seminar_id);
				break;
			case 'conflicts' :
				$element = $this->view->getConflicts($module_id, $seminar_id);
				break;
			default:
				$element = '';
				// throw error
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $element;
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewEditNote () {
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getNote($_REQUEST['module_id'], $_REQUEST['seminar_id'], true);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->view->setEdit($_REQUEST['seminar_id']);
			$this->actionLVPShow();
		}
	}

	public function actionOverviewUpdateNote () {
		if (LVPPluginHelper::InsertNote($_REQUEST['seminar_id'], $_REQUEST['note'])) {
			$this->view->addMsg('msg', _("Die Notiz wurde gendert."), $_REQUEST['seminar_id']);
		} else {
			$this->view->addMsg('error', _("Die Notiz konnte nicht gendert werden."), $_REQUEST['seminar_id']);
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getNote($_REQUEST['module_id'], $_REQUEST['seminar_id']);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewDeleteNote () {
		if (LVPPluginHelper::DeleteNote($_REQUEST['seminar_id'])) {
			$this->view->addMsg('msg', _("Die Notiz wurde gelscht."), $_REQUEST['seminar_id']);
		} else {
			$this->view->addMsg('error', _("Die Notiz konnte nicht gelscht werden."), $_REQUEST['seminar_id']);
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getNote($_REQUEST['module_id'], $_REQUEST['seminar_id']);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewGetNote () {
		$module_id = substr($_REQUEST['module_id'], 0, 32);
		$seminar_id = substr($_REQUEST['seminar_id'], 0, 32);
		if ($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] == 'note') {
			unset($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id]);
		} else {
			$_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] = 'note';
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getNote($module_id, $seminar_id);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewGetMessages () {
		$module_id = substr($_REQUEST['module_id'], 0, 32);
		$seminar_id = substr($_REQUEST['seminar_id'], 0, 32);
		if ($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] == 'messages') {
			unset($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id]);
		} else {
			$_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] = 'messages';
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getMessages($module_id, $seminar_id);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewSendMessage () {
		$error = true;
		if (!isset($_REQUEST['uname']) || !sizeof($_REQUEST['uname'])) {
			$this->view->addMsg('error', _("Bitte whlen Sie einen Empfnger aus."), $_REQUEST['seminar_id']);
		} else if (!trim($_REQUEST['subject'])) {
			$this->view->addMsg('error', _("Bitte geben Sie einen Betreff ein."), $_REQUEST['seminar_id']);
		} else if (!trim($_REQUEST['message'])) {
			$this->view->addMsg('error', _("Bitte geben Sie eine Nachricht ein."), $_REQUEST['seminar_id']);
		} else if (LVPPluginHelper::InsertMessage($_REQUEST['seminar_id'], $_REQUEST['uname'], $_REQUEST['subject'], $_REQUEST['message'])) {
			$this->view->addMsg('msg', _("Die Nachricht wurde verschickt."), $_REQUEST['seminar_id']);
			$error = false;
		} else {
			$this->view->addMsg('error', _("Die Nachricht konnte nicht verschickt werden."), $_REQUEST['seminar_id']);
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getMessages($_REQUEST['module_id'], $_REQUEST['seminar_id'], $error);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->view->setEdit($_REQUEST['seminar_id']);
			$this->actionLVPShow();
		}
	}

	public function actionOverviewGetConflicts () {
		$module_id = substr($_REQUEST['module_id'], 0, 32);
		$seminar_id = substr($_REQUEST['seminar_id'], 0, 32);
		$fach_nr = intval($_REQUEST['fach_nr']);
		if ($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] == 'conflicts' . $fach_nr) {
			unset($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id]);
		} else {
			$_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] = 'conflicts' . $fach_nr;
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getConflicts($module_id, $seminar_id, $fach_nr, $pb);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewGetPbConflicts () {
		$module_id = substr($_REQUEST['module_id'], 0, 32);
		$seminar_id = substr($_REQUEST['seminar_id'], 0, 32);
		if ($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] == 'conflicts_pb') {
			unset($_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id]);
		} else {
			$_SESSION['LVPPlugin']['open_elements'][$module_id . '-' . $seminar_id] = 'conflicts_pb';
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getPbConflicts($module_id, $seminar_id);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewNotifyOpen () {
		list($element_id, $module_seminar_id) = explode('_', $_REQUEST['id']);
		$_SESSION['LVPPlugin']['open_elements'][$module_seminar_id] = $element_id;
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewNotifyClose () {
		list($element_id, $module_seminar_id) = explode('_', $_REQUEST['id']);
		if (isset($_SESSION['LVPPlugin']['open_elements'][$module_seminar_id])) {
			unset($_SESSION['LVPPlugin']['open_elements'][$module_seminar_id]);
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			$element_id = substr($_REQUEST['id'], 0, 80);
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewToggleVisibility () {
		$visible = LVPPluginHelper::ToggleVisibility($_REQUEST['seminar_id']);
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getVisibility($_REQUEST['seminar_id'], $visible);
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewToggleIgnore () {
		$ignored = LVPPluginHelper::GetIgnoredCourses(array($_REQUEST['seminar_id']));
		if (sizeof($ignored)) {
			LVPPluginHelper::DeleteIgnoredCourse($_REQUEST['seminar_id']);
		} else {
			LVPPluginHelper::InsertIgnoredCourse($_REQUEST['seminar_id']);
		}
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
			echo $this->view->getIgnored($_REQUEST['seminar_id'], !isset($ignored[$_REQUEST['seminar_id']]));
			ob_start(create_function('$a', 'return "";'));
		} else {
			$this->actionLVPShow();
		}
	}

	public function actionOverviewRefresh () {
		$this->view->setRefresh();
		$this->actionLVPShow();
	}

	public function actionOverviewNew () {
		if (($_REQUEST['fachsem'] && !$_REQUEST['add_abschluss']) || ($_REQUEST['add_abschluss'] && $_REQUEST['abschluss_2'])) {
			$this->view->setRefresh();
		}
		$this->actionLVPShow();
	}

	public function actionOverviewReset () {
		if (isset($_SESSION['LVPPlugin']['mod_select'])) {
			unset($_SESSION['LVPPlugin']['mod_select']);
		}
		if (isset($_SESSION['LVPPlugin']['mod_select_2'])) {
			unset($_SESSION['LVPPlugin']['mod_select_2']);
		}
		$_SESSION['LVPPlugin']['show_all'] = false;
		$this->actionLVPShow();
	}

	public function actionCalendarShowFoS () {
		$this->actionLVPShow();
	}

	public function actionCalendarShowModule () {
		$this->actionLVPShow();
	}

	public function actionCalendarShowSingleCourse () {
		$this->actionLVPShow();
	}

	public function actionCalendarNext () {
		$atime = $this->view->getTime();
		$this->view->setTime(mktime(12, 0, 0, date('n', $atime), date('j', $atime) + 7), date('Y', $atime));
		$this->actionLVPShow();
	}

	public function actionCalendarPrevious () {
		$atime = $this->view->getTime();
		$this->view->setTime(mktime(12, 0, 0, date('n', $atime), date('j', $atime) - 7), date('Y', $atime));
		$this->actionLVPShow();
	}

	public function actionCalendarUp () {
		if ($this->view->getDayTime() <= 8) {
			$this->view->setDayTime(0);
		} else if ($this->view->getDayTime() >= 11) {
			$this->view->setDayTime(8);
		} else {
			$this->view->setDayTime(8);
		}
		$this->actionLVPShow();
	}

	public function actionCalendarDown () {
		if ($this->view->getDayTime() == 8) {
			$this->view->setDayTime(11);
		} else if ($this->view->getDayTime() == 0) {
			$this->view->setDayTime(8);
		} else {
			$this->view->setDayTime(8);
		}
		$this->actionLVPShow();
	}

	public function actionCalendarNextConflict () {
		$this->actionLVPShow();
	}

	public function actionCalendarPreviousConflict () {
		$this->actionLVPShow();
	}

	public function actionCalendarGoTo () {
		$this->actionLVPShow();
	}

	public function actionCalendarSendMessage () {
		$this->actionLVPShow();
	}

	public function actionCalendarRedirectRaumzeit () {
		$this->actionLVPShow();
	}
}
?>