(function () {

document.observe('dom:loaded', function() {
	$$('form').invoke('observe', 'submit', function(event) {
		var stop = false;
		$(event.target).select('.required').each(function(item) {
			stop |= !$F(item).length;
		});
		if (stop) {
			event.stop();
		}
	});
});

document.observe('click', function(event) {
	if (event.button!=0)
		return;

	var element = event.element();
	if (element.match('.semester.visible') || (element.match('.semester.link') && element.up('td').down('.visible').visible())) {
		event.stop();
		element.up('td').down('.visible').hide().siblings('.hidden').invoke('show');
		element.up('td').select('.module,.module').invoke('hide');
		var row = element.up('tr').next();
		while (row) {
			row = row.hide().next();
		}
	} else if (element.match('.semester.hidden') || (element.match('.semester.link') && !element.up('td').down('.visible').visible())) {
		event.stop();
		element.up('td').down('.hidden').hide().siblings('.visible').invoke('show');
		element.up('td').select('.module,.module').invoke('show');

		var row = element.up('tr').next();
		var display = false;
		while (row) {
			if (row.match('.module')) {
				display = row.show().down('.visible').visible();
			} else if (display) {
				row.show();
			}
			row = row.next();
		}
	}
	if (element.match('.module.visible') || (element.match('.module.link') && element.up('td').down('.visible').visible())) {
		event.stop();
		element.up('td').down('.visible').hide().siblings('.hidden').invoke('show');
		var row = element.up('tr').next();
		while (row && !row.match('.module')) {
			row = row.hide().next();
		}
	} else if (element.match('.module.hidden') || (element.match('.module.link') && !element.up('td').down('.visible').visible())) {
		event.stop();
		element.up('td').down('.hidden').hide().siblings('.visible').invoke('show');
		var row = element.up('tr').next();
		while (row && !row.match('.module')) {
			row = row.show().next();
		}
	}

	if (element.match('.module.open_all')) {
		event.stop();
		element.up('tbody').down('tr').siblings().invoke('show');
		element.up('tbody').select('.visible').invoke('show');
		element.up('tbody').select('.hidden').invoke('hide');
	} else if (element.match('.module.close_all')) {
		event.stop();
		element.up('tbody').down('tr').siblings().invoke('hide');
		element.up('tbody').select('tr.module,tr.module .hidden').invoke('show');
		element.up('tbody').select('tr.module .visible').invoke('hide');
	}

	if (!event.findElement('a') || !event.findElement('a').match('.module_info')) {
		return;
	}
	event.stop();

	var div = new Element('div');

	var container = element;
	while (!container.up().match('body')) {
		container = container.up();
	}
	var dimensions = container.getDimensions();

	div.writeAttribute('id', 'module_overlay');
	$$('body')[0].appendChild(div);
	div.setStyle({
		position: 'absolute',
		left: 0,
		top: 0,
		width: Math.max(dimensions.width,window.innerWidth||document.body.clientWidth||document.documentElement.clientWidth)+'px',
		height: Math.max(dimensions.height,window.innerHeight||document.body.clientHeight||document.documentElement.clientHeight)+'px',
		backgroundColor: '#000',
		zIndex: 10000
	});
	div.setOpacity(0.5);
	var dimensions = document.viewport.getDimensions();

	while ($('lightwindow_overlay'))
		$('lightwindow_overlay').remove();
	while ($('lightwindow'))
		$('lightwindow').remove();

	var lw = new lightwindow;

	var href = event.findElement('a').readAttribute('href');
	var type = (href.match(/^https?:\/\//)
		? 'external'
		: 'page');
	if (type!='page') {
		href += '&remove_layout&append_script';
	}
	lw.activateWindow({
		href : href,
		type : type,
		height : Math.floor((window.innerHeight||document.body.clientHeight||document.documentElement.clientHeight)*0.8)+'px',
		width : Math.floor(dimensions.width*0.8)+'px',
		loadingAnimation : false,
		title : ''
	});

	$('module_overlay').observe('click', function() {
		lw.deactivate();
	});
}).observe('lightwindow:close', function(event) {
	$('module_overlay') && $('module_overlay').remove();
});

})();