<?php

require_once $GLOBALS['STUDIP_BASE_PATH'] . '/' . $GLOBALS['RELATIVE_PATH_CALENDAR'] . '/lib/SeminarEvent.class.php';

class LVPPluginCalendarEvent extends SeminarEvent {

	public function __construct ($id = '', $properties = null, $sem_id = '') {
		parent::__construct($id, $properties, $sem_id);
	}
	
	public function restore ($id = '') {
		if ($id) {
			$this->id = $id;
		}
		
		$db = DBManager::get();
		
		$stmt = $db->prepare('SELECT t.*, s.* FROM termine t LEFT JOIN seminare s ON t.range_id = s.Seminar_id WHERE t.termin_id = ?');
		$stmt->execute(array($this->id));
		if ($row = $stmt->fetch()) {
			$this->setProperty('SUMMARY',         $row['title']);
			$this->setProperty('DTSTART',         $row['date']);
			$this->setProperty('DTEND',           $row['end_time']);
			$this->setProperty('DESCRIPTION',     $row['description']);
			$this->setProperty('CLASS',           'PRIVATE');
			$this->setProperty('SEMNAME',         $row['Name']);
			$this->setProperty('UID',             $this->getUid($this->id));
			$this->setProperty('CREATED',         $row['mkdate']);
			$this->setProperty('LAST-MODIFIED',   $row['chdate']);
			$this->setProperty('RRULE',           $this->getRepeat());
			$this->setProperty('STUDIP_CATEGORY', $row['date_typ']);
			$this->sem_id   = $row['Seminar_id'];
			$this->setWritePermission(TRUE);
			if (trim($row['raum'])) {
				$this->setProperty('LOCATION', $row['raum']);
			} else {
				$stmt = $db->prepare('SELECT ro.name FROM resources_assign as ra LEFT JOIN resources_objects as ro USING (resource_id) WHERE ra.assign_user_id = ?');
				$stmt->execute(array($this->id));
				if ($row = $stmt->fetch()) {
					$this->setProperty('LOCATION', $row['name']);
				} else {
					$this->setProperty('LOCATION', _("Keine Raumangabe"));
				}
			}
			return true;
		}
		return false;
	}
}
?>