<?php
require_once('lib/msg.inc.php');


abstract class LVPPluginView {

	protected $plugin;
	protected $template;
	private $messages = array();

	public static function GetView ($class_name, &$plugin) {
		$full_class_name = 'LVPPluginView' . $class_name;
		$view_instance = new $full_class_name();
		$view_instance->plugin =& $plugin;
		$view_instance->template = $view_instance->plugin->template_factory->open(strtolower($class_name) . '.tmpl.php');
		return $view_instance;
	}

	public function __call ($method_name, $params) {
		// Fehlerausgabe
		throw new Exception(_("Das Plugin verfgt nicht ber die gewnschte Operation"));
	}

	public function show () { }

	protected function getAjaxLink ($cmd, $options = null) {
		if (is_null($options)) {
			$options = array();
		}
		$link = PluginEngine::GetLink($this->plugin, array($options), $cmd);
		return PrototypeHelper::remote_function(array('url' => $link));
	}

	public function addMsg ($type, $message, $id = null) {
		if (is_null($id)) {
			$id = 'top';
		}
		$this->messages[$id][] = array($type, $message);
	}

	protected function getMsg ($id) {
		return $this->messages[$id];
	}

	protected function showMsg () {
		if (sizeof($this->messages)) {
			$template = $this->plugin->template_factory->open('messages.tmpl.php');
			$template->set_attribute('messages', $this->messages['top']);
			echo $template->render();
		}
	}

}
?>