<?php

require_once dirname(__FILE__) . '/LVPPluginCalendarWeek.class.php';

class LVPPluginViewCalendar extends LVPPluginView {
	
	private $time;
	private $dtime;
	private $type;
	private $calendar;
	
	public function __construct () {
		//unset($_SESSION['LVPPlugin']['ViewCalendar']);
		if (!isset($_SESSION['LVPPlugin']['ViewCalendar'])) {
			$_SESSION['LVPPlugin']['ViewCalendar'] = array(
				'time' => time(),
				'dtime' => 8,
				'type' => 5
			);
		}
		foreach ($_SESSION['LVPPlugin']['ViewCalendar'] as $key => $value) {
			$this->$key = $value;
		}
	}
	
	public function __destruct () {
		$_SESSION['LVPPlugin']['ViewCalendar'] = array(
			'time' => $this->getTime(),
			'dtime' => $this->getDayTime(),
			'type' => $this->getWeekType()
		);
	}
	
	public function setTime ($tstamp) {
		$tstamp = intval($tstamp);
		if ($tstamp < 0 || $tstamp > 0x7FFFFFFF) {
			$this->time = time();
		} else {
			$this->time = $tstamp;
		}
		$_SESSION['LVPPlugin']['ViewCalendar']['time'] = $this->time;
		var_dump($_SESSION['LVPPlugin']['ViewCalendar']);
	}
	
	public function getTime () {
		return $this->time;
	}
	
	public function setDayTime ($dtime) {
		$dtime = intval($dtime);
		if ($dtime < 0 || $dtime > 23) {
			$this->dtime = 8;
		} else {
			$this->dtime = $dtime;
		}
		$_SESSION['LVPPlugin']['ViewCalendar']['dtime'] = $this->dtime;
	}
	
	public function getDayTime () {
		return $this->dtime;
	}
	
	public function setWeekType ($type) {
		if ($type == 7) {
			$this->type = 7;
		} else {
			$this->type = 5;
		}
	}
	
	public function getWeekType () {
		return $this->type;
	}
	
	public function getMaxColumns () {
		if (!is_array($this->calendar)) {
			$this->calendar = $this->createWeekTable();
		}
		return $this->calendar['max_columns'];
	}
	
	public function getCalendar ($row = null) {
		if (!is_array($this->calendar)) {
			$this->calendar = $this->createWeekTable();
		}
		if (is_null($row)) {
			return $this->calendar['table'];
		}
		return $this->calendar['table'][$row];
	}
	
	public function getCalendarSize () {
		if (!is_array($this->calendar)) {
			$this->calendar = $this->createWeekTable();
		}
		return sizeof($this->calendar['table']);
	}
	
	public function show () {
		$this->week = new LVPPluginCalendarWeek($this->getTime(), $this->data);
		$this->template->set_attribute('calendar', $this);//$this->createWeekTable($week, $this->getDayTime(), $this->getDayTime() + 12));
		$this->template->set_attribute('href_previous', PluginEngine::getLink($this->plugin, array(), 'CalendarPrevious'));
		$this->template->set_attribute('href_next', PluginEngine::getLink($this->plugin, array(), 'CalendarNext'));
		if ($this->getDayTime() >= 8) {
			$this->template->set_attribute('href_up', PluginEngine::getLink($this->plugin, array(), 'CalendarUp'));
		}
		if ($this->getDayTime() <= 9) {
			$this->template->set_attribute('href_down', PluginEngine::getLink($this->plugin, array(), 'CalendarDown'));
		}
		$this->template->set_attribute('plugin_path', $GLOBALS['ABSOLUTE_URI_STUDIP'] . $this->plugin->getPluginPath());
		$this->template->set_attribute('time_range', sprintf(_("%d. Woche vom %s bis %s"), strftime('%V', $this->week->getStart()), strftime('%x', $this->week->getStart()), strftime('%x', $this->week->getEnd())));
		$this->template->set_attribute('week_type', $this->getWeekType());
		$this->template->set_attribute('start_time', $this->getDayTime());
		echo $this->template->render();
	}
	
	private function createDayTable ($day_obj, $start = 8, $end = 20, $step = 900, $compact = FALSE, $title_length = 70, $height = 20, $padding = 6, $spacing = 1, $bg_image = 'big') {

		global $PHP_SELF, $CANONICAL_RELATIVE_PATH_STUDIP;
		$atime = $this->time;
		$term = array();    // Array mit eingeordneten Terminen und Platzhaltern (mixed[])
		$colsp = array();   // Breite der Spalten in den einzelnen Zeilen (int[])
		$tab = array();     // html-Ausgabe der Tabelle zeilenweise (String[])
		$max_spalte = 0;    // maximale Spaltenzahl der Tabelle
		$height_event = $height;
		$day_event_row = '';
		$style_cell = 'steel1';
		$link_edit_column = 0;
		$start *= 3600;
		$end *= 3600;
	
		// Die Generierung der Tabellenansicht erfolgt mit Hilfe geklonter Termine,
		// da die Anfangs- und Endzeiten zur korrekten Darstellung evtl. angepasst
		// werden muessen
		for ($i = 0; $i < sizeof($day_obj->events); $i++) {
			if (($day_obj->events[$i]->getEnd() >= $day_obj->getStart() + $start) && ($day_obj->events[$i]->getStart() < $day_obj->getStart() + $end + 3600)) {
	
				
				$cloned_event = $day_obj->events[$i]->getClone();
				$end_corr = $cloned_event->getEnd() % $step;
				if ($end_corr > 0) {
					$end_corr = $cloned_event->getEnd() + ($step - $end_corr);
					$cloned_event->setEnd($end_corr);
				}
				if ($cloned_event->getStart() < ($day_obj->getStart() + $start)) {
					$cloned_event->setStart($day_obj->getStart() + $start);
				}
				if ($cloned_event->getEnd() > ($day_obj->getStart() + $end + 3600)) {
					$cloned_event->setEnd($day_obj->getStart() + $end + 3600);
				}
	
				$tmp_event[] = $cloned_event;
				$map_events[] = $i;
			}
		}
	
		// calculate maximum number of columns
		$w = 0;
		for ($i = $start / $step; $i < $end / $step + 3600 / $step; $i++) {
			$spalte = 0;
			$zeile = $i - $start / $step;
			while ($w < sizeof($tmp_event) && $tmp_event[$w]->getStart() >= $day_obj->getStart() + $i * $step && $tmp_event[$w]->getStart() < $day_obj->getStart() + ($i + 1) * $step) {
				$rows = ceil($tmp_event[$w]->getDuration() / $step);
				if ($rows < 1) {
					$rows = 1;
				}
	
				while ($term[$zeile][$spalte] != '' && $term[$zeile][$spalte] != '#') {
					$spalte++;
				}
	
				$term[$zeile][$spalte] = $tmp_event[$w];
				$mapping[$zeile][$spalte] = $map_events[$w];
	
				$count = $rows - 1;
				for ($x = $zeile + 1; $x < $zeile + $rows; $x++) {
					for ($y = 0; $y <= $spalte; $y++) {
						if ($y == $spalte) {
							$term[$x][$y] = $count--;
						} elseif ($term[$x][$y] == '') {
							$term[$x][$y] = '#';
						}
					}
				}
				if ($max_spalte < sizeof($term[$zeile])) {
					$max_spalte = sizeof($term[$zeile]);
				}
				$w++;
			}
		}
	
		$zeile_min = 0;
		for ($i = $start / $step; $i < $end / $step + 3600 / $step; $i++) {
			$zeile = $i - $start / $step;
			$zeile_min = $zeile;
			while ($this->maxValue($term[$zeile], $step) > 1) {
				$zeile += $this->maxValue($term[$zeile], $step) - 1;
			}
			$size = 0;
			for ($j = $zeile_min; $j <= $zeile; $j++) {
				if (sizeof($term[$j]) > $size) {
					$size = sizeof($term[$j]);
				}
			}
			for ($j = $zeile_min; $j <= $zeile; $j++) {
				$colsp[$j] = $size;
			}
			$i = $zeile + $start / $step;
		}
		
		
		/*
		// Zeile fuer Tagestermine
		$day_event_row[0] = "<td class=\"$style_cell\"";
	
		if ($tmp_day_event) {
	
			if ($max_spalte > 0)
				$day_event_row[0] .= " colspan=\"" . ($max_spalte + $link_edit_column) . "\"";
	
			$day_event_row[0] .= " valign=\"bottom\"><table width=\"100%\" border=\"0\" cellpadding=\"";
			//$day_event_row[0] .= ($padding / 2) . "\" cellspacing=\"1\">\n";
			$day_event_row[0] .= "0\" cellspacing=\"0\">";
			$i = 0;
			foreach ($tmp_day_event as $day_event) {
				$category_style = $day_event->getCategoryStyle($bg_image);
				$title = fit_title($day_event->getTitle(), 1, 1, $title_length);
				$title_str = sprintf("<a style=\"color: #FFFFFF; font-size:10px;\" href=\"$PHP_SELF?cmd=edit&termin_id=%s&atime=%s%s\" %s>"
														, $day_event->getId(), $day_event->getStart()
														, strtolower(get_class($day_event)) == 'seminarevent' ? '&evtype=sem' : ''
														, js_hover($day_obj->events[$map_day_events[$i]]));
				$title_str .= $title . '</a>';
				$day_event_row[0] .= "<tr><td height=\"20\" valign=\"top\" style=\"border-style:solid; border-width:1px; border-color:";
				$day_event_row[0] .= $category_style['color'] . "; background-image:url(";
				$day_event_row[0] .= $category_style['image'] . ");\">";
				$day_event_row[0] .= $title_str;
				$day_event_row[0] .= info_icons($day_event);
				$day_event_row[0] .= "</td>";
				$i++;
			}
			if ($link_edit) {
				$tooltip = tooltip(_("neuer Tagestermin"));
				$day_event_row[0] .= "<td class=\"$style_cell\" align=\"right\" valign=\"bottom\" rowspan=\"";
				$day_event_row[0] .= sizeof($tmp_day_event) . "\"><a href=\"$PHP_SELF?cmd=edit&atime=";
				$day_event_row[0] .= $day_obj->getTs() . "&devent=1\">";
				$day_event_row[0] .= "<img src=\"".$GLOBALS['ASSETS_URL']."images/calplus.gif\" ";
				$day_event_row[0] .= "border=\"0\" $tooltip></a></td>\n";
			}
	
			$day_event_row[0] .= "</table></td>";
		}
		else {
			if ($max_spalte > 0)
				$day_event_row[0] .= " colspan=\"" . ($max_spalte + $link_edit_column) . "\"";
	
			if ($link_edit) {
				$tooltip = tooltip(_("neuer Tagestermin"));
				$day_event_row[0] .= " align=\"right\" valign=\"bottom\"><a href=\"$PHP_SELF?cmd=edit&atime=";
				$day_event_row[0] .= $day_obj->getTs() . "&devent=1\">";
				$day_event_row[0] .= "<img src=\"".$GLOBALS['ASSETS_URL']."images/calplus.gif\" ";
				$day_event_row[0] .= "border=\"0\" $tooltip></a></td>\n";
			}
			else
				$day_event_row[0] .= ">&nbsp;</td>\n";
		}
		*/
		
		
		for ($i = $start / $step;$i < $end / $step + 3600 / $step;$i++) {
			$cspan_str = '';
			$zeile = $i - $start / $step;
			
			/*
			if ($link_edit) {
				$link_edit_time = $zeile * $step + $start - 3600;
				$link_edit_alt = strftime(_("neuer Termin um %R Uhr"), $link_edit_time);
				$link_edit_tooltip = tooltip($link_edit_alt);
			}
			*/
			
			$link_notset = TRUE;
			if (!$term[$zeile]) {
				if ($link_edit) {
					if ($max_spalte > 0) {
						$tab[$zeile] .= "<td class=\"$style_cell\" align=\"right\"  valign=\"bottom\" colspan=\"";
						$tab[$zeile] .= ($max_spalte + 1) . "\"><a href=\"$PHP_SELF?cmd=edit&atime=";
						$tab[$zeile] .= ($day_obj->getStart() + $i * $step);
						$tab[$zeile] .= "\"><img src=\"".$GLOBALS['ASSETS_URL']."images/calplus.gif\" ";
						$tab[$zeile] .= "border=\"0\" $link_edit_tooltip></a></td>\n";
					} else {
						$tab[$zeile] .= "<td class=\"$style_cell\" align=\"right\" valign=\"bottom\">";
						$tab[$zeile] .= "<a href=\"$PHP_SELF?cmd=edit&atime=";
						$tab[$zeile] .=	($day_obj->getStart() + $i * $step);
						$tab[$zeile] .= "\"><img src=\"".$GLOBALS['ASSETS_URL']."images/calplus.gif\"";
						$tab[$zeile] .= "border=\"0\" $link_edit_tooltip></a></td>\n";
					}
				} else {
					if ($max_spalte > 1) {
						$tab[$zeile] .= "<td class=\"$style_cell\" colspan=\"$max_spalte\">";
						$tab[$zeile] .= "<span class=\"lvp_inday\">&nbsp;</span></td>\n";
					} else {
						$tab[$zeile] .= "<td class=\"$style_cell\"><span class=\"lvp_inday\">&nbsp;</span></td>\n";
					}
				}
				$height = "";
				// Wenn bereits hier ein Link eingefuegt wurde braucht weiter unten keine
				// zusaetliche Spalte ausgegeben werden
				$link_notset = FALSE;
			} else {
				if($colsp[$zeile] > 0) {
					$cspan = (int) ($max_spalte / $colsp[$zeile]);
				} else {
					$cspan = 0;
				}
	
				for ($j = 0;$j < $colsp[$zeile];$j++) {
					$sp = 0;
					$n = 0;
					if ($j + 1 == $colsp[$zeile]) {
						$cspan += $max_spalte % $colsp[$zeile];
					}
					if (is_object($term[$zeile][$j])) {
	
						// Wieviele Termine sind zum aktuellen Termin zeitgleich?
						$p = 0;
						$count = 0;
						while ($aterm = $tmp_event[$p]) {
							if ($aterm->getStart() >= $term[$zeile][$j]->getStart() && $aterm->getStart() <= $term[$zeile][$j]->getEnd()) {
								$count++;
							}
							$p++;
						}
	
						if ($count == 0) {
							for ($n = $j + 1;$n < $colsp[$zeile];$n++) {
								if (!is_int($term[$zeile][$n])) {
									$sp++;
								} else {
									break;
								}
							}
							$cspan += $sp;
						}
	
						$rows = ceil($term[$zeile][$j]->getDuration() / $step);
						$tab[$zeile] .= '<td';
	
						if ($cspan > 1) {
							$tab[$zeile] .= ' colspan="'.$cspan.'"';
						}
						if ($rows > 1) {
							$tab[$zeile] .= ' rowspan="'.$rows.'"';
						} else {
							$rows = 1;
						}
	
						$category_style = $term[$zeile][$j]->getCategoryStyle($bg_image);
						$tab[$zeile] .= " style=\"vertical-align:top; font-size:10px; color:#FFFFFF;";
						$tab[$zeile] .= " background-image:url(";
						$tab[$zeile] .= $category_style['image'];
						$tab[$zeile] .= "); border-style:solid; border-width:1px; border-color:";
						$tab[$zeile] .= $category_style['color'] . ";\">";
	
						if (strtolower(get_class($term[$zeile][$j])) == 'seminarevent' && ($term[$zeile][$j]->getTitle() == "Kein Titel" || !$term[$zeile][$j]->getTitle()) ) {
							$title_out = $term[$zeile][$j]->getSemName();
						} else {
							$title_out = $term[$zeile][$j]->getTitle();
						}
	
						if ($rows == 1) {
							$title = fit_title($title_out, $colsp[$zeile], $rows, $title_length - 6);
							$tab[$zeile] .= sprintf("<a style=\"color: #FFFFFF;\" href=\"$PHP_SELF?cmd=edit&termin_id=%s&atime=%d%s\" %s>",
								$term[$zeile][$j]->getId(),
								($day_obj->getStart() + $term[$zeile][$j]->getStart() % 86400),
								strtolower(get_class($term[$zeile][$j])) == "seminarevent" ? "&evtype=sem" : "",
								js_hover($day_obj->events[$mapping[$zeile][$j]]));
							$tab[$zeile] .= $title . "</a>";
						} else {
							$title = fit_title($title_out, $colsp[$zeile], $rows - 1, $title_length);
							$tab[$zeile] .= '<div style="font-size:10px; height:15px; background-color:';
							$tab[$zeile] .= $category_style['color'];
							$tab[$zeile] .= ';">' . date('H.i-', $day_obj->events[$mapping[$zeile][$j]]->getStart());
							$tab[$zeile] .= date('H.i', $day_obj->events[$mapping[$zeile][$j]]->getEnd()) . "</div>\n";
							$tab[$zeile] .= sprintf("<a style=\"color: #FFFFFF;\" href=\"$PHP_SELF?cmd=edit&termin_id=%s&atime=%d%s\" %s>",
								$term[$zeile][$j]->getId(),
								($day_obj->getStart() + $term[$zeile][$j]->getStart() % 86400),
								strtolower(get_class($term[$zeile][$j])) == 'seminarevent' ? '&evtype=sem' : '',
								js_hover($day_obj->events[$mapping[$zeile][$j]]));
							$tab[$zeile] .= $title . '</a>';
						}
						$tab[$zeile] .= info_icons($term[$zeile][$j]);
						$tab[$zeile] .= "</td>\n";
	
						if ($sp > 0) {
							for ($m = $zeile;$m < $rows + $zeile;$m++) {
								$colsp[$m] = $colsp[$m] - $sp + 1;
								$v = $j;
								while ($term[$m][$v] == '#') {
									$term[$m][$v] = 1;
								}
							}
							$j = $n;
						}
					} else if ($term[$zeile][$j] == '#') {
						$csp = $link_edit_column;
						if ($link_edit) {
							$csp--;
						}
						while ($term[$zeile][$j] == '#') {
							$csp += $cspan;
							$j++;
						}
						if ($csp > 1) {
							$colspan_attr = " colspan=\"$csp\"";
						} else {
							$colspan_attr = '';
						}
						$tab[$zeile] .= "<td class=\"$style_cell\"$colspan_attr>";
						$tab[$zeile] .= "<span class=\"lvp_inday\">&nbsp;</span></td>\n";
						$height = '';
					} else if ($term[$zeile][$j] == '') {
						$csp = $max_spalte - $j + $link_edit_column;
						if ($csp > 1) {
							$colspan_attr = " colspan=\"$csp\"";
						} else {
							$colspan_attr = '';
						}
	
						if ($link_edit) {
							$tab[$zeile] .= "<td class=\"$style_cell\"$colspan_attr align=\"right\" valign=\"bottom\">";
							$tab[$zeile] .= sprintf("<a href=\"$PHP_SELF?cmd=edit&atime=%s\">"
																, $day_obj->getStart() + $i * $step);
							$tab[$zeile] .= "<img src=\"".$GLOBALS['ASSETS_URL']."images/calplus.gif\" ";
							$tab[$zeile] .= "border=\"0\" $link_edit_tooltip>";
							$tab[$zeile] .= "</a></td>\n";
						} else {
							$tab[$zeile] .= "<td class=\"$style_cell\"$colspan_attr>";
							$tab[$zeile] .= "<span class=\"lvp_inday\">&nbsp;</span></td>\n";
						}
						
						$link_notset = FALSE;
						$height = '';
						break;
					}
				}
			}
	
			if ($link_edit && $link_notset) {
				$tab[$zeile] .= "<td class=\"$style_cell\" align=\"right\" valign=\"bottom\">";
				$tab[$zeile] .= "<a href=\"$PHP_SELF?cmd=edit&atime=" . ($day_obj->getStart() + $i * $step);
				$tab[$zeile] .= "\"><img src=\"".$GLOBALS['ASSETS_URL']."images/calplus.gif\" ";
				$tab[$zeile] .= "border=\"0\" $link_edit_tooltip>";
				$tab[$zeile] .= "</a></td>\n";
			}
	
			// sonst zerlegt array_merge (siehe unten) die Tabelle
			if (!isset($tab[$zeile]))
				$tab[$zeile] = '';
		}
	
		if ($max_spalte == 0) {
			$max_spalte = 1;
		}
		if ($link_edit && sizeof($tmp_event)) {
			$max_spalte++;
		}
		$tab = array_merge((array)$day_event_row, (array)$tab);
		return array('table' => $tab, 'max_columns' => $max_spalte);
	}
	
	function maxValue ($term, $st) {
		$max_value = 0;
		for ($i = 0; $i < sizeof($term); $i++) {
			if (is_object($term[$i])) {
				$max = ceil($term[$i]->getDuration() / $st);
			} elseif ($term[$i] == '#') {
				continue;
			} elseif ($term[$i] > $max_value) {
				$max = $term[$i];
			}
			if ($max > $max_value) {
				$max_value = $max;
			}
		}
		return $max_value;
	}
	
	function createWeekTable ($start = 8, $end = 20, $step = 900, $compact = false, $link_edit = FALSE) {
		global $PHP_SELF;
		
		$tab_arr = '';
		$tab = '';
		$max_columns = 0;
		$week_type = 5;
		$rows = ($end - $start + 1) * 3600 / $step;
		// calculating the maximum title length
		$length = ceil(125 / $this->getWeekType());
		
		$week_obj = $this->week;
		
		for ($i = 0; $i < $this->getWeekType(); $i++) {
			$tab_arr[$i] = $this->createDayTable($this->week->wdays[$i], $start, $end, $step, FALSE, FALSE, $link_edit, $length, 20, 4, 1, 'small');
		}
	
		// weekday and date as title for each column
		for ($i = 0; $i < $this->getWeekType(); $i++) {
			// add up all colums of each day
			$max_columns += $tab_arr[$i]['max_columns'];
			$dtime = $week_obj->wdays[$i]->getTs();
			if ($week_type == 5) {
				$tab[0] .= '<td class="steelgroup0" align="center" width="19%"';
			} else {
				$tab[0] .= '<td class="steelgroup0" align="center" width="13%"';
			}
	
			if ($tab_arr[$i]['max_columns'] > 1) {
				$tab[0] .= " colspan=\"{$tab_arr[$i]['max_columns']}\"";
			}
			$tab[0] .= "><a class=\"calhead\" href=\"$PHP_SELF?cmd=showday&atime=$dtime\"><b>";
			$tab[0] .= wday($dtime, 'SHORT') . " " . date('d', $dtime) . "</b></a></td>\n";
		}
		if ($compact) {
			$tab[0] = "<tr>{$tab[0]}</tr>\n";
		}
	
		// put the table together
		for ($i = 1; $i < $rows+1; $i++) {
			if ($compact) {
				$tab[$i] .= '<tr>';
			}
			for ($j = 0; $j < $this->getWeekType(); $j++) {
				$tab[$i] .= $tab_arr[$j]['table'][$i];
			}
			if ($compact) {
				$tab[$i] .= "</tr>\n";
			}
		}
	
		if ($compact) {
			$tab = implode('', $tab);
		}
	
		return array('table' => $tab, 'max_columns' => $max_columns);
	
	}

}

?>