<?php
/**
 * ModulVerwaltungDB.class.php
 *
 * lange Beschreibung...
 *
 * PHP version 5
 *
 * @author  	Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @package 	IBIT_ModulVerwaltungPlugin
 * @copyright 	2008 IBIT
 * @license 	http://www.gnu.org/licenses/gpl.html GPL Licence 3
 * @version 	0.8.2
 */

/**
 * statische Klasse fr Datenbankabfragen
 *
 */
class ModulVerwaltungDB
{
	/**
	 * Enter description here...
	 *
	 * @param string $seminar_id
	 * @return string
	 */
	public static function getSeminarName($seminar_id)
	{
	    $result = DBManager::Get()->query("SELECT Name FROM seminare WHERE Seminar_id = '".$seminar_id."'")->fetch(PDO::FETCH_ASSOC);
	    return $result['Name'];
	}

	/**
	 * Enter description here...
	 *
	 * @param string $seminar_id
	 * @return string
	 */
	public static function getVANummer($seminar_id)
	{
	    $result = DBManager::Get()->query("SELECT VeranstaltungsNummer FROM seminare WHERE Seminar_id = '".$seminar_id."'")->fetch(PDO::FETCH_ASSOC);
	    return $result['VeranstaltungsNummer'];
	}

	/**
	 * Enter description here...
	 *
	 * @param string $seminar_id
	 * @return string
	 */
	public static function getInstitut($seminar_id)
	{
		$result = DBManager::Get()->query("SELECT i.Name as Name FROM seminare s LEFT JOIN Institute i ON s.Institut_id=i.Institut_id WHERE Seminar_id = '".$seminar_id."'")->fetch(PDO::FETCH_ASSOC);
	    return $result['Name'];
	}

	/**
	 * Gibt alle Institut-IDs eines admins anhand seiner User-ID zurck
	 *
	 * @param string $userid
	 * @return array()
	 */
	public static function getAdminsInstitute($userid='')
	{
		$institute_ids = array();
		$db = new DB_Seminar;
		$db->queryf("SELECT Institut_id FROM `user_inst` WHERE `user_id` = '%s' AND `inst_perms` = 'admin'", $userid);
		while($db->next_record())
		{
			$institute_ids[] = $db->f('Institut_id');
		}
		return $institute_ids;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $userid
	 * @return array()
	 */
	public static function getLehreinheiten($userid='', $root = false, $include_prof = false)
	{
		$lehreinheiten = array();
		//Alle Lehreinheiten anzeigen
		if($root)
		{
			$db = new DB_Seminar;
			$db->queryf("SELECT sem_tree_id, priority, name FROM `sem_tree` WHERE `type`='2' ORDER BY `name`");
			while ($db->next_record())
			{
				$lehreinheiten[$db->f('sem_tree_id')] = $db->f('name');
			}
		}
		//nur ausgewhlte Lehreinheiten anzeigen
		else
		{
			$institute_ids = self::getAdminsInstitute($userid);
			foreach ($institute_ids as $institute_id)
			{
				// Institut is Fakultt -> alle Lehreinheiten der Fakultt holen
				if(self::isFaculty($institute_id))
				{
					$db = new DB_Seminar;
					$db->queryf("SELECT sem_tree_id FROM `sem_tree` WHERE `studip_object_id`='%s'", $institute_id);
					if($db->next_record())
					{
						$fakid = $db->f('sem_tree_id');
					}
					//echo "fakid: ".$fakid;

					$db = new DB_Seminar;
					$db->queryf("SELECT sem_tree_id, priority, name FROM `sem_tree` WHERE `parent_id`='%s' AND `type`='2' ORDER BY `name`", $fakid);
					while ($db->next_record())
					{
						$lehreinheiten[$db->f('sem_tree_id')] = $db->f('name');

					}
				}
				// nur die zugehrigen Lehreinheiten holen
				else
				{
					$db = new DB_Seminar;
					$db->queryf("SELECT st.sem_tree_id, st.priority, st.name FROM `lehreinheit` AS sple LEFT JOIN `struktur_zuordnung` AS spst ON sple.lehreinheit_id = spst.objekt_id LEFT JOIN `sem_tree` AS st ON spst.sem_tree_id = st.sem_tree_id WHERE sple.institut_id='%s' AND spst.typ = 2", $institute_id);
					while ($db->next_record())
					{
						$lehreinheiten[$db->f('sem_tree_id')] = $db->f('name');
					}

				}
			}
		}

		if ($include_prof)
		{
			$db = new DB_Seminar;
			$db->queryf("SELECT sem_tree_id, name FROM `sem_tree` WHERE `name`='Professionalisierungsbereich'");
			while ($db->next_record())
			{
				$lehreinheiten[$db->f('sem_tree_id')] = $db->f('name');

			}
		}

		#echo "<pre>";
		#print_r($lehreinheiten);
		#echo "</pre>";
		return $lehreinheiten;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $lehreinheit_id
	 * @return array()
	 */
	public static function getFaecher($lehreinheit_id='')
	{
		$faecher = array();
		$db = new DB_Seminar;
		$db->queryf("SELECT sem_tree_id, priority, name FROM `sem_tree` WHERE `type`='3' AND `parent_id`='%s' ORDER BY `priority`", $lehreinheit_id);
		while ($db->next_record())
		{
			$faecher[$db->f('sem_tree_id')] = $db->f('name');
		}
		return $faecher;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $fach_id
	 * @return array()
	 */
	public static function getAbschluesse($fach_id)
	{
		$abschluesse = array();
		$db = new DB_Seminar;
		$db->queryf("SELECT sem_tree_id, priority, name FROM `sem_tree` WHERE `type`='4' AND `parent_id`='%s' ORDER BY `priority`", $fach_id);
		while ($db->next_record())
		{
			$abschluesse[$db->f('sem_tree_id')] = array('name' => $db->f('name'));
		}
		return $abschluesse;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $fach_id
	 * @return array()
	 */
	public static function getAbschluesseAndModule($fach_id)
	{
		$abschluesse = array();
		$db = new DB_Seminar;
		$db->queryf("SELECT sem_tree_id, priority, name FROM `sem_tree` WHERE `type`='4' AND `parent_id`='%s' ORDER BY `priority`", $fach_id);
		while ($db->next_record())
		{
			$abschluesse[$db->f('sem_tree_id')] = array('name' => $db->f('name'), 'module' => self::getModule($db->f('sem_tree_id')));
		}
		return $abschluesse;
	}

	/**
	 * Holt alle abstrakten Module zu einem Fach.
	 *
	 * @param string $abschluss_id
	 * @return array()
	 */
	public static function getModule($abschluss_id)
	{
		$rows = DBManager::Get()->query("SELECT DISTINCT sem_tree_id, name FROM sem_tree WHERE type=5 AND parent_id='{$abschluss_id}' ORDER BY priority ASC, name ASC")->fetchAll(PDO::FETCH_ASSOC);

		$modules = array();
		foreach ($rows as $row)
		{
			$modules[ $row['sem_tree_id'] ] = $row['name'];
		}
		return $modules;
	}

	/**
	 * Gibt eine Liste aller konkreten Module zu einem Abschluss (in einem Semester) zurck
	 *
	 * @param string $abschluss_id
	 * @param optional string $semester
	 * @return array()
	 */
	public static function getKonModule($abschluss_id, $semester = '')
	{
		$module = array();
		$db = new DB_Seminar;
		$db->queryf("SELECT DISTINCT sem_tree_id FROM `sem_tree` WHERE `type`='5' AND `parent_id`='%s' ORDER BY `name`", $abschluss_id);
		while ($db->next_record())
		{
			#echo "semtree_id: ".$db->f('sem_tree_id')."<br>";
			$db2 = new DB_Seminar;
			if(!empty($semester))
			{
				$db2->queryf("SELECT m.modul_kon_id, mz.modul_abst_id, mz.modultitel, mz.modulschluessel, mz.pruef_version, mz.pruef_form, m.semester, m.mok, s.name as semestername FROM mod_zuordnung AS mz LEFT JOIN module m ON mz.modul_abst_id = m.modul_abst_id LEFT JOIN semester_data s ON m.semester=s.semester_id WHERE mz.sem_tree_id = '%s' AND m.semester ='%s' ORDER BY mz.modulschluessel", $db->f('sem_tree_id'), $semester);
			}
			else
			{
				$db2->queryf("SELECT m.modul_kon_id, mz.modul_abst_id, mz.modultitel, mz.modulschluessel, mz.pruef_version, mz.pruef_form, m.semester, m.mok, s.name as semestername FROM mod_zuordnung AS mz LEFT JOIN module m ON mz.modul_abst_id = m.modul_abst_id LEFT JOIN semester_data s ON m.semester=s.semester_id WHERE mz.sem_tree_id = '%s' ORDER BY mz.modulschluessel", $db->f('sem_tree_id'));
			}
			if($db2->next_record())
			{
				$modul = array(
					'modul_kon_id' => $db2->f('modul_kon_id'),
					'modul_abst_id' => $db2->f('modul_abst_id'),
					'modultitel' => $db2->f('modultitel'),
					'modulschluessel' => $db2->f('modulschluessel'),
					'pruef_version' => $db2->f('pruef_version'),
					'pruef_form' => $db2->f('pruef_form'),
					'mok' => $db2->f('mok'),
					'semester_id' => $db2->f('semester'),
					'semester_name' => str_replace(array('Sommersemester', 'Wintersemester'), array('SS', 'WS'), trim($db2->f('semestername')))
				);
				$module[] = $modul;
			}
		}
		return $module;
	}

	/**
	 * Gibt eine Liste aller konkreten Module zu einem Abschluss (in einem Semester) zurck
	 *
	 * @param string $abschluss_id
	 * @param optional string $semester
	 * @return array()
	 */
	public static function getKonModuleForFach($fach_id)
	{
		$module = array();
		$db = new DB_Seminar;
		$db->queryf("SELECT DISTINCT objekt_id FROM `struktur_zuordnung` WHERE `sem_tree_id`='%s'", $fach_id);
		while ($db->next_record())
		{
			$db2 = new DB_Seminar;
			$db2->queryf("SELECT DISTINCT m.modul_kon_id, mz.modul_abst_id, mz.modultitel, mz.modulschluessel, mz.pruef_version, mz.pruef_form, m.semester, m.mok, s.name as semestername FROM mod_zuordnung AS mz LEFT JOIN module m ON mz.modul_abst_id = m.modul_abst_id LEFT JOIN semester_data s ON m.semester=s.semester_id WHERE mz.fach_id = '%s' ORDER BY mz.modulschluessel", $db->f("objekt_id"));
			while($db2->next_record())
			{
				$modul = array(
					'modul_kon_id' => $db2->f('modul_kon_id'),
					'modul_abst_id' => $db2->f('modul_abst_id'),
					'modultitel' => $db2->f('modultitel'),
					'modulschluessel' => $db2->f('modulschluessel'),
					'pruef_version' => $db2->f('pruef_version'),
					'pruef_form' => $db2->f('pruef_form'),
					'mok' => $db2->f('mok'),
					'semester_id' => $db2->f('semester'),
					'semester_name' => str_replace(array('Sommersemester', 'Wintersemester'), array('SS', 'WS'), trim($db2->f('semestername')))
				);
				$module[] = $modul;
			}
		}
		array_unique($module);
		return $module;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $semester
	 * @param string $lehreinheit_id
	 * @param string $fach_id
	 * @param string $abschluss_id
	 * @return array()
	 */
	public static function getVeranstaltungen($semester, $lehreinheit_id, $fach_id, $abschluss_id)
	{
		$resultset = array();
		if (!empty($abschluss_id))
		{
			$db = new DB_Seminar;
			$db->queryf("SELECT DISTINCT type FROM sem_tree WHERE parent_id = '%s'", $abschluss_id);
			if ($db->next_record())
			{
				if($db->f('type') == '5')
				{
					$module = array();
					$db2 = new DB_Seminar;
					$db2->queryf("SELECT DISTINCT sem_tree_id FROM sem_tree WHERE parent_id = '%s' ORDER BY priority", $abschluss_id);
					while ($db2->next_record())
					{
						$modul = array(
							'id' => $db2->f('sem_tree_id'),
							'name' => self::getSemTreeIdName($db2->f('sem_tree_id')),
							'kommentar' => self::getModulKommentar($db2->f('sem_tree_id'), $semester),
							'veranstaltungen' => self::getVeranstaltungInfos($db2->f('sem_tree_id'), $semester)
						);
						if(!empty($modul['veranstaltungen']))
						{
							$module[] = $modul;
						}
					}
					$abschluss = array(
						'id' => $abschluss_id,
						'name' => self::getSemTreeIdName($abschluss_id),
						'module' => $module
					);
					$fach = array(
						'id' => $fach_id,
						'name' => self::getSemTreeIdName($fach_id),
						'abschluesse' => array($abschluss)
					);
					$lehreinheit = array(
						'id' => $lehreinheit_id,
						'name' => self::getSemTreeIdName($lehreinheit_id),
						'faecher' => array($fach)
					);
					$resultset[] = $lehreinheit;
				}
			}
			//Modul ausgewhlt
			else
			{
				$modul = array(
					'id' => $abschluss_id,
					'name' => self::getSemTreeIdName($abschluss_id),
					'kommentar' => self::getModulKommentar($abschluss_id, $semester),
					'veranstaltungen' => self::getVeranstaltungInfos($abschluss_id, $semester)
				);
				//todo...
				$abschluss = array(
					'id' => $abschluss_id,
					'name' => self::getSemTreeIdName($abschluss_id),
					'module' => array($modul)
				);
				$fach = array(
					'id' => $fach_id,
					'name' => self::getSemTreeIdName($fach_id),
					'abschluesse' => array($abschluss)
				);
				$lehreinheit = array(
					'id' => $lehreinheit_id,
					'name' => self::getSemTreeIdName($lehreinheit_id),
					'faecher' => array($fach)
				);
				$resultset[] = $lehreinheit;

				#echo "modul ausgewhlt<br/>";
				#echo "<pre>";
				#print_r($resultset);
				#echo "</pre>";
			}
		}
		elseif (!empty($fach_id))
		{
			$abschluesse = array();
			$db2 = new DB_Seminar;
			$db2->queryf("SELECT sem_tree_id FROM sem_tree WHERE parent_id = '%s'", $fach_id);
			while ($db2->next_record())
			{
				$module = array();
				$db3 = new DB_Seminar;
				$db3->queryf("SELECT sem_tree_id FROM sem_tree WHERE parent_id = '%s'", $db2->f('sem_tree_id'));
				while ($db3->next_record())
				{
					$modul = array(
						'id' => $db3->f('sem_tree_id'),
						'name' => self::getSemTreeIdName($db3->f('sem_tree_id')),
						'veranstaltungen' => self::getVeranstaltungInfos($db3->f('sem_tree_id'), $semester)
					);
					if(!empty($modul['veranstaltungen']))
					{
						$module[] = $modul;
					}
				}
				$abschluss = array(
					'id' => $db2->f('sem_tree_id'),
					'name' => self::getSemTreeIdName($db2->f('sem_tree_id')),
					'module' => $module
				);
				if(!empty($abschluss['module']))
				{
					$abschluesse[] = $abschluss;
				}
			}
			$fach = array(
				'id' => $fach_id,
				'name' => self::getSemTreeIdName($fach_id),
				'abschluesse' => $abschluesse
			);
			$lehreinheit = array(
				'id' => $lehreinheit_id,
				'name' => self::getSemTreeIdName($lehreinheit_id),
				'faecher' => array($fach)
			);
			$resultset[] = $lehreinheit;
		}
		elseif (!empty($lehreinheit_id))
		{
			$faecher = array();
			$db4 = new DB_Seminar;
			$db4->queryf("SELECT sem_tree_id FROM sem_tree WHERE parent_id = '%s'", $lehreinheit_id);
			while ($db4->next_record())
			{
				$abschluesse = array();
				$db2 = new DB_Seminar;
				$db2->queryf("SELECT sem_tree_id FROM sem_tree WHERE parent_id = '%s'", $db4->f('sem_tree_id'));
				while ($db2->next_record())
				{
					$module = array();
					$db3 = new DB_Seminar;
					$db3->queryf("SELECT sem_tree_id FROM sem_tree WHERE parent_id = '%s'", $db2->f('sem_tree_id'));
					while ($db3->next_record())
					{
						$modul = array(
							'id' => $db3->f('sem_tree_id'),
							'name' => self::getSemTreeIdName($db3->f('sem_tree_id')),
							'veranstaltungen' => self::getVeranstaltungInfos($db3->f('sem_tree_id'), $semester)
						);
						#wenn leer nicht anzeigen
						if(!empty($modul['veranstaltungen']))
						{
							$module[] = $modul;
						}

					}
					$abschluss = array(
						'id' => $db2->f('sem_tree_id'),
						'name' => self::getSemTreeIdName($db2->f('sem_tree_id')),
						'module' => $module
					);
					if(!empty($abschluss['module']))
					{
						$abschluesse[] = $abschluss;
					}
				}
				$fach = array(
					'id' => $db4->f('sem_tree_id'),
					'name' => self::getSemTreeIdName($db4->f('sem_tree_id')),
					'abschluesse' => $abschluesse
				);
				if(!empty($fach['abschluesse']))
				{
					$faecher[] = $fach;
				}
			}
			$lehreinheit = array(
				'id' => $lehreinheit_id,
				'name' => self::getSemTreeIdName($lehreinheit_id),
				'faecher' => $faecher
			);

			$resultset[] = $lehreinheit;
		}
		return $resultset;
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $semester
	 * @param unknown_type $lehreinheit_id
	 * @param unknown_type $fach_id
	 * @param unknown_type $abschluss_id
	 * @param unknown_type $userid
	 * @param unknown_type $root
	 * @return array() list of courses
	 */
	public static function getVeranstaltungenForBericht($semester, $lehreinheit_id, $fach_id, $abschluss_id, $userid, $sortbysemester='no', $root=false)
	{
		$instituts = self::getAdminsInstitute($userid);
		$resultset = array();
		$db = new DB_Seminar;
		$db->queryf("SELECT DISTINCT type FROM sem_tree WHERE parent_id = '%s'", $abschluss_id);
		if ($db->next_record())
		{
			if($db->f('type') == '5')
			{
				$module = array();
				$db2 = new DB_Seminar;
				$db2->queryf("SELECT DISTINCT sem_tree_id FROM sem_tree WHERE parent_id = '%s' ORDER BY priority", $abschluss_id);
				while ($db2->next_record())
				{
					$modul = array(
						'id' => $db2->f('sem_tree_id'),
						'name' => self::getSemTreeIdName($db2->f('sem_tree_id')),
						'fachsemester' => self::getModulFachsemester($db2->f('sem_tree_id'), $semester),
						'kommentar' => self::getModulKommentar($db2->f('sem_tree_id'), $semester),
						'veranstaltungen' => self::getVeranstaltungInfos($db2->f('sem_tree_id'), $semester, $instituts, $root)
					);
					if(!empty($modul['veranstaltungen']))
					{
						$module[] = $modul;
					}
				}

				//Module nach empfohlenem Fachsemester sortieren
				if($sortbysemester == 'yes')
				{
					$fsemester =array();
					foreach($module as $modul)
					{
						if(empty($modul['fachsemester']))
						{
							$fsemester['x'][] = $modul;
						}
						else
						{
							foreach($modul['fachsemester'] as $fsid)
							{
								$fsemester[$fsid['fachsem_id']][] = $modul;
							}
						}
					}
					$abschluss = array(
						'id' => $abschluss_id,
						'name' => self::getSemTreeIdName($abschluss_id),
						'semester' => $fsemester
					);
				}
				//nur module anzeigen
				else
				{
					$abschluss = array(
						'id' => $abschluss_id,
						'name' => self::getSemTreeIdName($abschluss_id),
						'module' => $module
					);
				}
				$fach = array(
					'id' => $fach_id,
					'name' => self::getSemTreeIdName($fach_id),
					'abschluesse' => array($abschluss)
				);
				$lehreinheit = array(
					'id' => $lehreinheit_id,
					'name' => self::getSemTreeIdName($lehreinheit_id),
					'faecher' => array($fach)
				);
				$resultset[] = $lehreinheit;
			}
		}
		return $resultset;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $sem_tree_id
	 * @return unknown
	 */
	public static function getModulKommentar($sem_tree_id, $semester)
	{
		return DBManager::get()->query("SELECT md.kommentar
			FROM modul_deskriptor AS md
			LEFT JOIN module AS m ON md.desk_id=m.desk_id
			LEFT JOIN mod_zuordnung AS mz ON m.modul_abst_id= mz.modul_abst_id
			WHERE mz.sem_tree_id='{$sem_tree_id}' AND m.semester='{$semester}'")->fetchColumn();
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $sem_tree_id
	 * @param unknown_type $semester
	 * @return unknown
	 */
	public static function getModulFachsemester($sem_tree_id, $semester)
	{
		return DBManager::get()->query("SELECT mf.fachsem_id
			FROM mod_fachsem AS mf
			LEFT JOIN module AS m ON mf.modul_kon_id=m.modul_kon_id
			LEFT JOIN mod_zuordnung AS mz ON m.modul_abst_id= mz.modul_abst_id
			WHERE mz.sem_tree_id='{$sem_tree_id}' AND m.semester='{$semester}'")->fetchAll(PDO::FETCH_ASSOC);
	}

	/**
	 * //TODO: status als typ ausgeben...
	 *
	 * @param string $sem_tree_id
	 * @param string $semester_id
	 * @return array()
	 */
	public static function getVeranstaltungInfos($sem_tree_id, $semester_id, $instituts=array(), $root=false)
	{
		$courses = array();
		$db = new DB_Seminar;
		$db->queryf("
		SELECT s.Seminar_id, s.VeranstaltungsNummer, s.Name, s.status, s.art, s.Beschreibung, s.admission_turnout, s.visible, si.institut_id
		FROM seminar_sem_tree AS sst
		LEFT JOIN seminare AS s ON sst.seminar_id = s.Seminar_id
		LEFT JOIN semester_data sd ON s.start_time = sd.beginn
		LEFT JOIN seminar_inst si ON sst.seminar_id = si.seminar_id
		WHERE sst.sem_tree_id = '%s'
		AND sd.semester_id='%s'
		ORDER BY s.VeranstaltungsNummer ASC", $sem_tree_id, $semester_id);
		#error_reporting(E_ALL);
		while($db->next_record())
		{
			$authors =array();

			$db2 = new DB_Seminar;
			$db2->queryf("
			SELECT a.Nachname, a.Vorname
			FROM seminar_user AS su
			LEFT JOIN auth_user_md5 AS a
			ON su.user_id = a.user_id
			WHERE su.Seminar_id='%s' AND su.status='dozent' ORDER BY su.position, a.Nachname;", $db->f('Seminar_id'));
			while($db2->next_record())
			{
				$author = array(
					'name' => $db2->f('Nachname'),
					'vorname' => $db2->f('Vorname')
				);
				$authors[] = $author;
			}
			#veranstaltungen nur hinzu, wenn ein institut passt, kein institut angegeben oder root
			# bentigt fr profbereich
			$institut_id = $db->f('institut_id');
			if(in_array($institut_id, $instituts) || empty($institut_id) || empty($instituts) || $root)
			{
				$course = array(
					'seminar_id' => $db->f('Seminar_id'),
					'vnummer' => $db->f('VeranstaltungsNummer'),
					'name' => $db->f('Name'),
					'status' => $db->f('status'),
					'art' => $db->f('art'),
					'beschreibung' => $db->f('Beschreibung'),
					'max_user' => $db->f('admission_turnout'),
					'visible' => $db->f('visible'),
					'typ' => $GLOBALS['SEM_TYPE'][$db->f('status')]['name'],
					'authors' => $authors
				);
				$courses[]=$course;
			}
		}
		return $courses;
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $sem_tree_id
	 * @param unknown_type $semester_id
	 */
	public static function getVeranstaltungsPlace($seminar_id)
	{
		#$room = DBManager::Get()->query("SELECT DISTINCT raum FROM termine WHERE range_id='$seminar_id'")->fetchAll(PDO::FETCH_ASSOC);
		$rooms = explode('<br/>', getRoom($seminar_id, false, (time() - 60 * 60 * 24 * 90)));
		foreach ($rooms as $key=>$longroom)
		{
			$new = preg_replace('/^.*Ort: (.*)&nbsp;&nbsp.*$/is', '$1', $longroom);
			$new = preg_replace('/^.*0&nbsp;(.*),.*$/is', '$1', $new);

			if($key > 0 && $last != $new)
			{
				$room .= ', ';
			}
			if($last != $new)
			{
				$last = $new;
				$room .= str_replace(array('(', ')'), '', $last);
			}
		}

		if(empty($room))
		{
			$result2 = DBManager::Get()->query("SELECT Ort FROM seminare WHERE Seminar_id='$seminar_id'")->fetch(PDO::FETCH_ASSOC);
			if(!empty($result2['Ort']))
			{
				$room = $result2['Ort'];
			}
		}

		$room = str_replace(array('k.A., ', '&nbsp;', 'k.A.'), '', $room);

		if(empty($room) || $room == '(nicht bekannt)' || $room == 'nicht bekannt' || $room == 'A00 0-000')
		{
			$room = 'k.A.';
		}
		return $room;
	}

	/**
	 * Enter description here...
	 *
	 * @param md5 $seminar_id
	 * @return string
	 */
	public static function getVeranstaltungsPlaceAndTime($seminar_id)
	{
		//neu 1.
		$total = DBManager::get()->query("SELECT COUNT(*) FROM termine WHERE range_id = '{$seminar_id}'")->fetchColumn();
		$blockseminar = DBManager::get()->query("SELECT COUNT(*) FROM termine WHERE range_id = '{$seminar_id}' AND date_typ = '8'")->fetchColumn();

		//blockveranstaltung -> nur ersten und letzten termin anzeigen.
		if ($blockseminar > 0)
		{
			//blockdaten holen
		    $dates = DBManager::get()->query("SELECT * FROM termine WHERE range_id = '{$seminar_id}' AND date_typ = '8' ORDER BY date")->fetchAll(PDO::FETCH_ASSOC);
		    
			
		    //zustzliche einzeltermine vorher.
		    if($total > $blockseminar)
		    {
		        //singledaten holen
		        $singles = DBManager::get()->query("SELECT * FROM termine WHERE range_id = '{$seminar_id}' AND date_typ != '8'")->fetchAll(PDO::FETCH_ASSOC);
		        foreach ($singles as $single_date){
		            if($single_date['date'] < $dates[0]['date']){
		                $room .= strftime('%a. %d.%m.%Y %H:%M', $single_date['date']).'-'.strftime('%H:%M', $single_date['end_time']).'<br/>';
		                if($single_date['raum']){
		                    $room .= 'Ort: '.$single_date['raum'].', <br/>';
		                }
		            }
		        }
		    }
		    
		    //blockveranstaltungen gruppieren...
		    $blocks = array();
		    foreach ($dates as $bdate){
		        $blocks[$bdate['mkdate']][] = $bdate;
		    }
		    
		    //blcke ausgeben
		    foreach ($blocks as $block){
		        if(count($block) > 1){
                    $room .= '<br/>'.strftime('%a. %d.%m.%Y', $block[0]['date']).' bis '.strftime('%a. %d.%m.%Y', $block[count($block)-1]['date']);
                    $room .= ', '.strftime('%H:%M', $block[0]['date']).'-'.strftime('%H:%M', $block[count($block)-1]['end_time']).', ';
                    if(!empty($dates[0]['raum'])){
                        $room .= ', '.$dates[0]['raum'].', ';		            
    		        }
                } else {
                    $room .= '<br/>'.strftime('%a. %d.%m.%Y %H:%M', $block[0]['date']).'-'.strftime('%H:%M', $block[0]['end_time']).', ';
                    if(!empty($dates[0]['raum'])){
                        $room .= $dates[0]['raum'].', ';                    
                    }
                }	
                	        
		    }
		    
		    //zustzliche einzeltermine nachher.
            if(isset($singles))
            {
                foreach ($singles as $single_date){
                    if($single_date['date'] > $dates[0]['date']){
                        $room .= '<br/>'.strftime('%a. %d.%m.%Y %H:%M', $single_date['date']).'-'.strftime('%H:%M', $single_date['end_time']);
                        if($single_date['raum']){
                            $room .= '<br/>'.'Ort: '.$single_date['raum'].', <br/>';
                        }
                    }
                }
            }
			
		}
		// infos aus der ressourcenverwaltung
		else
		{
			$room = getRoom($seminar_id, false);
			$room = preg_replace('/<i.*?i>/', '', $room);
			$room = preg_replace('/<I.*?I>/', '', $room);
			$room = str_replace('&nbsp;', ' ', $room);
			$room = str_replace(array('(', ')'), '', $room);
			$room = str_replace(array('nicht bekannt', 'A00 0-000'), 'k.A.', $room);
			$room = str_replace('  ,', ',', $room);
			$room = str_replace('So. wchentlich 00:00-00:00 Ort: k.A.', 'k.A.', $room);
		}

		//2. wenn da nix vorhanden war, in der seminare gucken
		if(empty($room))
		{
			//TODO: zeiten dazu...
			$result2 = DBManager::Get()->query("SELECT Ort FROM seminare WHERE Seminar_id='$seminar_id'")->fetch(PDO::FETCH_ASSOC);
			if(!empty($result2['Ort']))
			{
				$room = $result2['Ort'];
			}
		}
		//3. wenn immer noch keine daten da sind, keine Angabe...
		if(empty($room))
		{
			$room = 'k.A.';
		}

		return $room;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $id
	 * @return string
	 */
	public static function getSemTreeIdName($id)
	{
		$db = new DB_Seminar;
		$db->queryf("SELECT sem_tree_id, name FROM `sem_tree` WHERE sem_tree_id='%s'", $id);
		if($db->next_record())
		{
			return $db->f('name');
		}
		else
		{
			return '';
		}
	}

	/**
	 * berprft eine Institut anhand der ID, ob es sich um eine Fakultt handelt.
	 *
	 * @param string $institut_id
	 * @return boolean
	 */
	public static function isFaculty($institut_id)
	{
		$db = new DB_Seminar;
		$db->queryf("SELECT Institut_id FROM `Institute` WHERE `Institut_id` = '%s' AND `fakultaets_id` = '%s'", $institut_id, $institut_id);
		if($db->next_record())
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	/**
	 * Enter description here...
	 *
	 * @return array()
	 */
	public static function getAllVAdmins()
	{
        $results = DBManager::get()->query("SELECT u.user_id, u.username, u.Vorname, u.Nachname, i.Name FROM `auth_user_md5` as u LEFT JOIN `user_inst` AS iu ON u.user_id=iu.user_id LEFT JOIN `Institute` AS i ON iu.Institut_id=i.Institut_id WHERE iu.inst_perms='admin' ORDER BY u.Nachname, i.Name")->fetchAll(PDO::FETCH_ASSOC);
	    $vadmins = array();
        foreach ($results as $entry) {
            #$vadmins[$entry['user_id']] = array();
            $vadmins[$entry['user_id']]['username'] = $entry['username'];
            $vadmins[$entry['user_id']]['vorname'] = $entry['Vorname'];
            $vadmins[$entry['user_id']]['nachname'] = $entry['Nachname'];
            $vadmins[$entry['user_id']]['institute'][] = $entry['Name'];        
        }
        return $vadmins;
	}

	/**
	 * Enter description here...
	 *
	 * @return array()
	 */
	public static function getAllMAdmins()
	{
		$results = DBManager::get()->query("SELECT ru.userid, u.username, u.Vorname, u.Nachname, r.rolename, i.Name FROM `roles_user` AS ru LEFT JOIN `roles` AS r ON ru.roleid=r.roleid LEFT JOIN `auth_user_md5` as u ON ru.userid=u.user_id LEFT JOIN `user_inst` AS iu ON ru.userid=iu.user_id LEFT JOIN `Institute` AS i ON iu.Institut_id=i.Institut_id WHERE r.rolename='M-Admin' AND iu.inst_perms='admin' ORDER BY u.Nachname, i.Name")->fetchAll(PDO::FETCH_ASSOC);
        $madmins = array();
        foreach ($results as $entry) {
            #$vadmins[$entry['user_id']] = array();
            $madmins[$entry['userid']]['username'] = $entry['username'];
            $madmins[$entry['userid']]['vorname'] = $entry['Vorname'];
            $madmins[$entry['userid']]['nachname'] = $entry['Nachname'];
            $madmins[$entry['userid']]['institute'][] = $entry['Name'];        
        }
        return $madmins;
	}

	/**
	 * Sucht die Veranstaltungen raus, die nicht kopiert werden drfen und gibt
	 * diese als Array zurck
	 *
	 * @param array() $seminars
	 * @param string $user
	 * @return array()
	 */
	public static function checkSeminars($seminars, $user)
	{
	    $db = new DB_Seminar;
	    $db->queryf("SELECT Institut_id FROM user_inst WHERE user_id = '%s' AND inst_perms = 'admin'", $user);
	    while ($db->next_record())
	    {
	        $user_inst_admin[] = $db->f("Institut_id");
	    }
	    foreach ($seminars as $val)
	    {
	        $has_perms = 0;
	        $sql =  "SELECT i.Institut_id, i.fakultaets_id FROM seminare s ".
	                "LEFT JOIN Institute i ON s.Institut_id=i.Institut_id ".
	                "WHERE Seminar_id = '".$val."'";
	        $db->query($sql);
	        $db->next_record();
	        $i_id = $db->f("Institut_id");
	        $f_id = $db->f("fakultaets_id");
	        foreach ($user_inst_admin as $val2)
	        {
	            if (($i_id === $val2) || ($f_id === $val2))
	            {
	                $has_perms++;
	            }
	        }
	        if (!$has_perms)
	        {
	            $sem_array[1][] = $val; // diese Veranstaltung darf nicht kopiert werden
	        } else {
	            $sem_array[0][] = $val; // diese schon
	        }
	    }
	    return $sem_array;
	}

	/**
	 * Kopiert konkrete Module von einem Semester in ein anderes
	 *
	 * @param array() $modules
	 * @param string $semester
	 * @param string $userid
	 * @return array values of copied and already existing modules
	 */
	public static function copyModules($modules, $semester, $userid)
	{
		$i = 0;
		$j = 0;
		foreach ($modules as $modul)
		{
			$result = DBManager::get()->query("SELECT DISTINCT * FROM module WHERE modul_kon_id = '{$modul}'")->fetch(PDO::FETCH_ASSOC);
			$check = DBManager::get()->query("SELECT DISTINCT * FROM module WHERE semester = '{$semester}' AND modul_abst_id = '{$result['modul_abst_id']}'")->fetch(PDO::FETCH_ASSOC);

			if(!empty($result) && empty($check))
			{
				$newkonid = md5($modul.rand());

				//1. db module
				DBManager::get()->exec("INSERT INTO module
				(modul_kon_id, modul_abst_id, desk_id, komplett, semester, kp, letzteAenderung, aktiv, user_id, notenart, pruef_form, pruef_zeiten, pruef_links, mok, institut_id, strukturschluessel)
				VALUES (
					'{$newkonid}',
					'{$result['modul_abst_id']}',
					'{$result['desk_id']}',
					'{$result['komplett']}',
					'{$semester}',
					'{$result['kp']}',
					UNIX_TIMESTAMP(NOW()),
					'{$result['aktiv']}',
					'{$userid}',
					'{$result['notenart']}',
					'{$result['pruef_form']}',
					'{$result['pruef_zeiten']}',
					'{$result['pruef_links']}',
					'{$result['mok']}',
					'{$result['institut_id']}',
					'{$result['strukturschluessel']}')");

				//2. db modul_lehrform
				$modul_lehrform_results = DBManager::get()->query("SELECT * FROM modul_lehrform WHERE modul_kon_id = '{$modul}';")->fetchAll(PDO::FETCH_ASSOC);
				if(!empty($modul_lehrform_results))
				{
					foreach ($modul_lehrform_results as $modul_lehrform)
					{
						DBManager::get()->exec("INSERT INTO modul_lehrform (modul_kon_id, veranst_typ_id, sws) VALUES ('{$newkonid}', '{$modul_lehrform['veranst_typ_id']}', '{$modul_lehrform['sws']}')");
					}
				}

				//3. db modul_sprach_zuord
				$modul_sprach_zuord_results = DBManager::get()->query("SELECT * FROM mod_sprach_zuord WHERE modul_kon_id = '{$modul}';")->fetchAll(PDO::FETCH_ASSOC);
				if(!empty($modul_sprach_zuord_results))
				{
					foreach ($modul_sprach_zuord_results as $modul_sprach_zuord)
					{
						DBManager::get()->exec("INSERT INTO mod_sprach_zuord (modul_kon_id, sprach_id) VALUES ('{$newkonid}', '{$modul_sprach_zuord['sprach_id']}')");
					}
				}

				//4. db modul_fachsem
				$modul_fachsem_results = DBManager::get()->query("SELECT * FROM mod_fachsem WHERE modul_kon_id = '{$modul}';")->fetchAll(PDO::FETCH_ASSOC);
				if(!empty($modul_fachsem_results))
				{
					foreach ($modul_fachsem_results as $modul_fachsem)
					{
						DBManager::get()->exec("INSERT INTO mod_fachsem (modul_kon_id, fachsem_id) VALUES ('{$newkonid}', '{$modul_fachsem['fachsem_id']}')");
					}
				}

				//5. db modul_bereich_zuord
				$modul_bereich_zuord_results = DBManager::get()->query("SELECT * FROM mod_bereich_zuord WHERE modul_kon_id = '{$modul}';")->fetchAll(PDO::FETCH_ASSOC);
				if(!empty($modul_bereich_zuord_results))
				{
					foreach ($modul_bereich_zuord_results as $modul_bereich_zuord)
					{
						DBManager::get()->exec("INSERT INTO mod_bereich_zuord (modul_kon_id, bereich_id) VALUES ('{$newkonid}', '{$modul_bereich_zuord['bereich_id']}')");
					}
				}

				//6. db modul_schwerp_zuord
				$modul_schwerp_zuord_results = DBManager::get()->query("SELECT * FROM mod_schwerp_zuord WHERE modul_kon_id = '{$modul}';")->fetchAll(PDO::FETCH_ASSOC);
				if(!empty($modul_schwerp_zuord_results))
				{
					foreach ($modul_schwerp_zuord_results as $modul_schwerp_zuord)
					{
						DBManager::get()->exec("INSERT INTO mod_schwerp_zuord (modul_kon_id, schwerpunkt_id) VALUES ('{$newkonid}', '{$modul_schwerp_zuord['schwerpunkt_id']}')");
					}
				}

				//7. db modul_verantwort_zuord
				$modul_verantwort_zuord_results = DBManager::get()->query("SELECT * FROM mod_verantwort_zuord WHERE modul_kon_id = '{$modul}';")->fetchAll(PDO::FETCH_ASSOC);
				if(!empty($modul_verantwort_zuord_results))
				{
					foreach ($modul_verantwort_zuord_results as $modul_verantwort_zuord)
					{
						DBManager::get()->exec("INSERT INTO mod_verantwort_zuord (modul_kon_id, user_id, verantwort_typ_id) VALUES ('{$newkonid}', '{$modul_verantwort_zuord['user_id']}', '{$modul_verantwort_zuord['verantwort_typ_id']}')");
					}
				}

				$i++;
			}
			elseif(!empty($check))
			{
				$j++;
			}
		}
		return array($i, $j);
	}
}

?>
