<?php
class ModuleAdministration
{
	private static $not_editable = array(
		'kp',
//		'pruef_form',
		'fachsemester_more',
	);

	public static $tabs = array(
		'create'=>'Konkrete Module erstellen',
		'edit'=>'Konkrete Module bearbeiten',
		'bereich'=>'Bereiche bearbeiten',
		'schwerpunkt'=>'Schwerpunkte bearbeiten',
	);
	private static $tab = null;
	private static $action = null;

	private static $template_factory = null;
	private static $parent = null;

	public static function Engage(&$parent)
	{
		// Print messages
		$messages = self::GetMessages();
		if (!empty($messages['error']))
			StudIPTemplateEngine::showErrorMessage("<strong>Fehler</strong>:<br/>".implode('<br/>', $messages['error']));
		if (!empty($messages['success']))
			StudIPTemplateEngine::showSuccessMessage("<strong>Erfolgreich</strong>:<br/>".implode('<br/>', $messages['success']));

		// Engange actual site
		reset(self::$tabs);

		self::$parent =& $parent;

		self::$tab = isset($_REQUEST['ma_tab'])
			? $_REQUEST['ma_tab']
			: key(self::$tabs);

		self::$action = isset($_REQUEST['function'])
			? $_REQUEST['function']
			: 'index';

		if (isset($_REQUEST['subcommand']) and is_array($_REQUEST['subcommand']))
			$subcommand = key($_REQUEST['subcommand']);
		elseif (isset($_REQUEST['subcommand']) and is_string($_REQUEST['subcommand']))
			$subcommand = $_REQUEST['subcommand'];
		if (is_callable(array('self', self::$tab.'_'.$subcommand)))
			self::$action = $subcommand;
		$function2call = self::$tab.'_'.self::$action;
		if (!empty($_POST) and is_callable(array('self', $function2call.'_POST')))
		{
			if (!($template = self::GetTemplate($function2call.'_POST')))
				$template = self::GetTemplate($function2call);
			if (call_user_func(array('self', $function2call.'_POST'), $template) !== false)
				echo $template->render();
		}
		elseif (is_callable(array('self', $function2call)))
		{
			$template = self::GetTemplate($function2call);
			if (call_user_func(array('self', $function2call), $template) !== false)
				echo $template->render();
		}
		else
			printf('Unknown method "%s::%s_%s" called', __CLASS__, self::$tab, self::$action);
	}

/** CREATE **/

	private static function debuginfo($var)
	{
		$arguments = func_get_args();
		echo '<pre style="background-color: #ffd; border: 1px solid #eea; padding: 5px;">';
		array_map('var_dump', $arguments);
		echo '</pre>';
	}

	public static function create_index(&$template)
	{
		$display = self::$parent->showModulesSelectArea(false, self::GetLink(), true, !self::$parent->permissions->hasRootPermission());

		if (!$display or !isset($_REQUEST['lehreinheit'], $_REQUEST['fach'], $_REQUEST['abschluss']))
			return false;

		$semObject = new SemesterData;
		if(!empty($_REQUEST['semester']))
			$current_semester = $_REQUEST['semester'];
		else
			$current_semester = DBManager::get()->query("SELECT semester_id FROM semester_data WHERE -(-vorles_ende + UNIX_TIMESTAMP()) >= 0 ORDER BY -(-vorles_ende + UNIX_TIMESTAMP()) ASC")->fetchColumn();

		$sem_tree_ids = array_keys( ModulVerwaltungDB::getModule($_REQUEST['abschluss']) );
		$abstract_module_ids = ModuleDB::GetAbstractIds( $sem_tree_ids );
		$abstract_modules = ModuleDB::Load($abstract_module_ids, $sem_tree_ids);

		$institute_ids = self::$parent->permissions->hasRootPermission()
			? null
			: ModuleHelper::GetInstitutesForUser(self::$parent->user->userid);

		$concrete_module_ids = ModuleDB::GetConcreteIds( $abstract_module_ids, $current_semester, $institute_ids, false);
		$allowed_concrete_module_ids =  ModuleDB::GetConcreteIds( $abstract_module_ids, $current_semester, $institute_ids);

		$abstract_modules_sorted = $abstract_modules;
		foreach (array_reverse($abstract_modules) as $abst_id => $module)
			if (in_array($abst_id, $allowed_concrete_module_ids))
			{
				unset($abstract_modules_sorted[$abst_id]);
				$abstract_modules_sorted = array_merge(array($abst_id=>$module), $abstract_modules_sorted);
			}

		$template->set_attribute('abstract_modules', $abstract_modules);
		$template->set_attribute('abstract_modules_sorted', $abstract_modules_sorted);
		$template->set_attribute('concrete_module_ids', $concrete_module_ids);
		$template->set_attribute('allowed_concrete_module_ids', $allowed_concrete_module_ids);

		$template->set_attribute('lehreinheit', $_REQUEST['lehreinheit']);
		$template->set_attribute('lehreinheit_name', ModulVerwaltungDB::getSemTreeIdName($_REQUEST['lehreinheit']));
		$template->set_attribute('fach', $_REQUEST['fach']);
		$template->set_attribute('fach_name', ModulVerwaltungDB::getSemTreeIdName($_REQUEST['fach']));
		$template->set_attribute('abschluss', $_REQUEST['abschluss']);
		$template->set_attribute('abschluss_name', ModulVerwaltungDB::getSemTreeIdName($_REQUEST['abschluss']));

		$template->set_attribute('semester', $semObject->getAllSemesterData());
		$template->set_attribute('current_semester', $current_semester);
		$template->set_attribute('institutes', ModuleHelper::GetInstituteData());
		$template->set_attribute('is_foreign', !self::$parent->permissions->hasRootPermission() and ModuleHelper::IsForeignLehreinheitForUser($_REQUEST['lehreinheit'], self::$parent->user->userid));
		$template->set_attribute('link_edit', self::GetLink('index', array('ma_tab'=>'edit', 'lehreinheit'=>$_REQUEST['lehreinheit'], 'fach'=>$_REQUEST['fach'], 'abschluss'=>$_REQUEST['abschluss'], 'semester'=>$_REQUEST['semester'])));

		$current_institute = ModuleHelper::GetInstituteForLehreinheit($_REQUEST['lehreinheit']);
		$template->set_attribute('current_institute',  in_array($current_institute, ModuleHelper::GetInstituteData())
			? array($current_institute)
			: $institute_ids
		);

		return true;
	}

	public static function create_abstractize(&$template)
	{
		if (empty($_POST['concrete_modules']))
			die('Undefined state in '.__METHOD__.' ('.__FILE__.':'.__LINE__.')');

		ModuleDB::RemoveConcreteModule($_POST['concrete_modules']);

		log_event('MOD_DEL_MODULE', null, null, sprintf('%d konkrete Module der Lehreinheit "%s / %s / %s" wurden gelöscht', count($_POST['concrete_modules']), ModuleHelper::GetLehreinheitName($_REQUEST['lehreinheit']), ModuleHelper::GetFachName($_REQUEST['fach']), ModuleHelper::GetAbschlussName($_REQUEST['abschluss'])));

		self::ReportSuccess('Die konkreten Module wurden erfolgreich entfernt');

		self::Relocate('index', array(
			'semester'=>$_REQUEST['semester'],
			'lehreinheit'=>$_REQUEST['lehreinheit'],
			'fach'=>$_REQUEST['fach'],
			'abschluss'=>$_REQUEST['abschluss'],
		));
	}

	public static function create_concretize(&$template)
	{
		if (empty($_POST['abstract_modules']))
			die('Undefined state in '.__METHOD__.' ('.__FILE__.':'.__LINE__.')');

		foreach ($_POST['abstract_modules'] as $modul_abst_id)
			ModuleDB::CreateConcreteModule($modul_abst_id, $_POST['semester'], $_POST['institute'], self::$parent->getUser()->getUserId());

		log_event('MOD_ADD_MODULE', null, null, sprintf('%d abstrakte Module der Lehreinheit "%s / %s / %s" wurden konkretisiert', count($_POST['abstract_modules']), ModuleHelper::GetLehreinheitName($_REQUEST['lehreinheit']), ModuleHelper::GetFachName($_REQUEST['fach']), ModuleHelper::GetAbschlussName($_REQUEST['abschluss'])));
		self::ReportSuccess('Die konkreten Module wurden erfolgreich erzeugt');

		self::Relocate('index', array(
			'semester'=>$_REQUEST['semester'],
			'lehreinheit'=>$_REQUEST['lehreinheit'],
			'fach'=>$_REQUEST['fach'],
			'abschluss'=>$_REQUEST['abschluss'],
		));
	}

/** EDIT **/

	public static function edit_index(&$template)
	{
		if (!self::$parent->showModulesSelectArea(false, self::GetLink(), true, !self::$parent->permissions->hasRootPermission()))
			return false;

		if (!empty($_REQUEST['action']))
		{
			$user_id = self::$parent->getUser()->getUserId();
			switch ($_REQUEST['action'])
			{
				case 'activate':
				case 'deactivate':
					ModuleDB::UpdateConcreteModule($_REQUEST['module_ids'], 'aktiv', (int)($_REQUEST['action']=='activate'), $user_id);
					$action = ($_REQUEST['action']=='activate') ? 'MOD_ACTIVATE' : 'MOD_DEACTIVATE';
					$message = ($_REQUEST['action']=='activate')
						? 'Modul "%s" (%s) wurde aktiviert'
						: 'Modul "%s" (%s) wurde deaktiviert';
					foreach ($_REQUEST['module_ids'] as $id)
						log_event($action, null, null, sprintf($message, ModuleHelper::GetModuleName(ModuleDB::LoadConcrete($id)), $id));
				break;
				case 'mark_complete':
				case 'mark_incomplete':
					ModuleDB::UpdateConcreteModule($_REQUEST['module_ids'], 'komplett', (int)($_REQUEST['action']=='mark_complete'), $user_id);
					$action = ($_REQUEST['action']=='mark_complete') ? 'MOD_COMPLETE' : 'MOD_INCOMPLETE';
					$message = ($_REQUEST['action']=='mark_complete')
						? 'Modul "%s" (%s) wurde als komplett markiert'
						: 'Modul "%s" (%s) wurde als unvollständig markiert';
					foreach ($_REQUEST['module_ids'] as $id)
						log_event($action, null, null, sprintf($message, ModuleHelper::GetModuleName(ModuleDB::LoadConcrete($id)), $id));
				break;
				default:
				break;
			}
		}

		$semObject = new SemesterData;
		if(!empty($_REQUEST['semester']))
			$current_semester = $_REQUEST['semester'];
		else
			$current_semester = DBManager::get()->query("SELECT semester_id FROM semester_data WHERE -(-vorles_ende + UNIX_TIMESTAMP()) >= 0 ORDER BY -(-vorles_ende + UNIX_TIMESTAMP()) ASC")->fetchColumn();

		$abstract_module_ids = ModuleDB::GetAbstractIds( array_keys( ModulVerwaltungDB::getModule($_REQUEST['abschluss']) ) );

		$institute_ids = self::$parent->permissions->hasRootPermission()
			? null
			: ModuleHelper::GetInstitutesForUser(self::$parent->user->userid, false);

		$semester_data = array();
		foreach ($semObject->getAllSemesterData() as $semester)
			$semester_data[ $semester['semester_id'] ] = count(ModuleDB::GetConcreteIds( $abstract_module_ids, $semester['semester_id'] , $institute_ids ));

		$concrete_module_ids = ModuleDB::GetConcreteIds( $abstract_module_ids, $current_semester , $institute_ids );
		$concrete_modules = ModuleDB::LoadConcrete(array_keys($concrete_module_ids));
		$abstract_modules = ModuleDB::Load($abstract_module_ids);

		$template->set_attribute('abstract_modules', $abstract_modules);
		$template->set_attribute('concrete_modules', $concrete_modules);
		$template->set_attribute('concrete_module_ids', $concrete_module_ids);

		$template->set_attribute('lehreinheit', $_REQUEST['lehreinheit']);
		$template->set_attribute('lehreinheit_name', ModulVerwaltungDB::getSemTreeIdName($_REQUEST['lehreinheit']));
		$template->set_attribute('fach', $_REQUEST['fach']);
		$template->set_attribute('fach_name', ModulVerwaltungDB::getSemTreeIdName($_REQUEST['fach']));
		$template->set_attribute('abschluss', $_REQUEST['abschluss']);
		$template->set_attribute('abschluss_name', ModulVerwaltungDB::getSemTreeIdName($_REQUEST['abschluss']));

		$template->set_attribute('semester', $semObject->getAllSemesterData());
		$template->set_attribute('semester_data', $semester_data);
		$template->set_attribute('current_semester', $current_semester);
		$template->set_attribute('plugin_path', self::$parent->path);

		$link_parameters = array(
			'lehreinheit'=>$_REQUEST['lehreinheit'],
			'fach'=>$_REQUEST['fach'],
			'abschluss'=>$_REQUEST['abschluss'],
			'semester'=>$current_semester,
		);
		$template->set_attribute('links', array(
			'edit'=>self::GetLink('edit', array(
				'back'=>$_REQUEST['lehreinheit'].'|'.$_REQUEST['fach'].'|'.$_REQUEST['abschluss'].'|'.$current_semester,
				'modul_kon_id'=>'%s',
			)),
			'module_info'=>self::GetLink('get_info', array('id'=>'%s')),
			'submit'=>self::GetLink('index', array('ma_tab'=>'edit')).'#form',
			'activate'=>self::GetLink('index', array_merge($link_parameters, array(
				'action'=>'activate',
				'module_ids[]'=>'%s',
			))).'#form',
			'deactivate'=>self::GetLink('index', array_merge($link_parameters, array(
				'action'=>'deactivate',
				'module_ids[]'=>'%s',
			))).'#form',
			'mark_complete'=>self::GetLink('index', array_merge($link_parameters, array(
				'action'=>'mark_complete',
				'module_ids[]'=>'%s',
			))).'#form',
			'mark_incomplete'=>self::GetLink('index', array_merge($link_parameters, array(
				'action'=>'mark_incomplete',
				'module_ids[]'=>'%s',
			))).'#form',
		));

		return true;
	}

	public static function edit_get_info(&$template)
	{
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH']))
		{
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
		}

		$template->set_attribute('modul', ModuleDB::LoadConcrete($_GET['id']));
		echo $template->render();

		if (isset($_SERVER['HTTP_X_REQUESTED_WITH']))
			ob_start(create_function('$a', 'return "";'));
	}

	private static function Preview()
	{
		if (isset($_SERVER['HTTP_X_REQUESTED_WITH']))
		{
			ob_end_clean();
			Header('Content-Type: text/html; charset=WINDOWS-1252');
		}

		$_POST['module'] = array_map(create_function('$a', 'return is_string($a) ? utf8_decode(stripslashes($a)) : $a;'), $_POST['module']);
		$_POST['module']['deskriptor'] = array_map(create_function('$a', 'return is_string($a) ? utf8_decode(stripslashes($a)) : $a;'), $_POST['module']['deskriptor']);
		$module = array_merge(ModuleDB::LoadConcrete($_POST['module']['id']), $_POST['module']);
		$module['verantwortliche'] = $_POST['module']['persons'];

		// Filter
		$user_ids = array_map(create_function('$a', 'return trim($a["user_id"]);'), $module['verantwortliche']);

		foreach ($module['verantwortliche'] as $index=>$ids)
		{
			$statement = DBManager::Get()->query("SELECT a.user_id, CONCAT(IF(LENGTH(title_front)>0, CONCAT(title_front, ' '),''),Vorname,' ',Nachname,IF(LENGTH(title_rear)>0,CONCAT(' ',title_rear),'')) AS name FROM auth_user_md5 a LEFT JOIN user_info u ON a.user_id=u.user_id WHERE a.user_id IN ('".implode("','", $ids)."')");

			$users = array();
			foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
				$users[ $row['user_id'] ] = $row['name'];
			$module['verantwortliche'][$index] = $users;
		}

		$template = self::$template_factory->open('ma_viewmodule.php');
		$template->set_attribute('module', $module);
		$template->set_attribute('preview', true);
		$template->set_attribute('links', array(
			'seminars'=>PluginEngine::GetLink(new StudienmodulManagement(), array('id'=>$module['modul_abst_id'], 'semester'=>$module['semester'], 'show_seminars'=>1, 'hide_links'=>!empty($_REQUEST['hide_links']), 'action' => 'show_module')),
		));
		echo $template->render();

		if (isset($_SERVER['HTTP_X_REQUESTED_WITH']))
			ob_start(create_function('$a', 'return "";'));
	}

	public static function edit_edit_POST(&$template)
	{
		if (isset($_POST['preview']) or isset($_POST['preview_x']))
		{
			self::Preview();
			return false;
		}

		$module = ModuleDB::LoadConcrete($_POST['module']['id']);
		$post_module = $_POST['module'];
		$post_deskriptor = array_map('stripslashes', $post_module['deskriptor']);

		// Update descriptor
		DBManager::get()
			->prepare("INSERT INTO modul_deskriptor (desk_id, turnus, level_id, typ_id, dauer, lehrform_kommentar, anmeldeformalitaeten, inhalte, ziele, kommentar, literatur, teilnahmevoraussetzungen, vorkenntnisse, verknuepftMitModulen, zulassungsbedingungen, url, unbeschraenkt, praesenzzeit, belegungszeitpunkt, untertitel, language) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) ON DUPLICATE KEY UPDATE turnus=VALUES(turnus), level_id=VALUES(level_id), typ_id=VALUES(typ_id), dauer=VALUES(dauer), lehrform_kommentar=VALUES(lehrform_kommentar), anmeldeformalitaeten=VALUES(anmeldeformalitaeten), inhalte=VALUES(inhalte), ziele=VALUES(ziele), kommentar=VALUES(kommentar), literatur=VALUES(literatur), teilnahmevoraussetzungen=VALUES(teilnahmevoraussetzungen), vorkenntnisse=VALUES(vorkenntnisse), verknuepftMitModulen=VALUES(verknuepftMitModulen), zulassungsbedingungen=VALUES(zulassungsbedingungen), url=VALUES(url), unbeschraenkt=VALUES(unbeschraenkt), praesenzzeit=VALUES(praesenzzeit), untertitel=VALUES(untertitel), language=VALUES(language)")
			->execute(array(
				$module['desk_id'],
				$post_deskriptor['turnus'],
				$post_deskriptor['level_id'],
				$post_deskriptor['typ_id'],
				$post_deskriptor['dauer'],
				$post_deskriptor['lehrform_kommentar'],
				$post_deskriptor['anmeldeformalitaeten'],
				$post_deskriptor['inhalte'],
				$post_deskriptor['ziele'],
				$post_deskriptor['kommentar'],
				$post_deskriptor['literatur'],
				$post_deskriptor['teilnahmevoraussetzungen'],
				$post_deskriptor['vorkenntnisse'],
				$post_deskriptor['verknuepftMitModulen'],
				$post_deskriptor['zulassungsbedingungen'],
				$post_deskriptor['url'],
				(int) isset($post_deskriptor['unbeschraenkt']),
				$post_deskriptor['praesenzzeit'],
				isset($post_deskriptor['belegungszeitpunkt'])
					? $post_deskriptor['belegungszeitpunkt']
					: $module['deskriptor']['belegungszeitpunkt'],
				$post_deskriptor['untertitel'],
				$post_deskriptor['language'],
			));

		// Update Schwerpunkte
		DBManager::get()
			->prepare("DELETE FROM mod_schwerp_zuord WHERE modul_kon_id = ?")
			->execute(array( $post_module['id'] ));

		$stmt = DBManager::get()->prepare("INSERT INTO mod_schwerp_zuord (modul_kon_id, schwerpunkt_id) VALUES (?, ?)");
		foreach ((array) $post_module['schwerpunkte'] as $schwerpunkt_id)
			$stmt->execute(array(
				$post_module['id'],
				$schwerpunkt_id,
			));

		// Update Bereiche
		DBManager::get()
			->prepare("DELETE FROM mod_bereich_zuord WHERE modul_kon_id=?")
			->execute(array( $post_module['id'] ));

		$stmt = DBManager::get()->prepare("INSERT INTO mod_bereich_zuord (modul_kon_id, bereich_id) VALUES (?, ?)");
		foreach ((array)$post_module['bereiche'] as $bereich_id)
			$stmt->execute(array(
				$post_module['id'],
				$bereich_id,
			));

		// Update Fachsemester
		DBManager::get()
			->prepare("DELETE FROM mod_fachsem WHERE modul_kon_id = ?")
			->execute(array( $post_module['id'] ));

		$stmt = DBManager::get()->prepare("INSERT INTO mod_fachsem (modul_kon_id, fachsem_id) VALUES (?, ?)");
		foreach ((array) $post_module['fachsemester'] as $fachsemester)
			$stmt->execute(array(
				$post_module['id'],
				$fachsemester,
			));

		// Update Sprachen
		DBManager::get()
			->prepare("DELETE FROM mod_sprach_zuord WHERE modul_kon_id = ?")
			->execute(array( $post_module['id'] ));

		$stmt = DBManager::get()->prepare("INSERT INTO mod_sprach_zuord (modul_kon_id, sprach_id) VALUES (?, ?)");
		foreach ((array) $post_module['sprachen'] as $sprach_id)
			$stmt->execute(array(
				$post_module['id'],
				$sprach_id,
			));

		// Update Lehrformen
		DBManager::get()
			->prepare("DELETE FROM modul_lehrform WHERE modul_kon_id = ?")
			->execute(array( $post_module['id'] ));

		$stmt = DBManager::get()->prepare("INSERT INTO modul_lehrform (modul_kon_id, veranst_typ_id, sws) VALUES (?,?,?) ON DUPLICATE KEY UPDATE sws = sws + VALUES(sws)");
		foreach ($post_module['lehrformen'] as $index => $data)
		{
			if (!is_numeric($index) or ($data['sws']==0))
				continue;

			$stmt->execute(array(
				$post_module['id'],
				$data['veranst_typ_id'],
				(int) $data['sws'],
			));
		}

		// Update Verantwortliche
		DBManager::get()
			->prepare("DELETE FROM mod_verantwort_zuord WHERE modul_kon_id = ?")
			->execute(array( $post_module['id'] ));

		$stmt = DBManager::get()->prepare("INSERT INTO mod_verantwort_zuord (modul_kon_id, user_id, verantwort_typ_id, position) VALUES (?, ?, ?, ?)");
		$index = 0;
		foreach ((array) $post_module['persons'] as $verantwort_typ_id => $user_ids)
			foreach ((array) $user_ids as $user_id)
				$stmt->execute(array(
					$post_module['id'],
					$user_id,
					$verantwort_typ_id,
					$index++,
				));

		// Update module
		DBManager::get()
			->prepare("UPDATE module SET mok = ?, kp = ?, pruef_form = ?, pruef_zeiten = ?, pruef_links = ?, letzteAenderung = UNIX_TIMESTAMP(), user_id = ?, aktiv = ?, komplett = ?  WHERE modul_kon_id = ?")
			->execute(array(
				$post_module['mok'],
				$post_module['kp'],
				$post_module['pruef_form'],
				$post_module['pruef_zeiten'],
				(empty($post_module['pruef_links']) or $post_module['pruef_links']==-1) ? null : $post_module['pruef_links'],
				self::$parent->getUser()->getUserId(),
				$post_module['aktiv'],
				$post_module['komplett'],
				$post_module['id']
			));

		if (self::$parent->permissions->hasRootPermission())
			DBManager::get()
				->prepare("UPDATE module SET institut_id = ? WHERE modul_kon_id = ?")
				->execute(array(
					$post_module['institut_id'],
					$post_module['id']
				));

		log_event('MOD_EDIT_MODULE', null, null, sprintf('Modul "%s" (%s) wurde bearbeitet', ModuleHelper::GetModuleName(ModuleDB::LoadConcrete($post_module['id'])), $post_module['id']));
		self::ReportSuccess('Die Änderungen wurden erfolgreich gespeichert');

		$parameters = unserialize(urldecode($_POST['backlink_parameters']));
		self::Relocate('index', $parameters);

		return false;
	}

	public static function edit_edit(&$template)
	{
		if (empty($_REQUEST['modul_kon_id']) or !($module = ModuleDB::LoadConcrete($_REQUEST['modul_kon_id'])))
			return false;

		if (isset($_REQUEST['back']))
		{
			if (!isset($_SESSION['ma_back']) or !is_array($_SESSION['ma_back']))
				$_SESSION['ma_back'] = array();
			$_SESSION['ma_back'][ $_REQUEST['modul_kon_id'] ] = $_REQUEST['back'];
		}

		list($l, $f, $a, $s) = explode('|', $_SESSION['ma_back'][ $_REQUEST['modul_kon_id'] ]);
		$back_link_parameters = array(
			'lehreinheit'=>$l,
			'fach'=>$f,
			'abschluss'=>$a,
			'semester'=>$s,
		);

		$semObject = new SemesterData;

		$template->set_attribute('module', $module);
		$template->set_attribute('semesters', ModuleHelper::GetSemesters());
		$template->set_attribute('all_semesters', array_intersect(ModuleDB::GetModuleSemesters($_REQUEST['modul_kon_id']), array_keys(ModuleHelper::GetSemesters())));
		$template->set_attribute('back_link_parameters', $back_link_parameters);
		$template->set_attribute('verantwortliche', ModuleDB::GetVerantwortliche());
		$template->set_attribute('not_editable', self::$not_editable);
		$template->set_attribute('root', self::$parent->permissions->hasRootPermission());
		$template->set_attribute('institutes', ModuleHelper::GetInstituteData());
		$template->set_attribute('links', array(
			'back'=>self::GetLink('index', $back_link_parameters).'#form',
			'submit'=>self::GetLink('edit').'#form',
			'autocomplete'=>self::GetLink('autocomplete'),
			'load_semester_data'=>self::GetLink('load_data'),
		));
	}

	private static function edit_load_data(&$template)
	{
		ob_end_clean();

		Header('Content-Type: text/html; charset=WINDOWS-1252');
		$module_id = ModuleDB::GetModuleIdBySemester($_REQUEST['modul_kon_id'], $_REQUEST['semester_id']);
		$module = ModuleDB::LoadConcrete( $module_id );

		array_walk_recursive($module, create_function('&$a', '$a = utf8_encode($a);'));
		echo json_encode($module);

		die;
		//ob_start(create_function('$a', 'return "";'));
	}

	private static function edit_autocomplete_search($needle, $limit = 0)
	{
		$sanitized_needle = str_replace(array('Ä','Ö','Ü','ä','ö','ü','ß'), array('Ae','Oe','Ue','ae','oe','ue','ss'), utf8_decode($needle));

		if ($limit == -1)
		{
			$stmt = DBManager::get()->prepare(
				"SELECT COUNT(*) AS quantity ".
				"FROM auth_user_md5 ".
				"LEFT JOIN user_info USING (user_id) ".
				"WHERE perms IN ('dozent', 'admin', 'root') AND ".
				"(username LIKE ? OR ".
				"CONCAT(Vorname,' ',Nachname) LIKE ? OR ".
				"CONCAT(Vorname,' ',Nachname) LIKE ? OR ".
				"Vorname LIKE ? OR ".
				"Vorname LIKE ? OR ".
				"Nachname LIKE ? OR  ".
				"Nachname LIKE ?) ".
				"AND " . get_vis_query()
			);
			$stmt->execute(array(
				"%{$needle}%",
				"%{$needle}%",
				"%{$sanitized_needle}%",
				"%{$needle}%",
				"%{$sanitized_needle}%",
				"%{$needle}%",
				"%{$sanitized_needle}%",
			));

			return ($row = $stmt->fetch())
				? $row['quantity']
				: false;
		}

		$stmt = DBManager::get()->prepare("SELECT user_id, username, Vorname, Nachname, ".
			"title_front, title_rear, perms ".
			"FROM auth_user_md5 ".
			"LEFT JOIN user_info USING (user_id) ".
			"WHERE perms IN ('dozent', 'admin', 'root') AND ".
			"(username LIKE ? OR ".
			"CONCAT(Vorname,' ',Nachname) LIKE ? OR ".
			"CONCAT(Vorname,' ',Nachname) LIKE ? OR ".
			"Vorname LIKE ? OR ".
			"Vorname LIKE ? OR ".
			"Nachname LIKE ? OR  ".
			"Nachname LIKE ?) ".
			"AND " . get_vis_query() . " ".
			"ORDER BY Nachname ".
			(!empty($limit)?"LIMIT {$limit}":''));

			$stmt->execute(array(
				"%{$needle}%",
				"%{$needle}%",
				"%{$sanitized_needle}%",
				"%{$needle}%",
				"%{$sanitized_needle}%",
				"%{$needle}%",
				"%{$sanitized_needle}%",
			));

			return $stmt->fetchAll();
	}

	public static function edit_autocomplete()
	{
		ob_end_clean();
		Header('Content-Type: text/html; charset=WINDOWS-1252');

		$persons = self::edit_autocomplete_search(utf8_decode($_GET['value']), isset($_GET['limit']) ? $_GET['limit'] : 0);

		echo '<ul>';
		foreach ($persons as $person)
		{
			printf('<li rel="%s"><span class="informal">%s </span>%s %s<span class="informal"> (%s)</span></li>',
				$person['user_id'],
				Avatar::getAvatar($person['user_id'])->getImageTag(Avatar::SMALL),
				htmlReady($person['Vorname']),
				htmlReady($person['Nachname']),
				htmlReady($person['perms'])
			);
		}
		echo '</ul>';

		if (isset($_GET['limit']) and self::edit_autocomplete_search($_GET['value'], -1)>$_GET['limit'])
		{
			printf('<a href="#" class="autocomplete_more">%s</a>',
				sprintf(_('Alle %s Ergebnisse'),
					number_format(self::edit_autocomplete_search($_GET['value'], -1), 0, ',', '.')
				)
			);
		}

		ob_start(create_function('$a', 'return "";'));
	}


	public static function bereich_index(&$template)
	{
		if (!empty($_POST['action']))
		{
			switch ($_POST['action'])
			{
				case 'delete':
					log_event('MOD_DEL_BEREICH', null, null, sprintf('%d Bereiche der Lehreinheit "%s" wurden gel�scht', count($_POST['bereich_ids']), ModuleHelper::GetLehreinheitName($_REQUEST['lehreinheit'])), null);
					ModuleDB::DeleteBereich($_POST['bereich_ids']);
				break;
				default:
				break;
			}
			self::Relocate('index', array(
				'lehreinheit'=>$_REQUEST['lehreinheit'],
			));
		}

		$lehreinheiten = ModulVerwaltungDB::getLehreinheiten(self::$parent->user->userid, self::$parent->permissions->hasRootPermission(), true);
		$mapping = ModuleHelper::MapSemTreeLehreinheiten(array_keys($lehreinheiten));
		foreach ($lehreinheiten as $id=>$value)
		{
			unset($lehreinheiten[$id]);
			$lehreinheiten[ $mapping[$id] ] = $value;
		}
		$lehreinheit = isset($_REQUEST['lehreinheit'])
			? $_REQUEST['lehreinheit']
			: key($lehreinheiten);

		$template->set_attribute('lehreinheiten', $lehreinheiten);
		$template->set_attribute('lehreinheit', $lehreinheit);
		$template->set_attribute('bereiche', ModuleDB::GetBereiche($lehreinheit));
		$template->set_attribute('links', array(
			'edit'=>self::GetLink('edit', array('bereich_id'=>'%s')),
			'submit'=>self::GetLink(),
			'create'=>self::GetLink('create', compact('lehreinheit')),
		));
	}

	public static function bereich_create_POST()
	{
		ModuleDB::CreateBereich($_POST['name'], $_POST['lehreinheit']);
		log_event('MOD_ADD_BEREICH', null, null, sprintf('Neuer Bereich "%s" der Lehreinheit "%s" wurde erzeugt', $_POST['name'], ModuleHelper::GetLehreinheitName($_POST['lehreinheit'])), null);
		self::Relocate('index', array(
			'lehreinheit'=>$_POST['lehreinheit'],
		));
	}

	public static function bereich_create(&$template)
	{
		$template->set_attribute('lehreinheit', $_REQUEST['lehreinheit']);
	}

	public static function bereich_edit_POST()
	{
		$bereich = ModuleDB::GetBereich($_REQUEST['bereich_id']);

		log_event('MOD_EDIT_BEREICH', null, null, sprintf('Bereich "%s" der Lehreinheit "%s" wurde in "%s" umbenannt', ModuleHelper::GetBereichName($_REQUEST['bereich_id']), ModuleHelper::GetLehreinheitName($bereich['le_id']), $_REQUEST['name']), null);

		ModuleDB::UpdateBereich($_REQUEST['bereich_id'], $_REQUEST['name']);

		self::Relocate('index', array(
			'lehreinheit'=>$bereich['le_id'],
		));
	}

	public static function bereich_edit(&$template)
	{
		$id = $_REQUEST['bereich_id'];
		$bereich = ModuleDB::GetBereich($id);

		$template->set_attribute('bereich', $bereich);
		$template->set_attribute('links', array(
			'submit'=>self::GetLink(),
			'cancel'=>self::GetLink('index', array('lehreinheit'=>$bereich['le_id'])),
		));
	}

	public static function schwerpunkt_index(&$template)
	{
		if (!empty($_POST['action']))
		{
			switch ($_POST['action'])
			{
				case 'delete':
					log_event('MOD_DEL_SCHWERPUNKT', null, null, sprintf('%d Schwerpunkte der Lehreinheit "%s" wurden gel�scht', count($_POST['schwerpunkt_ids']), ModuleHelper::GetLehreinheitName($_REQUEST['lehreinheit'])), null);
					ModuleDB::DeleteSchwerpunkt($_POST['schwerpunkt_ids']);
				break;
				default:
				break;
			}
			self::Relocate('index', array(
				'lehreinheit'=>$_REQUEST['lehreinheit'],
			));
		}

		$lehreinheiten = ModulVerwaltungDB::getLehreinheiten(self::$parent->user->userid, self::$parent->permissions->hasRootPermission(), true);
		$mapping = ModuleHelper::MapSemTreeLehreinheiten(array_keys($lehreinheiten));
		foreach ($lehreinheiten as $id=>$value)
		{
			unset($lehreinheiten[$id]);
			$lehreinheiten[ $mapping[$id] ] = $value;
		}
		$lehreinheit = isset($_REQUEST['lehreinheit'])
			? $_REQUEST['lehreinheit']
			: key($lehreinheiten);

		$template->set_attribute('lehreinheiten', $lehreinheiten);
		$template->set_attribute('lehreinheit', $lehreinheit);
		$template->set_attribute('schwerpunkte', ModuleDB::GetSchwerPunkte($lehreinheit));
		$template->set_attribute('links', array(
			'edit'=>self::GetLink('edit', array('schwerpunkt_id'=>'%s')),
			'submit'=>self::GetLink(),
			'create'=>self::GetLink('create', compact('lehreinheit')),
		));
	}

	public static function schwerpunkt_create_POST()
	{
		log_event('MOD_ADD_SCHWERPUNKT', null, null, sprintf('Neuer Schwerpunkt "%s" der Lehreinheit "%s" wurde erzeugt', $_POST['name'], ModuleHelper::GetLehreinheitName($_POST['lehreinheit'])), null);
		ModuleDB::CreateSchwerpunkt($_POST['name'], $_POST['lehreinheit']);
		self::Relocate('index', array(
			'lehreinheit'=>$_POST['lehreinheit'],
		));
	}

	public static function schwerpunkt_create(&$template)
	{
		$template->set_attribute('lehreinheit', $_REQUEST['lehreinheit']);
	}

	public static function schwerpunkt_edit_POST()
	{
		$schwerpunkt = ModuleDB::GetSchwerpunkt($_REQUEST['schwerpunkt_id']);

		log_event('MOD_EDIT_SCHWERPUNKT', null, null, sprintf('Schwerpunkt "%s" der Lehreinheit "%s" wurde in "%s" umbenannt', ModuleHelper::GetSchwerpunktName($_REQUEST['schwerpunkt_id']), ModuleHelper::GetLehreinheitName($schwerpunkt['le_id']), $_REQUEST['name']), null);

		ModuleDB::UpdateSchwerpunkt($_REQUEST['schwerpunkt_id'], $_REQUEST['name']);

		self::Relocate('index', array(
			'lehreinheit'=>$schwerpunkt['le_id'],
		));
	}

	public static function schwerpunkt_edit(&$template)
	{
		$id = $_REQUEST['schwerpunkt_id'];
		$schwerpunkt = ModuleDB::GetSchwerpunkt($id);

		$template->set_attribute('schwerpunkt', $schwerpunkt);
		$template->set_attribute('links', array(
			'submit'=>self::GetLink(),
			'cancel'=>self::GetLink('index', array('lehreinheit'=>$schwerpunkt['le_id'])),
		));
	}

/** HELPER FUNCTIONS **/

	private static function GetLink($link = null, $parameters = array())
	{
		if ($link === null)
			$link = self::$action;
		$link = PluginEngine::getLink(self::$parent, array_merge(array('function'=>$link, 'ma_tab'=>self::$tab), $parameters), 'adminModules');
		$link = str_replace(array('&amp;', urlencode('%s'), urlencode('|'), urlencode('[]')), array('&', '%s', '|', '[]'), $link);
		return $link;
	}

	private static function GetTemplate($name)
	{
		$template_file = 'ma_'.$name;
		$path = dirname(__FILE__).'/../templates/';

		if (self::$template_factory === null)
			self::$template_factory = new Flexi_TemplateFactory($path);

		return count(glob($path.$template_file.'.*'))
			? self::$template_factory->open($template_file)
			: false;
	}

	private static function Relocate($action, $parameters = array())
	{
		$link = self::GetLink($action, $parameters).'#form';
		$link = str_replace('&amp;', '&', $link);

		$link = sprintf('http%s://%s%s',
			$_SERVER['SERVER_PORT'] == 80 ? '' : 's',
			$_SERVER['HTTP_HOST'],
			$link
		);

		ob_end_clean();
		Header('Location: '.$link);
		flush();

		die;
	}

	private static function ReportError($message/*, $parameter, ...*/)
	{
		$arguments = func_get_args();
		array_unshift($arguments, 'error');
		call_user_func_array(array('self', 'ReportMessage'), $arguments);
	}

	private static function ReportSuccess($message/*, $parameter, ...*/)
	{
		$arguments = func_get_args();
		array_unshift($arguments, 'success');
		call_user_func_array(array('self', 'ReportMessage'), $arguments);
	}

	private static function ReportMessage($type, $message/*, $parameter, ...*/)
	{
		$arguments = func_get_args();
		$type = array_shift($arguments);
		$message = sprintf(array_shift($arguments), $arguments);

		if (!isset($_SESSION['ma_messages']))
			$_SESSION['ma_messages'] = array();
		if (!isset($_SESSION['ma_messages'][$type]))
			$_SESSION['ma_messages'][$type] = array();
		array_push($_SESSION['ma_messages'][$type], $message);
	}

	private static function GetMessages()
	{
		$messages = $_SESSION['ma_messages'];
		$_SESSION['ma_messages'] = array();
		return $messages;
	}
}
?>