<?php
class ModuleDB
{
	private static $statement_cache = array();

	private static function &GetStatement($query)
	{
		$hash = md5($query);

		if (!isset(self::$statement_cache[$hash]))
			self::$statement_cache[$hash] = DBManager::Get()->prepare($query);

		$statement = self::$statement_cache[$hash];
		$statement->closeCursor();

		return $statement;
	}

	public static function IsConcrete($module_id, $semester=null)
	{
		return $semester===null
			? DBManager::Get()->query("SELECT 1 FROM module WHERE modul_kon_id='{$module_id}'")->fetchColumn()
			: DBManager::Get()->query("SELECT 1 FROM module m JOIN mod_zuordnung mz ON (m.modul_abst_id=mz.modul_abst_id AND mz.sem_tree_id='{$module_id}') WHERE modul_kon_id='{$module_id}' AND semester='{$semester}'")->fetchColumn();
	}

	public static function Load($id, $sem_tree_ids = null)
	{
		$return_array = is_array($id);

		$query = is_null($sem_tree_ids)
			? "SELECT modul_abst_id, stamm_id, sem_tree_id, fach_id, abschluss_id, lehreinheit_id, pruef_id, modulschluessel, modultitel, pruef_version, pruef_form, notenart, kp, fk_id FROM mod_zuordnung WHERE modul_abst_id IN ('".implode("','", (array)$id)."') OR sem_tree_id IN ('".implode("','", (array)$id)."') ORDER BY modulschluessel ASC, modultitel ASC, pruef_version ASC"
			: "SELECT modul_abst_id, stamm_id, sem_tree_id, fach_id, abschluss_id, lehreinheit_id, pruef_id, modulschluessel, modultitel, pruef_version, pruef_form, notenart, kp, fk_id FROM mod_zuordnung WHERE modul_abst_id IN ('".implode("','", (array)$id)."') AND sem_tree_id IN ('".implode("','", (array)$sem_tree_ids)."') ORDER BY modulschluessel ASC, modultitel ASC, pruef_version ASC";

		$statement = DBManager::Get()->query($query);

		$result = array();
		// Ugly, i know
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[ $row['modul_abst_id'] ] = array(
				'id'=>$row['modul_abst_id'],
				'stamm_id'=>$row['stamm_id'],
				'sem_tree_id'=>$row['sem_tree_id'],
				'fach_id'=>$row['fach_id'],
				'abschluss_id'=>$row['abschluss_id'],
				'lehreinheit_id'=>$row['lehreinheit_id'],
				'pruef_id'=>$row['pruef_id'],
				'modulschluessel'=>$row['modulschluessel'],
				'modultitel'=>$row['modultitel'],
				'pruef_version'=>$row['pruef_version'],
				'pruef_form'=>$row['pruef_form'],
				'notenart'=>$row['notenart'],
				'kp'=>$row['kp'],
				'fk_id'=>$row['fk_id']
			);

		return $return_array
			? $result
			: reset($result);
	}

	public static function LoadConcrete($id)
	{
		if (is_array($id))
		{
			$result = array();
			foreach ($id as $module_id)
				$result[$module_id] = self::LoadConcrete($module_id);

			uasort($result, create_function('$a,$b', 'return strcmp($a["modulschluessel"], $b["modulschluessel"]);'));
			return $result;
		}
		// Konkrete Daten laden
		$result = DBManager::Get()->query("SELECT modul_abst_id, semester, modul_kon_id, desk_id, komplett, kp, letzteAenderung, aktiv, user_id, notenart, pruef_form, pruef_links, pruef_zeiten, mok, institut_id, strukturschluessel FROM module WHERE modul_kon_id='{$id}'");
		if (!$result->rowCount())
			return false;

		$module = $result->fetch(PDO::FETCH_ASSOC);

		// Abstrakte Daten laden
		$result = DBManager::Get()->query("SELECT fach_id, abschluss_id, fk_id, stamm_id, sem_tree_id, lehreinheit_id, pruef_id, modulschluessel, modultitel, pruef_version FROM mod_zuordnung WHERE modul_abst_id='{$module['modul_abst_id']}'");
		if (!$result->rowCount())
			return false;

		$module = array_merge($module, $result->fetch(PDO::FETCH_ASSOC));

		// Deskriptor laden
		$result = DBManager::Get()->query("SELECT bezeichnung, belegungszeitpunkt, turnus, level_id, typ_id, dauer, lehrform_kommentar, anmeldeformalitaeten, inhalte, ziele, kommentar, literatur, teilnahmevoraussetzungen, vorkenntnisse, verknuepftMitModulen, zulassungsbedingungen, url, unbeschraenkt, praesenzzeit, untertitel, language FROM modul_deskriptor WHERE desk_id='{$module['desk_id']}'");
		if ($result->rowCount())
			$module['deskriptor'] = (array)$result->fetch(PDO::FETCH_ASSOC);

		$module['stamm_lehreinheit'] = DBManager::Get()->query("SELECT lehreinheit_id FROM lehreinheit WHERE institut_id='{$module['institut_id']}'")->fetchColumn();
		$module['lehrformen'] = self::QueryToArray("SELECT veranst_typ_id, sws FROM modul_lehrform WHERE modul_kon_id='{$id}' AND sws>0");
		$module['sprachen'] = self::QueryToArray("SELECT sprach_id FROM mod_sprach_zuord WHERE modul_kon_id='{$id}'");
		$module['verantwortliche'] = self::QueryToArray("SELECT user_id, verantwort_typ_id FROM mod_verantwort_zuord WHERE modul_kon_id='{$id}' ORDER BY position ASC");
		$module['fachsemester'] = self::QueryToArray("SELECT fachsem_id FROM mod_fachsem WHERE modul_kon_id='{$id}'");
		$module['schwerpunkte'] = self::QueryToArray("SELECT schwerpunkt_id FROM mod_schwerp_zuord WHERE modul_kon_id='{$id}'");
		$module['bereiche'] = self::QueryToArray("SELECT bereich_id FROM mod_bereich_zuord WHERE modul_kon_id='{$id}'");

		// Filter
		$user_ids = array_map(create_function('$a', 'return trim($a["user_id"]);'), $module['verantwortliche']);

		$statement = DBManager::Get()->query("SELECT a.user_id, CONCAT(IF(LENGTH(title_front)>0, CONCAT(title_front, ' '),''),Vorname,' ',Nachname,IF(LENGTH(title_rear)>0,CONCAT(' ',title_rear),'')) AS name FROM auth_user_md5 a LEFT JOIN user_info u ON a.user_id=u.user_id WHERE a.user_id IN ('".implode("','", $user_ids)."')");
		$user_names = array();
		foreach ($statement->fetchAll() as $row)
			$user_names[ $row['user_id'] ] = $row['name'];

		$verantwortliche = array();
		foreach ($module['verantwortliche'] as $item)
		{
			if (!isset($verantwortliche[ $item['verantwort_typ_id'] ]))
				$verantwortliche[ $item['verantwort_typ_id'] ] = array();
			$verantwortliche[ $item['verantwort_typ_id'] ][ $item['user_id'] ] = $user_names[ $item['user_id'] ];
		}
		$module['verantwortliche'] = $verantwortliche;

		return $module;
	}

	public static function GetModuleSemesters($modul_kon_id)
	{
		$statement = self::GetStatement("SELECT modul_abst_id FROM module WHERE modul_kon_id = ?");
		$statement->execute(array($modul_kon_id));
		$modul_abst_id = $statement->fetchColumn();

		$statement = self::GetStatement("SELECT semester FROM module WHERE modul_abst_id = ?");
		$statement->execute(array($modul_abst_id));
		return $statement->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetModuleIdBySemester($module_id, $semester_id)
	{
		$module_abst_id = DBManager::Get()->query("SELECT modul_abst_id FROM module WHERE modul_kon_id = '{$module_id}'")->fetchColumn();
		return self::SearchConcrete($module_abst_id, $semester_id);
	}

	public static function SearchConcrete($abst_id, $semester_id)
	{
		return DBManager::Get()->query("SELECT modul_kon_id FROM module WHERE (modul_abst_id = '{$abst_id}' OR modul_abst_id = (SELECT modul_abst_id FROM mod_zuordnung WHERE sem_tree_id = '{$abst_id}')) AND semester = '{$semester_id}'")->fetchColumn();
	}

	public static function LoadBySeminar($id)
	{
		$return_array = is_array($id);

		$statement = DBManager::Get()->query("SELECT modul_abst_id, stamm_id, sem_tree_id, fach_id, abschluss_id, lehreinheit_id, pruef_id, modulschluessel, modultitel, pruef_version, pruef_form, notenart, kp, fk_id FROM mod_zuordnung WHERE sem_tree_id IN ('".implode("','", (array)$id)."') ORDER BY modulschluessel ASC");

		$result = array();
		// Ugly, i know
		foreach ($statement->fetchAll() as $row)
			$result[ $row['modul_abst_id'] ] = array(
				'id'=>$row['modul_abst_id'],
				'stamm_id'=>$row['stamm_id'],
				'sem_tree_id'=>$row['sem_tree_id'],
				'fach_id'=>$row['fach_id'],
				'abschluss_id'=>$row['abschluss_id'],
				'lehreinheit_id'=>$row['lehreinheit_id'],
				'pruef_id'=>$row['pruef_id'],
				'modulschluessel'=>$row['modulschluessel'],
				'modultitel'=>$row['modultitel'],
				'pruef_version'=>$row['pruef_version'],
				'pruef_form'=>$row['pruef_form'],
				'notenart'=>$row['notenart'],
				'kp'=>$row['kp'],
				'fk_id'=>$row['fk_id'],
			);

		return $return_array
			? $result
			: reset($result);
	}

	public static function GetIdsByLehreinheit($lehreinheit)
	{
		$lehreinheit = ($return_array = is_array($lehreinheit))
			? $lehreinheit
			: array($lehreinheit);

		$query = "SELECT lehreinheit_id, modul_abst_id FROM mod_zuordnung WHERE lehreinheit_id IN ('".implode("','", $lehreinheit)."')";
//		echo $query;

		$statement = DBManager::Get()->quey("SELECT lehreinheit_id, modul_abst_id FROM mod_zuordnung WHERE lehreinheit_id IN ('".implode("','", $lehreinheit)."')");

		$result = array();
		foreach ($statement->fetchAll() as $row)
		{
			if (!isset($result[ $row['lehreinheit_id'] ]))
				$result[ $row['lehreinheit_id'] ] = array();
			array_push($result[ $row['lehreinheit_id'] ], $row['modul_abst_id']);
		}

		return $return_array
			? $result
			: array_shift($result);
	}

	public static function GetAbstractIds($sem_tree_ids)
	{
		return DBManager::Get()->query("SELECT modul_abst_id FROM mod_zuordnung WHERE sem_tree_id IN ('".implode("','", $sem_tree_ids)."')")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetConcreteIds($abstract_ids, $semester, $institute_ids = null, $inclusive = true)
	{
		if ($institute_ids === null)
			$query = "SELECT modul_abst_id, modul_kon_id FROM module LEFT JOIN mod_zuordnung USING(modul_abst_id) WHERE modul_abst_id IN ('".implode("','", $abstract_ids)."') AND semester='{$semester}' ORDER BY modulschluessel ASC, modultitel ASC, pruef_version ASC";
		elseif ($inclusive)
			$query = "SELECT modul_abst_id, modul_kon_id FROM module LEFT JOIN mod_zuordnung USING(modul_abst_id) WHERE modul_abst_id IN ('".implode("','", $abstract_ids)."') AND institut_id IN ('".implode("','", $institute_ids)."') AND semester='{$semester}' ORDER BY modulschluessel ASC, modultitel ASC, pruef_version ASC";
		else
			$query = "SELECT modul_abst_id, modul_kon_id FROM module LEFT JOIN mod_zuordnung USING(modul_abst_id) WHERE (modul_abst_id IN ('".implode("','", $abstract_ids)."') OR institut_id IN ('".implode("','", $institute_ids)."')) AND semester='{$semester}' ORDER BY modulschluessel ASC, modultitel ASC, pruef_version ASC";

		$rows = DBManager::Get()->query($query)->fetchAll(PDO::FETCH_ASSOC);

		$ids = array();
		foreach ($rows as $row)
			$ids[ $row['modul_kon_id'] ] = $row['modul_abst_id'];

		return $ids;
	}

	private static function StripId($id)
	{
		return ltrim($id, '0x'); // F�hrendes x und f�hrende 0en entfernen
	}

	private static function GetStructureKey($module)
	{
		return sprintf('%u.%u.%u.%u.%u',
			self::StripId($module['fk_id']),
			self::StripId($module['lehreinheit_id']),
			self::StripId($module['fach_id']),
			self::StripId($module['abschluss_id']),
			self::StripId($module['id'])
		);
	}

	public static function CreateConcreteModule($modul_abst_id, $semester_id, $institut_id, $user_id)
	{
		$module = self::Load($modul_abst_id);

		$modul_kon_id = md5(uniqid('concrete_module', true));
		$modul_desk_id = md5(uniqid('module_descriptor', true));
		$strukturschluessel = self::GetStructureKey($module);

		$statement = self::GetStatement("INSERT INTO module (modul_kon_id, modul_abst_id, desk_id, komplett, semester, kp, letzteAenderung, aktiv, user_id, notenart, pruef_form, pruef_zeiten, pruef_links, mok, institut_id, strukturschluessel) VALUES (?, ?, ?, 0, ?, ?, UNIX_TIMESTAMP(), 0, ?, ?, ?, '', ?, '', ?, ?)");

		$statement->execute(array(
			$modul_kon_id,
			$modul_abst_id,
			$modul_desk_id,
			$semester_id,
			$module['kp'],
			$user_id,
			$module['notenart'],
			$module['pruef_form'],
			$module['pruef_links'],
			$institut_id,
			$strukturschluessel
		));
		if (!$statement->rowCount())
			return false;

		$description = $module['modulschluessel'].' '.$module['modultitel'];

		$statement = self::GetStatement("INSERT INTO modul_deskriptor (desk_id, bezeichnung) VALUES (?, ?)");
		$statement->execute(array(
			$modul_desk_id,
			$description
		));

		return $statement->rowCount()>0;
	}

	public static function RemoveConcreteModule($concrete_id)
	{
		$failures = 0;

		$tables = array(
			'mod_fachsem',
			'modul_lehrform',
			'mod_sprach_zuord',
			'mod_schwerp_zuord',
			'mod_bereich_zuord',
			'module',
		);

		$desk_id = DBManager::Get()->query("SELECT desk_id FROM module WHERE modul_kon_id IN ('".implode("','", (array)$concrete_id)."')")->fetchAll(PDO::FETCH_COLUMN);

		foreach ($tables as $table)
			foreach ((array)$concrete_id as $id)
			{
				$statement = DBManager::Get()->query("DELETE FROM {$table} WHERE modul_kon_id='{$id}'");
				$failures += (int)($statement->rowCount()==0);
			}

		foreach ($desk_id as $id)
			if (!DBManager::Get()->query("SELECT COUNT(*) FROM module WHERE desk_id='{$id}'")->fetchColumn())
			{
				$statement = DBManager::Get()->query("DELETE FROM modul_deskriptor WHERE desk_id='{$id}'");
				$failures += (int)($statement->rowCount()==0);
			}

		return $failures==0;
	}

	public static function UpdateConcreteModule($module_id, $field, $value, $user_id)
	{
		$statement = self::GetStatement("UPDATE module SET `{$field}` = ?, user_id = ?, letzteAenderung = UNIX_TIMESTAMP() WHERE modul_kon_id = ?");
		foreach ( (array)$module_id as $id)
			$statement->execute(array(
				$value,
				$user_id,
				$id
			));
	}

	public static function GetIds($user_id = null, $roles = null)
	{
		if ($user_id === null)
		{
			$statement = DBManager::Get()->query("SELECT modul_abst_id FROM mod_zuordnung");

			$ids = array();
			foreach ($statement->fetchAll() as $row)
				array_push($ids, $row['modul_abst_id']);
			return $ids;
		}

		$lehreinheiten = ModulVerwaltungDB::getLehreinheiten($user_id);
	}

	public static function GetSchwerpunkt($id)
	{
		$statement = DBManager::Get()->prepare("SELECT schwerpunkt_id, bezeichnung, le_id FROM modul_schwerpunkt WHERE schwerpunkt_id=?");
		$statement->execute(array($id));
		return $statement->fetch(PDO::FETCH_ASSOC);
	}

	public static function CreateSchwerpunkt($name, $lehreinheit)
	{
		$statement = self::GetStatement("INSERT INTO modul_schwerpunkt (bezeichnung, le_id) VALUES (?, ?)");
		$statement->execute(array(
			$name,
			$lehreinheit,
		));
	}

	public static function UpdateSchwerpunkt($id, $name)
	{
		$statement = self::GetStatement("UPDATE modul_schwerpunkt SET bezeichnung = ? WHERE schwerpunkt_id = ?");
		$statement->execute(array(
			$name,
			$id,
		));
	}

	public static function DeleteSchwerpunkt($id)
	{
		$statement = self::GetStatement("DELETE FROM modul_schwerpunkt WHERE schwerpunkt_id = ?");
		foreach ( (array)$id as $schwerpunkt_id)
			$statement->execute(array(
				$schwerpunkt_id,
			));
	}

	public static function GetSchwerPunkte($lehreinheit_id)
	{
		return self::QueryToAssociativeArray(
			"SELECT schwerpunkt_id, bezeichnung FROM modul_schwerpunkt WHERE le_id='{$lehreinheit_id}' ORDER BY TRIM(bezeichnung) ASC",
			'schwerpunkt_id',
			'bezeichnung'
		);
	}

	public static function GetBereich($id)
	{
		$statement = self::GetStatement("SELECT bereich_id, bezeichnung, le_id FROM modul_bereich WHERE bereich_id=?");
		$statement->execute(array($id));

		return $statement->fetch(PDO::FETCH_ASSOC);
	}

	public static function CreateBereich($name, $lehreinheit)
	{
		$statement = self::GetStatement("INSERT INTO modul_bereich (bezeichnung, le_id) VALUES (?, ?)");
		$statement->execute(array(
			$name,
			$lehreinheit,
		));
	}

	public static function UpdateBereich($id, $name)
	{
		$statement = self::GetStatement("UPDATE modul_bereich SET bezeichnung = ? WHERE bereich_id = ?");
		$statement->execute(array(
			$name,
			$id,
		));
	}

	public static function DeleteBereich($id)
	{
		$statement = self::GetStatement("DELETE FROM modul_bereich WHERE bereich_id = ?");
		foreach ( (array)$id as $bereich_id)
			$statement->execute(array(
				$bereich_id,
			));
	}
	public static function GetBereiche($lehreinheit_id)
	{
		return self::QueryToAssociativeArray(
			"SELECT bereich_id, bezeichnung FROM modul_bereich WHERE le_id='{$lehreinheit_id}' ORDER BY TRIM(bezeichnung) ASC",
			'bereich_id',
			'bezeichnung'
		);
	}

	public static function GetLevel()
	{
		return self::QueryToAssociativeArray(
			"SELECT level_id, bezeichnung FROM modul_level ORDER BY TRIM(bezeichnung) ASC",
			'level_id',
			'bezeichnung'
		);
	}

	public static function GetType()
	{
		return self::QueryToAssociativeArray(
			"SELECT typ_id, bezeichnung FROM modul_typ ORDER BY TRIM(bezeichnung) ASC",
			'typ_id',
			'bezeichnung'
		);
	}

	public static function GetSprachen()
	{
		return self::QueryToAssociativeArray(
			"SELECT sprach_id, bezeichnung FROM modul_sprache ORDER BY sprach_id ASC",
			'sprach_id',
			'bezeichnung'
		);
	}

	public static function GetVeranstaltungsTypen()
	{
		return self::QueryToAssociativeArray(
			"SELECT veranst_typ_id, bezeichnung, kuerzel FROM modul_veranstaltungstyp ORDER BY veranst_typ_id ASC",
			'veranst_typ_id',
			array('bezeichnung', 'kuerzel')
		);
	}

	public static function GetVerantwortliche()
	{
		return self::QueryToAssociativeArray(
			"SELECT verantwort_typ_id, bezeichnung FROM modul_verantwortliche ORDER BY verantwort_typ_id ASC",
			'verantwort_typ_id',
			'bezeichnung'
		);
	}

	private static function QueryToArray($query, $shrink = true)
	{
		$array = array();

		$result = DBManager::Get()->query($query);
		while ($row = $result->fetch(PDO::FETCH_ASSOC))
		{
			if ($shrink and (count($row)==1))
				$row = array_shift($row);
			array_push($array, $row);
		}
		return $array;
	}

	private static function QueryToAssociativeArray($query, $key_field, $value_field)
	{
		$array = array();

		$result = DBManager::Get()->query($query);
		while ($row = $result->fetch(PDO::FETCH_ASSOC))
			if (is_array($value_field))
			{
				$inner_array = array();
				foreach ($value_field as $f)
					$inner_array[$f] = $row[$f];
				$array[ $row[$key_field] ] = $inner_array;
			}
			else
				$array[ $row[$key_field] ] = $row[$value_field];

		return $array;
	}

///////////////////

	public static function SearchModules($needle, $semester, $fachsemester)
	{
		$semesters = empty($semester)
			? array_keys(ModuleHelper::GetSemesters())
			: array($semester);

		$abst_ids = array();

		$result = array();
		$statement = DBManager::Get()->query("SELECT DISTINCT modul_abst_id, m.modul_kon_id, semester, fachsem_id FROM mod_zuordnung mz LEFT JOIN module m USING (modul_abst_id) LEFT JOIN modul_deskriptor md ON m.desk_id=md.desk_id LEFT JOIN mod_fachsem mf ON m.modul_kon_id=mf.modul_kon_id WHERE modultitel LIKE '%{$needle}%' OR mz.modulschluessel LIKE '%{$needle}%' OR mz.strukturschluessel LIKE '%{$needle}%' OR bezeichnung LIKE '%{$needle}%' OR inhalte LIKE '%{$needle}%' OR ziele LIKE '%{$needle}%' OR CONCAT(mz.modulschluessel,' ',mz.modultitel,' [',mz.pruef_version,']') LIKE '%{$needle}%' ORDER BY mz.modulschluessel ASC, mz.modultitel ASC, mz.pruef_version ASC");
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			if (empty($row['modul_kon_id']))
				foreach ($semesters as $semester_id)
				{
					if (!isset($result[$semester_id]))
						$result[$semester_id] = array();
					$result[$semester_id][$row['modul_abst_id']] = array('concrete'=>array(), 'seminars'=>array());
				}
			elseif (in_array($row['semester'], $semesters) and (empty($fachsemester) or $row['fachsem_id']==$fachsemester))
			{
				if (!isset($result[$row['semester']]))
					$result[$row['semester']] = array();
				$result[$row['semester']][$row['modul_abst_id']] = array('concrete'=>array($row['modul_kon_id']), 'seminars'=>array());
			}

		foreach ($result as $semester_id=>$module_data)
			foreach ($module_data as $abst_id=>$data)
				$result[$semester_id][$abst_id]['seminars'] = DBManager::Get()->query("SELECT DISTINCT sst.seminar_id FROM mod_zuordnung mz JOIN seminar_sem_tree sst ON mz.sem_tree_id=sst.sem_tree_id JOIN seminare s ON sst.seminar_id=s.seminar_id JOIN semester_data sd ON (sd.semester_id='{$semester_id}' AND s.start_time BETWEEN sd.beginn AND sd.ende) WHERE modul_abst_id='{$abst_id}' AND visible=1 ORDER BY VeranstaltungsNummer ASC, s.Name ASC")->fetchAll(PDO::FETCH_COLUMN);

		ksort($result);
		return array_reverse($result, true);
	}

	public static function GetStudienGaengeForModule($abst_id)
	{
		return DBManager::Get()->query("SELECT CONCAT(s.name, ' (', IF(m.fach_id='x0000000000000000000000000000900' AND m.abschluss_id='x0000000000000000000000000000019' AND m.lehreinheit_id='x0000000000000000000000000000099' , REPLACE(a.name, 'Zwei-Fcher-Bachelor', 'Fach- und Zwei-Fcher-Bachelor'), a.name), ')') AS name FROM mod_zuordnung m JOIN abschluss a ON (m.abschluss_id=a.abschluss_id) JOIN studiengaenge s ON (m.fach_id=s.studiengang_id) JOIN sem_tree st ON (st.sem_tree_id=m.sem_tree_id) WHERE st.sem_tree_id IS NOT NULL AND '{$abst_id}' IN (modul_abst_id, m.sem_tree_id) ORDER BY name ASC")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetSeminarDataForModule($module_id, $semester_id)
	{
		return DBManager::Get()->query("SELECT DISTINCT sst.seminar_id, VeranstaltungsNummer, s.Name, art FROM mod_zuordnung mz JOIN seminar_sem_tree sst ON mz.sem_tree_id=sst.sem_tree_id JOIN seminare s ON sst.seminar_id=s.seminar_id JOIN semester_data sd ON (sd.semester_id='{$semester_id}' AND s.start_time BETWEEN sd.beginn AND sd.ende) WHERE mz.modul_abst_id='{$module_id}' ORDER BY VeranstaltungsNummer ASC, Name ASC")->fetchAll(PDO::FETCH_ASSOC);
	}

	public static function GetSeminarDataForKonModule($module_id)
	{
		$result = DBManager::Get()->query("SELECT DISTINCT modul_abst_id, semester FROM module WHERE modul_kon_id='{$module_id}'")->fetch(PDO::FETCH_ASSOC);
		return self::GetSeminarDataForModule($result['modul_abst_id'], $result['semester']);
	}

	public static function GetModulesForSeminar($seminar_id)
	{
		return DBManager::Get()->query("SELECT DISTINCT m.modul_kon_id FROM seminar_sem_tree sst JOIN mod_zuordnung mz ON sst.sem_tree_id=mz.sem_tree_id JOIN module m ON mz.modul_abst_id=m.modul_abst_id JOIN seminare s ON sst.seminar_id=s.seminar_id JOIN semester_data sd ON m.semester=sd.semester_id WHERE sst.seminar_id='{$seminar_id}' AND s.start_time BETWEEN sd.beginn AND sd.ende ORDER BY mz.modulschluessel ASC, modultitel ASC")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetLatestModuleIds($quantity)
	{
		return DBManager::Get()->query("SELECT modul_kon_id FROM module ORDER BY letzteAenderung DESC LIMIT {$quantity}")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetZuordnung($objekt_id, $type = null)
	{
		$query = "SELECT name FROM struktur_zuordnung WHERE objekt_id='{$objekt_id}'";
		if ($type === 'lehreinheit')
			$query = "SELECT i0.Name FROM lehreinheit l JOIN Institute i ON l.institut_id=i.Institut_id JOIN Institute i0 ON i.fakultaets_id=i0.Institut_id WHERE l.lehreinheit_id='{$objekt_id}'";
		elseif ($type === 'institut')
			$query = "SELECT i.Name FROM lehreinheit l JOIN Institute i ON l.institut_id=i.Institut_id WHERE l.lehreinheit_id='{$objekt_id}'";
		return DBManager::Get()->query($query)->fetchColumn();
	}

	public static function GetSemestersAndModulesAndSeminareBySemTreeId($sem_tree_ids)
	{
		$data = array();

		$result = DBManager::Get()->query("SELECT DISTINCT sd.semester_id, mz.modul_abst_id, m.modul_kon_id, m.aktiv FROM seminar_sem_tree sst JOIN seminare s ON sst.seminar_id=s.seminar_id JOIN semester_data sd ON s.start_time BETWEEN sd.beginn AND sd.ende JOIN mod_zuordnung mz ON sst.sem_tree_id=mz.sem_tree_id LEFT JOIN module m ON (m.modul_abst_id=mz.modul_abst_id AND m.semester=sd.semester_id) WHERE sst.sem_tree_id IN ('".implode("','", $sem_tree_ids)."') AND visible=1 ORDER BY semester_id DESC, mz.modulschluessel ASC, mz.modultitel ASC, mz.pruef_version ASC, s.VeranstaltungsNummer ASC, s.Name ASC");

		foreach ($result->fetchAll(PDO::FETCH_ASSOC) as $row)
		{
			if (!isset($data[ $row['semester_id'] ]))
				$data[ $row['semester_id'] ] = array();
			if (!isset($data[ $row['semester_id'] ][ $row['modul_abst_id'] ]))
				$data[ $row['semester_id'] ][ $row['modul_abst_id'] ] = array(
					'concrete' => array(),
					'seminars' => array(),
				);
			if (!empty($row['modul_kon_id']) and $row['aktiv'] and !in_array($row['modul_kon_id'], $data[ $row['semester_id'] ][ $row['modul_abst_id'] ]['concrete']))
				array_push($data[ $row['semester_id'] ][ $row['modul_abst_id'] ]['concrete'], $row['modul_kon_id']);
		}

		foreach ($data as $semester_id => $entries)
			foreach ($entries as $abst_id => $row)
				$data[$semester_id][$abst_id]['seminars'] = DBManager::Get()->query("SELECT DISTINCT sst.seminar_id FROM mod_zuordnung mz JOIN seminar_sem_tree sst ON mz.sem_tree_id=sst.sem_tree_id JOIN seminare s ON sst.seminar_id=s.seminar_id JOIN semester_data sd ON (sd.semester_id='{$semester_id}' AND s.start_time BETWEEN sd.beginn AND sd.ende) WHERE modul_abst_id='{$abst_id}' AND visible=1 ORDER BY VeranstaltungsNummer ASC, s.Name ASC")->fetchAll(PDO::FETCH_COLUMN);

		return $data;
	}

	public static function GetLehreinheitenForForeignModules($user_id)
	{
		$statement = DBManager::Get()->query("SELECT st.sem_tree_id, st.name FROM module m JOIN mod_zuordnung mz USING(modul_abst_id) JOIN lehreinheit l ON l.lehreinheit_id=mz.lehreinheit_id JOIN struktur_zuordnung sz ON (l.lehreinheit_id=sz.objekt_id AND sz.typ=2) JOIN sem_tree st ON sz.sem_tree_id=st.sem_tree_id WHERE m.institut_id IN (SELECT Institut_id FROM user_inst u WHERE user_id='{$user_id}' AND inst_perms='admin') AND m.institut_id!=l.institut_id AND st.`name`!='Professionalisierungsbereich' ORDER BY st.name");

		$result = array();
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[ $row['sem_tree_id'] ] = $row['name'];
		return $result;
	}

	public static function GetFaecherForForeignLehreinheit($user_id, $lehreinheit_id)
	{
		$statement = DBManager::Get()->query("SELECT st.sem_tree_id, st.name FROM module m JOIN mod_zuordnung mz USING(modul_abst_id) JOIN lehreinheit l ON l.lehreinheit_id=mz.lehreinheit_id JOIN struktur_zuordnung sz ON (l.lehreinheit_id=sz.objekt_id AND sz.typ=2) JOIN struktur_zuordnung sz0 ON (mz.fach_id=sz0.objekt_id AND sz0.typ=3) JOIN sem_tree st ON sz0.sem_tree_id=st.sem_tree_id WHERE m.institut_id IN (SELECT Institut_id FROM user_inst u WHERE user_id='{$user_id}' AND inst_perms='admin') AND m.institut_id!=l.institut_id AND sz.sem_tree_id='{$lehreinheit_id}' ORDER BY st.name");

		$result = array();
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[ $row['sem_tree_id'] ] = $row['name'];
		return $result;
	}

	public static function GetAbschluesseForForeignFach($user_id, $fach_id)
	{
		$statement = DBManager::Get()->query("SELECT st.sem_tree_id, st.name FROM module m JOIN mod_zuordnung mz USING(modul_abst_id) JOIN lehreinheit l ON l.lehreinheit_id=mz.lehreinheit_id JOIN struktur_zuordnung sz ON (l.lehreinheit_id=sz.objekt_id AND sz.typ=2) JOIN struktur_zuordnung sz0 ON (mz.fach_id=sz0.objekt_id AND sz0.typ=3) JOIN struktur_zuordnung sz1 ON (mz.abschluss_id=sz1.objekt_id AND sz1.typ=4) JOIN sem_tree st ON sz1.sem_tree_id=st.sem_tree_id WHERE m.institut_id IN (SELECT Institut_id FROM user_inst u WHERE user_id='{$user_id}' AND inst_perms='admin') AND m.institut_id!=l.institut_id AND sz0.sem_tree_id='{$fach_id}' AND st.parent_id='{$fach_id}' ORDER BY st.name");

		$result = array();
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[ $row['sem_tree_id'] ] = array('name'=>$row['name']);
		return $result;
	}

	public static function GetAbschluesseForModule($abst_id)
	{
		return DBManager::Get()->query("SELECT a.name FROM mod_zuordnung m JOIN abschluss a ON (m.abschluss_id=a.abschluss_id) WHERE modul_abst_id='{$abst_id}' ORDER BY name ASC")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetConcreteModulesByUserId($user_id)
	{
		return DBManager::Get()->query("SELECT modul_kon_id FROM module WHERE user_id='{$user_id}'")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetSemestersForConcreteModulesByUserId($user_id)
	{
		return DBManager::Get()->query("SELECT DISTINCT semester FROM module WHERE user_id='{$user_id}' ORDER BY semester DESC")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetModulesByInstituteId($institute_id, $semester_id = null)
	{
		return DBManager::Get()->query(
			$semester_id === null
				? "SELECT DISTINCT modul_kon_id FROM module WHERE institut_id='{$institute_id}'"
				: "SELECT DISTINCT modul_kon_id FROM module WHERE institut_id='{$institute_id}' AND semester='{$semester_id}'"
		)->fetchAll(PDO::FETCH_COLUMN);
	}
}
?>