<?php
class ModuleHelper
{
	public static function GetSemesterName($semester_id)
	{
		return DBManager::Get()->query("SELECT name FROM semester_data WHERE semester_id='{$semester_id}'")->fetchColumn();
	}

	public static function GetInstitutsName($institut_id)
	{
		return DBManager::Get()->query("SELECT Name FROM Institute WHERE Institut_id='{$institut_id}'")->fetchColumn();
	}

	public static function GetSemesters()
	{
		$semester_object = new SemesterData;

		$semesters = array();
		foreach ($semester_object->getAllSemesterData() as $semester_data)
			$semesters[ $semester_data['semester_id'] ] = $semester_data['name'];
		return array_reverse($semesters, true);
	}

	public static function GetCurrentSemester()
	{
		return DBManager::Get()->query("SELECT semester_id FROM semester_data WHERE UNIX_TIMESTAMP() BETWEEN beginn AND ende")->fetchColumn();
	}

	public static function GetSemestersForUser($user_id)
	{
		return DBManager::Get()->query("SELECT DISTINCT semester_id FROM seminar_user AS su LEFT JOIN seminare AS se USING(seminar_id) LEFT JOIN semester_data AS sd ON (se.start_time BETWEEN sd.beginn AND sd.ende) WHERE user_id='{$user_id}' ORDER BY beginn DESC")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetSemesterInfo($ids)
	{
		$statement = DBManager::Get()->query("SELECT semester_id, name FROM semester_data WHERE semester_id IN ('".implode("','", (array)$ids)."')");

		$result = array();
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[$row['semester_id']] = $row['name'];
		return $result;
	}

	public static function GetSeminarsForUserAndSemester($user_id, $semester_id)
	{
		return DBManager::Get()->query("SELECT DISTINCT seminar_id FROM seminar_user AS su LEFT JOIN seminare AS se USING(seminar_id) LEFT JOIN semester_data AS sd ON (se.start_time BETWEEN sd.beginn AND sd.ende) WHERE user_id='{$user_id}' AND semester_id='{$semester_id}'")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetInstitutesForUser($user_id, $include_prof=true)
	{
		$institutes = DBManager::Get()->query("SELECT DISTINCT Institut_id FROM Institute WHERE Institut_id IN (SELECT Institut_id FROM user_inst WHERE user_id='{$user_id}' AND inst_perms='admin') OR fakultaets_id IN (SELECT Institut_id FROM user_inst WHERE user_id='{$user_id}' AND inst_perms='admin') ORDER BY name ASC")->fetchAll(PDO::FETCH_COLUMN);
		if ($include_prof)
			$institutes = array_filter(array_unique(array_merge($institutes, (array)DBManager::get()->query("SELECT l.Institut_id FROM user_inst u LEFT JOIN lehreinheit l ON (u.Institut_id=l.institut_id OR l.name='Professionalisierungsbereich') WHERE user_id='{$user_id}' AND (inst_perms='admin' OR l.name='Professionalisierungsbereich') ORDER BY name ASC")->fetchColumn(PDO::FETCH_COLUMN))));
		return $institutes;
	}

/*
		return !DBManager::Get()->query("SELECT 1 FROM struktur_zuordnung sz LEFT JOIN lehreinheit l ON (sz.objekt_id=l.lehreinheit_id AND sz.typ=2) WHERE sz.sem_tree_id='{$lehreinheit_id}' AND (institut_id IN (SELECT DISTINCT Institut_id FROM Institute WHERE Institut_id IN (SELECT Institut_id FROM user_inst WHERE user_id='{$user_id}' AND inst_perms='admin') OR fakultaets_id IN (SELECT Institut_id FROM user_inst WHERE user_id='{$user_id}' AND inst_perms='admin')) OR l.name='Professionalisierungsbereich')")->fetchColumn();

*/

	public static function GetInstituteData($ids = null)
	{
		$query = "SELECT Institut_id, Name FROM Institute WHERE (type IN (5,50) OR Institut_id=fakultaets_id) AND NOT (type=7 AND Name='Verwaltung')";
		if (!is_null($ids))
			$query .= " AND Institut_id IN ('".implode("','", (array)$ids)."')";
		$query .= " ORDER BY fakultaets_id=Institut_id DESC, Name ASC";

		$statement = DBManager::Get()->query($query);

		$result = array();
		foreach ($statement->fetchAll() as $row)
			$result[ $row['Institut_id'] ] = $row['Name'];
		return (is_array($id) or is_null($id))
			? $result
			: array_shift($result);
	}

	public static function GetFacultyForInstitute($id)
	{
		$faculty_id = DBManager::Get()->query("SELECT fakultaets_id FROM Institute WHERE Institut_id = '{$id}'")->fetchColumn();
		return DBManager::Get()->query("SELECT Name FROM Institute WHERE Institut_id = '{$faculty_id}'")->fetchColumn();

	}

	public static function GetInstituteForLehreinheit($lehreinheit_id)
	{
		return DBManager::Get()->query("SELECT institut_id FROM struktur_zuordnung s LEFT JOIN lehreinheit l ON (s.objekt_id=l.lehreinheit_id) WHERE sem_tree_id='{$lehreinheit_id}'")->fetchColumn();
	}

	public static function GetLehreinheitName($id)
	{
		return DBManager::Get()->query("SELECT l.name FROM lehreinheit l LEFT JOIN struktur_zuordnung z ON (l.lehreinheit_id=z.objekt_id) WHERE '{$id}' IN (lehreinheit_id, sem_tree_id)")->fetchColumn();
	}

	public static function GetFachName($id, $module = null)
	{
		return is_null($module)
			? DBManager::Get()->query("SELECT name FROM struktur_zuordnung WHERE objekt_id='{$id}'")->fetchColumn()
			: DBManager::Get()->query("SELECT s2.name FROM sem_tree s0 LEFT JOIN sem_tree s1 ON (s0.parent_id=s1.sem_tree_id) LEFT JOIN sem_tree s2 ON (s1.parent_id=s2.sem_tree_id) WHERE s0.sem_tree_id='{$module['sem_tree_id']}'")->fetchColumn();
	}

	public static function GetAbschlussName($id, $module = null)
	{
		return is_null($module)
			? DBManager::Get()->query("SELECT name FROM struktur_zuordnung WHERE objekt_id='{$id}'")->fetchColumn()
			: DBManager::Get()->query("SELECT s1.name FROM sem_tree s0 LEFT JOIN sem_tree s1 ON (s0.parent_id=s1.sem_tree_id) WHERE s0.sem_tree_id='{$module['sem_tree_id']}'")->fetchColumn();
	}

	public static function GetLehreinheiten()
	{
		$statement = DBManager::Get()->query("SELECT lehreinheit_id, name FROM lehreinheit ORDER BY name ASC");

		$result = array();
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[ $row['lehreinheit_id'] ] = $row['name'];
		return $result;
	}

	public static function MapSemTreeLehreinheiten($ids)
	{
		$statement = DBManager::Get()->query("SELECT sem_tree_id, objekt_id FROM struktur_zuordnung WHERE sem_tree_id IN ('".implode("','", $ids)."')");

		$result = array();
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[ $row['sem_tree_id'] ] = $row['objekt_id'];
		return $result;
	}

	public static function GetUserName($user_id)
	{
		return DBManager::get()->query("SELECT username FROM auth_user_md5 WHERE user_id = '{$user_id}'")->fetchColumn();
	}

	public static function GetCompleteName($user_id)
	{
		return DBManager::Get()->query("SELECT CONCAT(IF(LENGTH(title_front)>0, CONCAT(title_front, ' '),''),Vorname,' ',Nachname,IF(LENGTH(title_rear)>0,CONCAT(' ',title_rear),'')) FROM auth_user_md5 a LEFT JOIN user_info u ON a.user_id=u.user_id WHERE a.user_id='{$user_id}'")->fetchColumn();
	}

	public static function GetFullName($user_id)
	{
		return DBManager::get()->query("SELECT CONCAT(Vorname, ' ', Nachname) AS name FROM auth_user_md5 WHERE user_id = '{$user_id}'")->fetchColumn();
	}

	public static function GetStudiengaenge()
	{
		$statement = DBManager::Get()->query("SELECT studiengang_id, name FROM studiengaenge ORDER BY name ASC");

		$result = array();
		foreach ($statement->fetchAll(PDO::FETCH_ASSOC) as $row)
			$result[ $row['studiengang_id'] ] = $row['name'];
		return $result;
	}

	public static function GetBereichName($id)
	{
		return DBManager::Get()->query("SELECT bezeichnung FROM modul_bereich WHERE bereich_id={$id}")->fetchColumn();
	}

	public static function GetSchwerpunktName($id)
	{
		return DBManager::Get()->query("SELECT bezeichnung FROM modul_schwerpunkt WHERE schwerpunkt_id={$id}")->fetchColumn();
	}

	public static function GetModulTypName($id)
	{
		return DBManager::Get()->query("SELECT bezeichnung FROM modul_typ WHERE typ_id={$id}")->fetchColumn();
	}

	public static function GetModulLevelName($id)
	{
		return DBManager::Get()->query("SELECT bezeichnung FROM modul_level WHERE level_id={$id}")->fetchColumn();
	}

	public static function GetSprachName($id)
	{
		return DBManager::Get()->query("SELECT bezeichnung FROM modul_sprache WHERE sprach_id={$id}")->fetchColumn();
	}

	public static function GetVeranstaltungstypName($id)
	{
		return DBManager::Get()->query("SELECT bezeichnung FROM modul_veranstaltungstyp WHERE veranst_typ_id={$id}")->fetchColumn();
	}

	public static function GetVeranstaltungstypKuerzel($id)
	{
		return DBManager::Get()->query("SELECT kuerzel FROM modul_veranstaltungstyp WHERE veranst_typ_id={$id}")->fetchColumn();
	}

	public static function GetDozentenForSeminar($seminar_id)
	{
		return DBManager::Get()->query("SELECT user_id FROM seminar_user WHERE Seminar_id = '{$seminar_id}' AND status = 'dozent' ORDER BY position")->fetchAll(PDO::FETCH_COLUMN);
	}

	public static function GetModuleLink($kon_id, $semester_id, $additional_parameters=array())
	{
/*
		return PluginEngine::getPlugin('studienmodulmanagement')->getModuleDescriptionLink($kon_id, $semester_id);
*/
		return PluginEngine::GetLink(new StudienmodulManagement(), array_merge($additional_parameters, array(
			'id'=>$kon_id,
			'semester'=>$semester_id,
			'action'=>'show_module'
		))).'" target="_blank';
	}

	public static function GetModuleName($data, $display_pruef_version = false)
	{
		$name = $data['modultitel'];
		if (!empty($data['modulschluessel']))
			$name = $data['modulschluessel'].' '.$name;
		if (!empty($data['mok']))
			$name = $data['mok'].' '.$name;
		if ($display_pruef_version and !empty($data['pruef_version']))
			$name .= ' ['.$data['pruef_version'].']';
		return $name;
	}

	public static function IsForeignLehreinheitForUser($lehreinheit_id, $user_id)
	{
		$query = "SELECT 1 FROM struktur_zuordnung sz LEFT JOIN lehreinheit l ON (sz.objekt_id=l.lehreinheit_id AND sz.typ=2) WHERE sz.sem_tree_id='{$lehreinheit_id}' AND (institut_id IN (SELECT DISTINCT Institut_id FROM Institute WHERE Institut_id IN (SELECT Institut_id FROM user_inst WHERE user_id='{$user_id}' AND inst_perms='admin') OR fakultaets_id IN (SELECT Institut_id FROM user_inst WHERE user_id='{$user_id}' AND inst_perms='admin')) OR l.name='Professionalisierungsbereich')";
		return !DBManager::Get()->query($query)->fetchColumn();
	}

	public static function GetPruefungsberechtigte($id = -1)
	{
		$pruefungsberechigte = array(
			1 => array(
				'title' => _('Pr&uuml;fungsberechtigte Lehrende der Fakult&auml;t I'),
				'link' => 'http://www.fk1.uni-oldenburg.de/37581.html',
			),
			3 => array(
				'title' => _('Pr&uuml;fungsberechtigte Lehrende der Fakult&auml;t III'),
				'link' => 'http://www.fk3.uni-oldenburg.de/40464.html',
			),
			4 => array(
				'title' => _('Pr&uuml;fungsberechtigte Lehrende der Fakult&auml;t IV'),
				'link' => 'http://www.fk4.uni-oldenburg.de/35533.html',
			),
		);

		return $id == -1
			? $pruefungsberechigte
			: (
				isset($pruefungsberechigte[$id])
				? $pruefungsberechigte[$id]
				: null
			);
	}
}
?>