<?php
/**
 * UniReader.class.php
 *
 * lange Beschreibung...
 *
 * PHP version 5
 *
 * @author  	Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @author		Mark Sievers <msievers@uos.de>
 * @package 	IBIT_ModulVerwaltungPlugin
 * @copyright 	2008 IBIT
 * @license 	http://www.gnu.org/licenses/gpl.html GPL Licence 3
 * @version 	0.1
 */
//Imports
require_once 'Reader.class.php';

/**
 * Enter description here...
 *
 */
class UniReader extends Reader
{
	public $all_stors;
	private $starttime;
	private $seminar_ids;

	public function __construct($starttime, $seminar_ids)
	{
		parent::__construct();
		$this->starttime = $starttime;
		$this->seminar_ids = $seminar_ids;
	}
	/**
	 * Gibt alle SeminarIDS zurck
	 *
	 * @return array()
	 */
	public function getAll()
	{
		return $this->seminar_ids;
	}

	/**
	 * Enter description here...
	 *
	 */
	public function setAllSeminars()
	{
		foreach($this->seminar_ids as $sem_id)
		{
			$this->setSeminar($sem_id);
		}
	}

	/**
	 * Erstellt eine eindeutige SeminarID
	 *
	 * @return md5
	 */
	function createSemID()
	{
		return md5(uniqid("seminarneu"));
	}

	function getDatafieldEntries($sem_id)
	{
		$db = DBManager::get();
		$result = $db->query("SELECT datafield_id,content,mkdate,chdate FROM datafields_entries WHERE range_id = '$sem_id'");
		if(!$result->rowCount())
		{
			return array();
		}
		return $result->fetchAll(PDO::FETCH_ASSOC);
	}

	function getSeminarContent($sem_id)
	{
		$db = DBManager::get();
		$result = $db->query("SELECT * FROM seminare WHERE seminar_id = '$sem_id'");
		if(!$result->rowCount())
		{
			return array();
		}

		$sem = $result->fetchAll(PDO::FETCH_ASSOC);
		return $sem[0];
	}

	private function getSeminarDozent($sem_id)
	{
		$db = DBManager::get();
		$result = $db->query("SELECT * FROM seminar_user WHERE seminar_id = '".$sem_id."' AND status='dozent'");
		if(!$result->rowCount())
		{
			return array();
		}
		else
		{
			return $result->fetchAll(PDO::FETCH_ASSOC);
		}
	}

	function getSeminarInst($sem_id)
	{
		$db = DBManager::get();
		$result = $db->query("SELECT * FROM seminar_inst WHERE seminar_id='$sem_id'");
		if(!$result->rowCount())
		{
			return array();
		}

		//TODO: dies geht so noch nciht...
		$seminar_inst_array = array();
		while($result->nextRowset())
		{
			$row = $result->fetch(PDO::FETCH_ASSOC);
			$seminar_inst_array[] = $row['institut_id'];
		}
		return $seminar_inst_array;
	}

	/**
	 * Enter description here...
	 *
	 * @param string $sem_id
	 * @return array()
	 */
	function getSeminarSemTree($sem_id)
	{
		$db = DBManager::get();
		$result = $db->query("SELECT * FROM seminar_sem_tree WHERE seminar_id = '".$sem_id."';");
		if(!$result->rowCount())
		{
			return array();
		}
		else
		{
			return $result->fetchAll(PDO::FETCH_ASSOC);
		}
	}

	/**
	 * wichtig: bei Importierten Veranstaltungen muss die Resource_id in den
	 * Metadaten leer sein, sonst gibts Probleme
	 *
	 * @param unknown_type $sem_content
	 * @return unknown
	 */
	function parseMetaDates($sem_content)
	{
		$metadates = unserialize($sem_content["metadata_dates"]);
		for($i=0; $i < count($metadates["turnus_data"]); $i++)
		{
			$metadates["turnus_data"][$i]["resource_id"] = "";
			$metadates["turnus_data"][$i]["room"] = "";
		}
		$metadates["start_termin"] =  -1; // Den von Hand gesetzten Start-Termin loeschen und
		$metadates["start_woche"] = 0; // Ersten Termin automatisch vergeben
		$ser_metadates = serialize($metadates);
		$sem_content["metadata_dates"] = $ser_metadates;
		return $sem_content;
	}

	/**
	 *  diese Funktion speichert eine Veranstaltung in die Storage Variable
	 *
	 * @param md5 $sem_id
	 */
	function setSeminar($sem_id)
	{
		unset($this->storage);
		$this->storage = new Storage();
		// SeminarContent in Storage speichern
		$sem_content = $this->getSeminarContent($sem_id);
		// wir muessen noch das metadates-array bearbeiten
		$sem_content = $this->parseMetaDates($sem_content);
		$this->storage->setSem($sem_content);
		// ab hier Einstellungen, die fuer die Kopie relevant sind
		$this->storage->setAdmissionStartTime('-1');
		$this->storage->setAdmissionEndTimeSem('-1');
		$this->storage->setAdmissionEndTime(NULL);
		$this->storage->setVisible(0);
		$this->storage->setMakeDate(time()); // mkdate anpassen
		$this->storage->setChangeDate(time()); // chdate anpassen
		$this->storage->setSeminarId(md5(uniqid("Multi-Import"))); // Wir setzen hier schon die neue Sem-Id
		$this->storage->setStartTime($this->starttime);

		// SeminarInst speichern
		$sem_inst = $this->getSeminarInst($sem_id);
		$this->storage->setSeminarInst($sem_inst);

		// Dozenten speichern
		$sem_dozent = $this->getSeminarDozent($sem_id);
		foreach($sem_dozent as $val)
		{
			$this->storage->addDozent("", $val["user_id"]); // Dozent
		}

		// SeminarSemTree speichern (wichtig: an semester_seminar_order denken!!!)
		$sem_tree = $this->getSeminarSemTree($sem_id);
		foreach($sem_tree as $val)
		{
			$this->storage->addSeminarSemTree("", $val["sem_tree_id"]);
		}
		// generische Datenfeld-Eintraege
		$this->storage->setGenericComplete($this->getDatafieldEntries($sem_id));

		// Speichern des aktuellen Storage-Objektes in den Storage-Vector
		$this->storage_vector->add($this->storage);
	}

	// ab hier einige Methoden zum Parsen fr die Metadaten
	function getDay($string)
	{
		$day = substr($string, 0, 2);
		switch($day)
		{
			case "Mo" :
				$_day = 1;
				break;
			case "Di" :
				$_day = 2;
				break;
			case "Mi" :
				$_day = 3;
				break;
			case "Do" :
				$_day = 4;
				break;
			case "Fr" :
				$_day = 5;
				break;
			case "Sa" :
				$_day = 6;
				break;
			case "So" :
				$_day = 7;
				break;
		}
		return $_day;
	}

	//TODO: folgende funktionen machen auch keinen sinn...
	function getStartStunde($string)
	{
		return 0;
	}

	function getEndStunde($string)
	{
		return 0;
	}

	function getStartMinute($string)
	{
		return 0;
	}

	function getEndMinute($string)
	{
		return 0;
	}

	// Ende parse-Funktionen

	function createPW()
	{
		return md5("myPW");
	}
}

?>
