<?php
/**
 * Veranstaltungsbericht.class.php
 *
 * lange Beschreibung...
 *
 * PHP version 5
 *
 * @author  	Michael Riehemann <michael.riehemann@uni-oldenburg.de>
 * @package 	IBIT_ModulVerwaltungPlugin
 * @copyright 	2009 IBIT
 * @license 	http://www.gnu.org/licenses/gpl.html GPL Licence 3
 * @version 	0.9.11
 */

require_once 'ModulVerwaltungDB.class.php';

/**
 * Enter description here...
 *
 */
class Veranstaltungsbericht
{
	private $userid;
	private $root;
	private $semester;
	private $filter;
	private $instituts;

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $userid
	 * @param unknown_type $root
	 */
	public function __construct($userid, $root=false, $semester='')
	{
		$this->userid = $userid;
		$this->root = $root;
		$this->semester = $semester;
		$this->instituts = ModulVerwaltungDB::getAdminsInstitute($this->userid);

	}

	/**
	 * Enter description here...
	 *
	 * @param boolean $check
	 * @return array() lehreinheiten
	 */
	public function getLehreinheiten($check = false)
	{
		$lehreinheiten = array();

		if($this->root)
		{
			$lehreinheiten = DBManager::get()->query("SELECT sem_tree_id, priority, name FROM `sem_tree` WHERE `type`='2' ORDER BY `name`")->fetchAll(PDO::FETCH_ASSOC);
		}
		//nur ausgewhlte Lehreinheiten anzeigen
		else
		{
			foreach ($this->instituts as $institute_id)
			{
				// Institut is Fakultt -> alle Lehreinheiten der Fakultt holen
				if(ModulVerwaltungDB::isFaculty($institute_id))
				{
					$fakid = DBManager::get()->query("SELECT sem_tree_id FROM `sem_tree` WHERE `studip_object_id`='{$institute_id}'")->fetch();
					$lehreinheiten = array_merge(DBManager::get()->query("SELECT sem_tree_id, priority, name FROM `sem_tree` WHERE `parent_id`='{$fakid}' AND `type`='2' ORDER BY `name`")->fetchAll(PDO::FETCH_ASSOC));
				}
				// nur die zugehrigen Lehreinheiten holen
				else
				{
					$lehreinheiten = array_merge($lehreinheiten, DBManager::get()->query("SELECT st.sem_tree_id, st.priority, st.name FROM `lehreinheit` AS sple LEFT JOIN `struktur_zuordnung` AS spst ON sple.lehreinheit_id = spst.objekt_id LEFT JOIN `sem_tree` AS st ON spst.sem_tree_id = st.sem_tree_id WHERE sple.institut_id='{$institute_id}' AND spst.typ = 2")->fetchAll(PDO::FETCH_ASSOC));
				}
			}

			$lehreinheiten = array_merge($lehreinheiten, DBManager::get()->query("SELECT sem_tree_id, name FROM `sem_tree` WHERE `name`='Professionalisierungsbereich'")->fetchAll(PDO::FETCH_ASSOC));
		}

		//berprfung, ob die lehreinheit weitere eintrge im semtree hat
		if($check)
		{
			foreach ($lehreinheiten as $lehreinheit)
			{
				if($this->checkTree($lehreinheit['sem_tree_id']))
				{
					$new[] = $lehreinheit;
				}
			}
			$lehreinheiten = $new;
		}

		return $lehreinheiten;
	}

	/**
	 * Enter description here...
	 *
	 * @param md5 $parent_id
	 * @return array()
	 */
	public function getEbenen($parent_id)
	{
		return DBManager::get()->query("SELECT sem_tree_id, priority, name, type FROM `sem_tree` WHERE `parent_id`='{$parent_id}' ORDER BY `priority`")->fetchAll(PDO::FETCH_ASSOC);
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $topid
	 * @param unknown_type $filter
	 * @return unknown
	 */
	public function getCompleteTree($topid, $filter, $cleanup=true)
	{
		$this->filter = $filter;
		$tree = $this->getRecursiveTree($topid);

		//leere module und so entfernen
		if($cleanup)
		{
			$tree = $this->cleanRecursiveTree($tree);
		}

		// ergebnisse filtern
		if($filter['sortbysemester'] == 'yes')
		{
			$tree = $this->sortRecusiveTreeBySemester($tree);
		}

		$complete['description'] = DBManager::get()->query("SELECT sem_tree_id, priority, name, type FROM `sem_tree` WHERE `sem_tree_id`='{$topid}' ORDER BY `priority`")->fetch(PDO::FETCH_ASSOC);
		$complete['tree'] = $tree;

		return $complete;
	}

	/**
	 * Sortiert die Module nach Fachsemester
	 *
	 * @param array() $tree
	 * @return array()
	 */
	private function sortRecusiveTreeBySemester($tree)
	{
		if(isset($tree['seminars']))
		{
			$sort = $tree;
		}
		else
		{
			foreach ($tree as $key=>$branch)
			{
				if(!empty($branch['branch']))
				{
					$sort[$key] = $branch;
					$sort[$key]['branch'] = $this->sortRecusiveTreeBySemester($branch['branch']);

				}
				elseif($branch['type'] == '5')
				{
					if(empty($branch['fachsemester']))
					{
						$fsemester['x'][] = $branch;
					}
					else
					{
						foreach($branch['fachsemester'] as $fsid)
						{
							$fsemester[$fsid['fachsem_id']][] = $branch;
						}
					}

					ksort($fsemester);
					$sort = array('fsemester' => $fsemester);
				}
				elseif(empty($branch['branch']) && !empty($branch['seminars']))
				{
					$sort[$key] = $branch;
				}
			}
		}
		return $sort;
	}

	/**
	 * Enter description here...
	 *
	 * @param md5 $topid
	 * @return array()
	 */
	private function getRecursiveTree($topid)
	{
		$tree = DBManager::get()->query("SELECT sem_tree_id, priority, name, type FROM `sem_tree` WHERE `parent_id`='{$topid}' ORDER BY priority, name")->fetchAll(PDO::FETCH_ASSOC);
		//tree hat bltter
		if(count($tree)>0)
		{
			foreach ($tree as $key=>$branch)
			{
				//noch kein blatt, also weiter verschachteln
				if($this->checkTree($branch['sem_tree_id']))
				{
					$tree[$key]['branch'] = $this->getRecursiveTree($branch['sem_tree_id']);
				}
				// es ist ein blatt, also veranstaltungen holen
				else
				{
					$tree[$key]['seminars'] = $this->getSeminars($branch['sem_tree_id']);
				}

				// es ist ein modul
				if($branch['type'] == '5')
				{
					$tree[$key]['fachsemester'] = $this->getModulFachsemester($branch['sem_tree_id']);
					$tree[$key]['kommentar'] = $this->getModulKommentar($branch['sem_tree_id']);
				}

			}
		}
		//tree ist blatt
		else
		{
			$tree['seminars'] = $this->getSeminars($topid);
		}
		return $tree;
	}

	/**
	 * Entfernt alle leeren Eintrge aus dem Baum, d.h. wenn eine Ebene keine Unterebenen
	 * hat oder keine Veranstaltungen vorhanden sind.
	 *
	 * @param array() $tree
	 * @return array()
	 */
	private function cleanRecursiveTree($tree)
	{
		//tree ist blatt
		if(isset($tree['seminars']))
		{
			$i = 0;
			//verstecke und externe veranstaltungen zhlen, wenn diese nicht angezeigt werden sollen
			foreach ($tree['seminars'] as $seminar)
			{
				if(($this->filter['hiddencourses'] != 'yes' && $seminar['visible'] != '1') || ($this->filter['externalcourses'] != 'yes' && $seminar['extern'] == 1))
				{
					$i++;
				}
			}

			$tree['count_notshowing'] = $i;
			$tree['count_seminars'] =  count($tree['seminars']);
			if($i==0 || count($tree['seminars'])>$i)
			{
				$new = $tree;
			}
		}
		//tree hat bltter
		else
		{
			foreach ($tree as $key=>$branch)
			{
				if(!empty($branch['branch']))
				{
					$subbranch = $this->cleanRecursiveTree($branch['branch']);
					if(!empty($subbranch))
					{
						$new[$key] = $branch;
						$new[$key]['branch'] = $subbranch;
					}

				}
				elseif(empty($branch['branch']) && !empty($branch['seminars']))
				{
					$i = 0;
					//verstecke und externe veranstaltungen zhlen, wenn diese nicht angezeigt werden sollen
					foreach ($branch['seminars'] as $seminar)
					{
						if(($this->filter['hiddencourses'] != 'yes' && $seminar['visible'] != '1') || ($this->filter['externalcourses'] != 'yes' && $seminar['extern'] == 1))
						{
							$i++;
						}
					}

					$branch['count_notshowing'] = $i;
					$branch['count_seminars'] =  count($branch['seminars']);
					if($i==0 || count($branch['seminars'])>$i)
					{
						$new[$key] = $branch;
					}
				}
			}
		}

		return $new;
	}

	/**
	 * berprft, ob diese sem_tree_id weitere Unterebenen hat.
	 *
	 * @param md5 $checkid
	 * @return boolean
	 */
	private function checkTree($checkid)
	{
		$count = DBManager::get()->query("SELECT count(*) FROM `sem_tree` WHERE `parent_id`='{$checkid}'")->fetchColumn();
		if($count > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $semtree_id
	 * @param unknown_type $semester
	 * @return unknown
	 */
	private function getseminars($semtree_id)
	{
		//Seminare mit Infos holen
		$courses = DBManager::get()->query("
		SELECT DISTINCT s.Seminar_id, s.VeranstaltungsNummer, s.Name, s.status, s.art,
		s.Institut_id, s.Beschreibung, s.admission_turnout, s.visible
		FROM seminar_sem_tree AS sst
		LEFT JOIN seminare AS s ON sst.seminar_id = s.Seminar_id
		LEFT JOIN semester_data sd ON s.start_time = sd.beginn
		WHERE sst.sem_tree_id = '{$semtree_id}'
		AND sd.semester_id='{$this->semester}'
		ORDER BY s.VeranstaltungsNummer ASC")->fetchAll(PDO::FETCH_ASSOC);

		foreach ($courses as $course)
		{
			//Institute holen
			#$course['extern_instituts'] = DBManager::get()->query("
			#SELECT DISTINCT institut_id FROM seminar_inst WHERE seminar_id = '{$course['Seminar_id']}'
			#")->fetchAll(PDO::FETCH_COLUMN);

			//Dozenten holen
			$course['authors'] = DBManager::get()->query("
			SELECT a.Nachname, a.Vorname
			FROM seminar_user AS su
			LEFT JOIN auth_user_md5 AS a
			ON su.user_id = a.user_id
			WHERE su.Seminar_id='{$course['Seminar_id']}' AND su.status='dozent'
			ORDER BY su.position, a.Nachname")->fetchAll(PDO::FETCH_ASSOC);

			//veranstaltungstyp hinzu
			$course['typ'] = $GLOBALS['SEM_TYPE'][$course['status']]['name'];


			if(!in_array($course['Institut_id'], $this->instituts) && !empty($this->instituts))
			{
				$course['extern'] = true;
			}

			/*$institut_id = $db->f('institut_id');
			if(in_array($institut_id, $instituts) || empty($institut_id) || empty($instituts) || $root)
			{
				$course = array(
					'seminar_id' => $db->f('Seminar_id'),
					'vnummer' => $db->f('VeranstaltungsNummer'),
					'name' => $db->f('Name'),
					'status' => $db->f('status'),
					'art' => $db->f('art'),
					'beschreibung' => $db->f('Beschreibung'),
					'max_user' => $db->f('admission_turnout'),
					'visible' => $db->f('visible'),
					'typ' => $GLOBALS['SEM_TYPE'][$db->f('status')]['name'],
					'authors' => $authors
				);
				$courses[]=$course;
			}*/
			#echo ModulVerwaltungDB::getVeranstaltungsPlaceAndTime($course['Seminar_id']).'<br><hr><br>';
			$all[]=$course;
		}
		return $all;
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $sem_tree_id
	 * @return string
	 */
	private function getModulKommentar($sem_tree_id)
	{
		return DBManager::get()->query("SELECT md.kommentar
			FROM modul_deskriptor AS md
			LEFT JOIN module AS m ON md.desk_id=m.desk_id
			LEFT JOIN mod_zuordnung AS mz ON m.modul_abst_id= mz.modul_abst_id
			WHERE mz.sem_tree_id='{$sem_tree_id}' AND m.semester='{$this->semester}'")->fetchColumn();
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $sem_tree_id
	 * @return array()
	 */
	private function getModulFachsemester($sem_tree_id)
	{
		return DBManager::get()->query("SELECT mf.fachsem_id
			FROM mod_fachsem AS mf
			LEFT JOIN module AS m ON mf.modul_kon_id=m.modul_kon_id
			LEFT JOIN mod_zuordnung AS mz ON m.modul_abst_id= mz.modul_abst_id
			WHERE mz.sem_tree_id='{$sem_tree_id}' AND m.semester='{$this->semester}'")->fetchAll(PDO::FETCH_ASSOC);
	}
}

?>