<?php
	$content_types = array(
		'css' => 'text/css',
		'js' => 'text/javascript',
	);

	$files = isset($_REQUEST['f'])
		? $_REQUEST['f']
		: $_SERVER['QUERY_STRING'];

	if (empty($files) or strpos('/', $files)!==false)
		Header('Status: 403').die('403');

	$requested_files = explode(',', $files);
	$type = isset($_REQUEST['t'])
		? $_REQUEST['t']
		: strtolower(end(explode('.', end($requested_files))));

	if (!in_array($type, array('css', 'js')))
		Header('Status: 501').die('501');

	array_walk($requested_files, create_function('&$a', '$a="assets/".basename($a, ".'.$type.'").".'.$type.'";'));

	$cached_file = $GLOBALS['TMP_PATH'].'/'.md5($type.'|'.$files).'.optimized.'.$type;
	if (!file_exists($cached_file) or filemtime($cached_file) < max(max(array_map('filemtime', $requested_files)), filemtime(__FILE__)))
	{
		$contents = implode("\n", array_filter(array_map('file_get_contents', $requested_files)));
		$before = strlen($contents);

		// Replace /*[[PATH]]*/ with current path
		$replaces = array(
			"\r\n" => "\n",
			'/*[[PATH]]*/' => $GLOBALS['ABSOLUTE_URI_STUDIP'].str_replace($GLOBALS['ABSOLUTE_PATH_STUDIP'], '', dirname(__FILE__)),
		);

		// Replace images with their correct representation
		preg_match_all('/\/\*\[\[ASSETS:IMAGE:([^\]]*)\]\]\*\//', $contents, $matches, PREG_SET_ORDER);
		foreach ($matches as $match)
			$replaces[$match[0]] = Assets::image_path($match[1]);

		$contents = str_replace(array_keys($replaces), array_values($replaces), $contents);
		$replaces = array();

		// Strip leading and trailing whitespace and empty lines, applies to both CSS and Javascript
		$contents = implode("\n", array_filter(array_map('trim', explode("\n", $contents))));

		if ($type=='css')
		{
			// Get rid of all 0px occurences, will be simpley replaced by 0
			preg_match_all('/(\s|:)0px(\s|;|})/ixs', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = $match[1].'0'.$match[2];

			// Replace certain colors by their hex representation [list extended on demand]
			$color_replacements = array('black'=>'#000', 'white'=>'#fff');
			preg_match_all('/([\s:])('.implode('|', array_keys($color_replacements)).')([\s;])/i', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = $match[1].$color_replacements[strtolower($match[2])].$match[3];

			// Remove quotes from url()-declarations
			preg_match_all('/url\(([\'"])(.*?)\\1\)/i', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = 'url('.$match[2].')';

			// Get rid of all comments
			preg_match_all('/\/\*.*?\*\//xis', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = '';

			// Remove unnecessary whitespace
			preg_match_all('/(?:\s+\{\s*|\s*[:,]\s*)/', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = trim($match[0]);
			preg_match_all('/;\s+\}/', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = ';}';

			// Shorten colors #xxyyzz to #xyz
			preg_match_all('/#([0-9a-f])\\1([0-9a-f])\\2([0-9a-f])\\3/', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = '#'.$match[1].$match[2].$match[3];

			// Remove all line breaks except after each rule
			$replaces["\n"] = '';
			$replaces['}'] = "}\n";

			// Remove last trailing semicolon in each property list
			$replaces[';}'] = '}';
		}
		elseif ($type=='js')
		{
			preg_match_all('~^//.*$~m', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]."\n"] = '';

			preg_match_all('~^/\*.*?\*/~ms', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]."\n"] = '';

			preg_match_all('/function\(([^)]*)\)\s+{/i', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = 'function('.implode(',', array_map('trim', explode(',', $match[1]))).'){';

			preg_match_all('/function\s+\(([^)]*)\){/i', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				$replaces[$match[0]] = 'function('.implode(',', array_map('trim', explode(',', $match[1]))).'){';
		}
		$contents = trim(str_replace(array_keys($replaces), array_values($replaces), $contents));
		$replaces = array();

		if ($type=='js')
		{
			preg_match_all('/\}(?:\s*[,);]*\s*\})+/', $contents, $matches, PREG_SET_ORDER);
			foreach ($matches as $match)
				if ($match[0]!=($replace=preg_replace('/\s/', '', $match[0])))
					$replaces[$match[0]] = $replace;

			uksort($replaces, create_function('$a,$b', 'return strlen($b)-strlen($a);'));
		}
		$contents = trim(str_replace(array_keys($replaces), array_values($replaces), $contents));

		file_put_contents($cached_file, $contents);
	}
	else
		$contents = file_get_contents($cached_file);
	if (isset($_SERVER['HTTP_ACCEPT_ENCODING']) and strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')!==false)
	{
		Header('Content-Encoding: gzip');
		$contents = gzencode($contents, 9);
	}
	elseif (isset($_SERVER['HTTP_ACCEPT_ENCODING']) and strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'deflate')!==false)
	{
		Header('Content-Encoding: deflate');
		$contents = gzdeflate($contents, 9);
	}
	Header('Content-Type: '.$content_types[$type].';charset=UTF-8');
	header('Cache-Control: public, max-age=315360000');
	header('Last-Modified: '.gmdate('D, d M Y H:i:s') .' GMT');
	header('Vary: Accept-Encoding');
	header('Expires: '.gmdate('D, d M Y H:i:s', strtotime('+10 years')).' GMT');
	echo $contents;
?>