<?php
function format_semester($semester, $duration)
{
	sort($semester);
	$duration = (int)$duration;

	$output = array();
	while (!empty($semester))
	{
		$part = array_slice($semester, 0, $duration);

		$initial = reset($part);
		if (implode($part)==implode(range($initial, $initial+$duration-1)))
		{
			array_push($output, $part);
			$semester = array_slice($semester, $duration);
		}
		else
		{
			array_push($output, array_slice($semester, 0, 1));
			$semester = array_slice($semester, 1);
		}
	}

	return '<ul style="margin:0;list-style-image: url(http://www.studium.uni-oldenburg.de/img/pfeil_s.gif);"><li>'.implode('. '._('Semester').'</li><li>', array_map('implode', $output, array_fill(0, count($output), '. '._('und').' '))).'. '._('Semester').'</li></ul>';
}
?>
<?php if (false && $remove_layout): ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=WINDOWS-1252"/>
	</head>
<body>
<?php endif; ?>
<?php
	$url_wrap = 40;
?>
<style type="text/css">
.bordered{border:1px solid #000}
.centered{text-align:center}
strong,h2{color:#2b4b6f}
h2{padding:3px 0 0;margin:0}
</style>

<div style="padding: 5px;">
<table cellpadding="4" class="bordered" style="width: 100%; border-collapse: collapse; font-family: Arial,Verdana,Sans-Serif; line-height: 120%; font-size: 13px; background-color: #fff;">
	<colgroup>
		<col width="50%"/>
		<col width="50%"/>
	</colgroup>
	<thead>
		<tr class="bordered" style="font-weight: bold; color: #2B4B6F;">
			<td>
			<?php if (empty($module['institut_id'])): ?>
				<?=$test=ModuleDB::GetZuordnung($module['lehreinheit_id'], 'lehreinheit')?><br/>
				<?=($test==($probe=ModuleDB::GetZuordnung($module['lehreinheit_id'], 'institut')))?'':$probe?><br/>
			<?php else: ?>
				<?=$test=ModuleHelper::GetFacultyForInstitute($module['institut_id'])?><br/>
				<?=($test==($probe=ModuleHelper::GetInstitutsName($module['institut_id'])))?'':$probe?><br/>
			<?php endif; ?>
			</td>
			<td style="text-align: left;">
			<?php if (!$preview and !$print): ?>
				<a id="print_link" style="float: right;" href="<?=$links['print']?>" target="_blank"><?=_('Drucken')?></a>
			<?php endif; ?>
				<?=ModuleHelper::GetSemesterName($module['semester'])?>
			</td>
		</tr>
	</thead>
	<tbody style="vertical-align: top;">
		<tr class="bordered">
			<td colspan="2" class="centered" style="background-color: #ddd; padding: 10px 0;">
				<h2>
					<?=empty($module['mok'])?'':$module['mok']?>
					<?=$module['modulschluessel']?>
					<?=$module['modultitel']?>
				</h2>
			<?php if (!empty($module['deskriptor']['untertitel'])): ?>
				<?=$module['deskriptor']['untertitel']?>
			<?php endif; ?>
			</td>
		</tr>
		<tr>
			<td colspan="2" class="bordered">
				<?=_('Dieses Modul wird in folgenden Studiengngen angeboten')?>:<br/>
			<?php if (empty($studiengaenge2)): ?>
				-
			<?php else: ?>
				<ul style="list-style-image: url(http://www.studium.uni-oldenburg.de/img/pfeil_s.gif);">
				<?php foreach ($studiengaenge2 as $name): ?>
					<li><?=$name?></li>
				<?php endforeach; ?>
				</ul>
			<?php endif; ?>
			</td>
		</tr>
	<?php if (!$abstract): ?>
		<tr>
			<td class="bordered">
				<strong><?=_('Bereiche')?>:</strong>
			<?php if (empty($module['bereiche'])): ?>
				<br/>-
			<?php else: ?>
				<ul style="list-style-image: url(http://www.studium.uni-oldenburg.de/img/pfeil_s.gif);">
				<?php foreach ($module['bereiche'] as $id): ?>
					<li><?=ModuleHelper::GetBereichName($id)?></li>
				<?php endforeach; ?>
				</ul>
			<?php endif; ?>
			</td>
			<td class="bordered">
				<strong><?=_('Schwerpunkte')?>:</strong>
			<?php if (empty($module['schwerpunkte'])): ?>
				<br/>-
			<?php else: ?>
				<ul style="list-style-image: url(http://www.studium.uni-oldenburg.de/img/pfeil_s.gif);">
				<?php foreach ($module['schwerpunkte'] as $id): ?>
					<li><?=ModuleHelper::GetSchwerpunktName($id)?></li>
				<?php endforeach; ?>
				</ul>
			<?php endif; ?>
			</td>
		</tr>
	<?php endif; ?>
<?php /* ?>
		<tr class="bordered">
			<td colspan="2">
				<strong><?=_('Verwendbarkeit im Kontext')?>:</strong><br/>
				<span style="color: red;">???</span>
			</td>
		</tr>
<?php */ ?>
<?php if ($print and $show_seminars): ?>
		<tr class="bordered">
			<td colspan="2">
				<?php include 'ma_viewseminars.php'; ?>
			</td>
		</tr>
<?php elseif (!$print and !empty($module['modul_kon_id'])): ?>
		<tr class="bordered">
			<td colspan="2" style="padding: 7px 0;">
				 <img id="viewseminarimage" src="http://www.uni-oldenburg.de/img/rahmen/pfeil-rechts.gif" alt="&gt;"/>
				 <a href="<?=$links['seminars']?>" class="view_module_seminar_details">
					<?=_('Veranstaltungen dieses Moduls mit Terminen und Rumen')?>
				 </a>
			</td>
		</tr>
<?php endif; ?>
		<tr>
			<td class="bordered">
				<strong><?=_('Dauer')?>:</strong>
			<?php if (empty($module['deskriptor']['dauer'])): ?>
				-
			<?php else: ?>
				<?=$module['deskriptor']['dauer']?> Semester
			<?php endif; ?>
				<br/>

				<strong><?=_('Turnus')?>:</strong>
			<?php if (empty($module['deskriptor']['turnus'])): ?>
				-
			<?php else: ?>
				<?=$module['deskriptor']['turnus']?>
			<?php endif; ?>
				<br/>

				<strong><?=_('Modulart')?>:</strong>
			<?php if (empty($module['deskriptor']['typ_id'])): ?>
				-
			<?php else: ?>
				<?=ModuleHelper::GetModulTypName($module['deskriptor']['typ_id'])?>
			<?php endif; ?>
				<br/>

				<strong><?=_('Level')?>:</strong>
			<?php if (empty($module['deskriptor']['level_id'])): ?>
				-
			<?php else: ?>
				<?=ModuleHelper::GetModulLevelName($module['deskriptor']['level_id'])?>
			<?php endif; ?>
				<br/>

				<strong><?=_('Modul sollte besucht werden im')?>:</strong>
			<?php if (empty($module['fachsemester'])): ?>
				-
			<?php else: ?>
				<?=format_semester($module['fachsemester'], $module['deskriptor']['dauer'])?>
			<?php endif; ?>
			</td>
			<td class="bordered">
				<strong><?=_('Lehr-/Lernform')?>:</strong>
			<?php if (empty($module['lehrformen'])): ?>
				-<br/>
			<?php else: ?>
				<?php $index = 0; foreach ($module['lehrformen'] as $data): ?>
					<?=$index++?', ':''?>
					<abbr title="<?=ModuleHelper::GetVeranstaltungstypName($data['veranst_typ_id'])?>"><?=ModuleHelper::GetVeranstaltungstypKuerzel($data['veranst_typ_id'])?></abbr> (<?=$data['sws']?> <?=_('SWS')?>)
				<?php endforeach; ?>
				<br/>
			<?php endif; ?>
			<?php if (!empty($module['deskriptor']['lehrform_kommentar'])): ?>
				<em><?=htmlReady($module['deskriptor']['lehrform_kommentar'])?></em>
				<br/>
			<?php endif; ?>

				<strong><?=_('Lehrsprache')?>:</strong>
			<?php if (empty($module['sprachen'])): ?>
				-
			<?php else: ?>
				<?php foreach ($module['sprachen'] as $index=>$sprach_id): ?>
					<?=$index?', ':''?><?=ModuleHelper::GetSprachName($sprach_id)?>
				<?php endforeach; ?>
			<?php endif; ?>
				<br/>

				<strong><?=_('Erreichbare Kredit-Punkte')?>:</strong>
			<?php if (empty($module['kp'])): ?>
				-
			<?php else: ?>
				<?=number_format($module['kp'], 2, ',', '.')?> <?=_('KP')?>
			<?php endif; ?>
				<br/>

				<strong><?=_('Workload')?>:</strong>
			<?php if (empty($module['kp'])): ?>
				-
			<?php else: ?>
				<?=number_format($module['kp']*30, 2, ',', '.')?> <?=_('Stunden')?>
			<?php endif; ?>
				<br/>

				<strong><?=_('Prsenzzeit')?>:</strong>
			<?php if (empty($module['deskriptor']['praesenzzeit'])): ?>
				-
			<?php else: ?>
				<?=$module['deskriptor']['praesenzzeit']?> <?=_('Stunden')?>
			<?php endif; ?>
				<br/>
			</td>
		</tr>
	<?php if ($abstract): ?>
		<tr>
			<td colspan="2" class="centered">
				<?=_('Dieses Modul wurde noch nicht vollstndig beschrieben.')?>
			</td>
		</tr>
	<?php else: ?>
		<tr>
			<td class="bordered">
				<strong><?=_('Die/der programmverantwortliche HochschullehrerIn')?>:</strong><br/>
				<?php if (empty($module['verantwortliche'][1])): ?>
					-
				<?php else: ?>
					<?php $i=0; foreach ($module['verantwortliche'][1] as $id=>$name): ?>
						<?=$i++?', ':''?>
						<?php if (empty($_REQUEST['hide_links'])): ?>
						<a href="<?=URLHelper::getLink('about.php?username='.ModuleHelper::GetUserName($id))?>" target="_top"><?=ModuleHelper::GetCompleteName($id)?></a>
						<?php else: ?>
							<?=ModuleHelper::GetCompleteName($id)?>
						<?php endif; ?>
					<?php endforeach; ?>
				<?php endif; ?>
			</td>
			<td class="bordered">
				<strong><?=_('Die/der Modulverantwortliche(n)')?>:</strong><br/>
				<?php if (empty($module['verantwortliche'][2])): ?>
					-
				<?php else: ?>
					<?php $i=0; foreach ($module['verantwortliche'][2] as $id=>$name): ?>
						<?=$i++?', ':''?>
						<?php if (empty($_REQUEST['hide_links'])): ?>
						<a href="<?=URLHelper::getLink('about.php?username='.ModuleHelper::GetUserName($id))?>" target="_top"><?=ModuleHelper::GetCompleteName($id)?></a>
						<?php else: ?>
							<?=ModuleHelper::GetCompleteName($id)?>
						<?php endif; ?>
					<?php endforeach; ?>
				<?php endif; ?>
			</td>
		</tr>
		<tr>
			<td class="bordered">
				<strong><?=_('Mitverantwortliche Person(en)')?>:</strong><br/>
				<?php if (empty($module['verantwortliche'][3])): ?>
					-
				<?php else: ?>
					<?php $i=0; foreach ($module['verantwortliche'][3] as $id=>$name): ?>
						<?=$i++?', ':''?>
						<?php if (empty($_REQUEST['hide_links'])): ?>
						<a href="<?=URLHelper::getLink('about.php?username='.ModuleHelper::GetUserName($id))?>" target="_top"><?=ModuleHelper::GetCompleteName($id)?></a>
						<?php else: ?>
							<?=ModuleHelper::GetCompleteName($id)?>
						<?php endif; ?>
					<?php endforeach; ?>
				<?php endif; ?>
			</td>
			<td class="bordered">
				<strong><?=_('Die/der Prfende(n)')?>:</strong><br/>
				<?php if (empty($module['verantwortliche'][4]) and empty($module['pruef_links'])): ?>
					-
				<?php elseif (!empty($module['verantwortliche'][4])): ?>
					<?php $i=0; foreach ($module['verantwortliche'][4] as $id=>$name): ?>
						<?=$i++?', ':''?>
						<?php if (empty($_REQUEST['hide_links'])): ?>
						<a href="<?=URLHelper::getLink('about.php?username='.ModuleHelper::GetUserName($id))?>" target="_top"><?=ModuleHelper::GetCompleteName($id)?></a>
						<?php else: ?>
							<?=ModuleHelper::GetCompleteName($id)?>
						<?php endif; ?>
					<?php endforeach; ?>
				<?php endif; ?>
				<?php if (!empty($module['pruef_links']) and $module['pruef_links']!='-1' and ($item = ModuleHelper::GetPruefungsberechtigte($module['pruef_links']))):?>
				<?php if (!empty($module['verantwortliche'][4])): ?>
					<?=_('und')?>
				<?php endif; ?>
					<a href="<?=$item['link']?>" target="_blank"><?=$item['title']?></a>
				<?php endif; ?>
			</td>
		</tr>
		<tr class="bordered">
			<td colspan="2">
				<strong><?=_('Ziele des Moduls/Kompetenzen')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;"><?=empty($module['deskriptor']['ziele'])?'-':formatReady($module['deskriptor']['ziele'])?></blockquote>
			</td>
		</tr>
		<tr class="bordered">
			<td colspan="2">
				<strong><?=_('Inhalte des Modules')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;"><?=empty($module['deskriptor']['inhalte'])?'-':formatReady($module['deskriptor']['inhalte'])?></blockquote>
			</td>
		</tr>
		<tr class="bordered">
			<td colspan="2">
				<strong><?=_('Literatur')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;"><?=empty($module['deskriptor']['literatur'])?'-':formatReady($module['deskriptor']['literatur'])?></blockquote>
			</td>
		</tr>
		<tr>
			<td class="bordered">
				<strong><?=_('Kommentar')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=empty($module['deskriptor']['kommentar'])?'-':htmlReady($module['deskriptor']['kommentar'])?>
				</blockquote>

				<strong><?=_('Internet-Link zu weiteren Informationen')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=(empty($module['deskriptor']['url']) or $module['deskriptor']['url']=='http://')?'-':sprintf('<a href="%s%s" target="_blank">%s%s</a>', preg_match('/^https?:\/\//i', trim($module['deskriptor']['url']))?'':'http://', $module['deskriptor']['url'], substr($module['deskriptor']['url'],0, $url_wrap), strlen($module['deskriptor']['url'])>$url_wrap?'&hellip;':'')?>
				</blockquote>

				<strong><?=_('Teilnahmevoraussetzungen')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=empty($module['deskriptor']['teilnahmevoraussetzungen'])?'-':htmlReady($module['deskriptor']['teilnahmevoraussetzungen'])?>
				</blockquote>
			</td>
			<td class="bordered">
				<strong><?=_('Ntzliche Vorkenntnisse')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=empty($module['deskriptor']['vorkenntnisse'])?'-':htmlReady($module['deskriptor']['vorkenntnisse'])?>
				</blockquote>

				<strong><?=_('Verknpft mit den Modulen')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=empty($module['deskriptor']['verknuepftMitModulen'])?'-':htmlReady($module['deskriptor']['verknuepftMitModulen'])?>
				</blockquote>
			</td>
		</tr>
		<tr class="bordered">
			<td colspan="2">
				<strong><?=_('Maximale TeilnehmerInnenzahl/Auswahlkriterium fr die Zulassung')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
				<?php if ($module['deskriptor']['unbeschraenkt']): ?>
					<em><?=_('unbeschrnkt')?></em>
				<?php else: ?>
					<?=empty($module['deskriptor']['zulassungsbedingungen'])?'-':htmlReady($module['deskriptor']['zulassungsbedingungen'])?>
				<?php endif; ?>
				</blockquote>

				<strong><?=_('Zu erbringende Leistungen/Prfungsform')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=empty($module['pruef_form'])?'-':htmlReady($module['pruef_form'])?>
				</blockquote>

				<strong><?=_('Prfungszeiten')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=empty($module['pruef_zeiten'])?'-':htmlReady($module['pruef_zeiten'])?>
				</blockquote>

				<strong><?=_('Anmeldeformalitten')?>:</strong><br/>
				<blockquote style="margin: 0; padding: 0 0 0 15px;">
					<?=empty($module['deskriptor']['anmeldeformalitaeten'])?'-':htmlReady($module['deskriptor']['anmeldeformalitaeten'])?>
				</blockquote>
			</td>
		</tr>
		<tr class="bordered">
			<td colspan="2">
				<em><?=_('Letzte nderung')?>:</em>
			<?php if (empty($module['letzteAenderung'])): ?>
				-
			<?php else: ?>
				<?=date('d.m.Y H:i:s', $module['letzteAenderung'])?>
			<?php endif; ?>
				<!-- Moduldeskriptor wurde angelegt von: <?=ModuleHelper::GetCompleteName($module['user_id'])?> -->
			</td>
		</tr>
	<?php endif; ?>
		<tr class="bordered">
			<td colspan="2" style=" font-size: 0.75em; background-color: #ccc;">
				<strong><?=_('Abkrzungen')?>:</strong>
				<?php $i=0; foreach (ModuleDB::GetVeranstaltungsTypen() as $type): ?>
					<?=$i++?', ':''?>
					<?=$type['kuerzel']?>: <?=$type['bezeichnung']?>
				<?php endforeach; ?>
			</td>
		</tr>
	</tbody>
</table>
</div>
<script type="text/javascript">
//<![CDATA[
<?php if (!empty($print)): ?>
window.print();
<?php else: ?>
document.observe('dom:loaded', function() {

});
<?php endif; ?>
//]]>
</script>
<?php if (false && $remove_layout): ?>
</body>
</html>
<?php endif; ?>
